program QTM;
uses
  ShareMem,
  Forms,
  Controls,
  QTM_Complex in 'QTM_Complex.pas',
  QTM_Chi2_Landscape in 'QTM_Chi2_Landscape.pas' {chi2_Landscape},
  QTM_Decl in 'QTM_Decl.pas',
  QTM_Fit in 'QTM_Fit.pas',
  QTM_Main in 'QTM_Main.pas' {M},
  QTM_MIO in 'QTM_MIO.pas',
  QTM_Multiple in 'QTM_Multiple.pas' {Multiple},
  QTM_Perturbation in 'QTM_Perturbation.pas',
  QTM_SLA in 'QTM_SLA.pas',
  QTM_DfDG_vs_actpar in 'QTM_DfDG_vs_actpar.pas' {DfDG_vs_actpar},
  QTM_Settings in 'QTM_Settings.pas' {Settings},
  QTM_Limits in 'QTM_Limits.pas' {Limits};
{$R *.RES}
{$Q+} {$R+}
type
  TFixedHintWindow = class(THintWindow)
  protected procedure CreateParams(var Params: TCreateParams); override;
end;

procedure TFixedHintWindow.CreateParams(var Params: TCreateParams);
begin inherited; Params.WndParent := 0; end;

begin
  Application.Initialize;
  HintWindowClass := TFixedHintWindow;     // added line to apply hint fix
  Application.Title := 'QTM';
  Application.CreateForm(TM, M);
  Application.Run;
end.

