unit QTM_Main;
interface
uses Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,QDialogs,StdCtrls,ExtCtrls,
     Pesgvcl,Menus,Pegrpapi,CheckLst,QTM_Decl,Spin,Math,Grids,Inifiles,Clipbrd,ComCtrls,TlHelp32,
     Dialogs,StrUtils,Registry, ShellApi;
type
  TM = class(TForm)
  SG1: TStringGrid; B_inc_clBox: TCheckListBox; StatusBar1: TStatusBar;
  OpenDialog1: TOpenDialog; SaveDialog1: TSaveDialog;
  df_Graph: PESGraph; dG_Graph: PESGraph;
  Clp_Btn: TButton; Clear_Btn: TButton;
  t10_Btn: TButton; b10_Btn: TButton; t5_Btn: TButton; b5_Btn: TButton; t2_Btn: TButton; b2_Btn: TButton; t1d5_Btn: TButton;
  b1d5_Btn: TButton; t1d1_Btn: TButton; b1d1_Btn: TButton; t1d01_Btn: TButton; b1d01_Btn: TButton; Ref_Btn: TButton; df_Graph_to_clpbd_Btn: TButton;dG_Graph_to_clpbd_Btn: TButton;
  AMF_Panel: TPanel;  Ex_Panel: TPanel; Roughness_Panel: TPanel; fac_panel: TPanel; Panel1: TPanel; Scale_Panel: TPanel; Limits_Panel: TPanel; Fit_Panel: TPanel;
  B_Liquid_Bulk_CBox: TCheckBox; B_Layer_1_CBox: TCheckBox; B_Layer_2_CBox: TCheckBox; B_Roughness_CBox: TCheckBox;
  t_e_Label: TLabel; rho_e_Label: TLabel; Jp_e_Label: TLabel; Jp_b_Label: TLabel; plp_e_Label: TLabel;
  Jpp_e_Label: TLabel; plpp_e_Label: TLabel; Jpp_b_Label: TLabel; t_e_C: TCheckBox;
  t_e_f_R: TRadioButton; t_f_f_R: TRadioButton; rho_b_f_R: TRadioButton; rho_f_f_R: TRadioButton; rho_e_f_R: TRadioButton; Jp_b_f_R: TRadioButton;
  Jp_f_f_R: TRadioButton; Jp_e_f_R: TRadioButton; Jp_exp_b_f_R: TRadioButton; Jp_exp_f_f_R: TRadioButton;
  Jp_exp_e_f_R: TRadioButton; Jpp_e_f_R: TRadioButton; Jpp_f_f_R: TRadioButton; Jpp_b_f_R: TRadioButton;
  Jpp_exp_e_f_R: TRadioButton; Jpp_exp_f_f_R: TRadioButton; Jpp_exp_b_f_R: TRadioButton;

  t_f_C: TCheckBox; rho_e_C: TCheckBox; rho_f_C: TCheckBox; rho_b_C: TCheckBox; Jp_b_C: TCheckBox; Jp_f_C: TCheckBox;
  Jp_e_C: TCheckBox; Jp_exp_e_C: TCheckBox; Jp_exp_f_C: TCheckBox; Jp_exp_b_C: TCheckBox;
  Jpp_e_C: TCheckBox; Jpp_f_C: TCheckBox; Jpp_b_C: TCheckBox; Jpp_exp_b_C: TCheckBox; Jpp_exp_f_C: TCheckBox; Jpp_exp_e_C: TCheckBox;

  t_e_Show: TEdit; t_f_Show: TEdit; rho_e_Show: TEdit; rho_f_Show: TEdit; rho_b_Show: TEdit; Jp_e_Show: TEdit; Jp_f_Show: TEdit;
  Jp_b_Show: TEdit; Jp_exp_e_Show: TEdit; Jp_exp_f_Show: TEdit; Jp_exp_b_Show: TEdit; Jpp_e_Show: TEdit; Jpp_f_Show: TEdit;
  Jpp_b_Show: TEdit; Jpp_exp_e_Show: TEdit; Jpp_exp_f_Show: TEdit; Jpp_exp_b_Show: TEdit; Jp_f_Label: TLabel; Jpp_f_Label: TLabel; m_e_Show: TEdit; m_f_Show: TEdit;

  rho_f_Label: TLabel; rho_b_Label: TLabel; plp_b_Label: TLabel; plp_f_Label: TLabel;
  plpp_f_Label: TLabel; plpp_b_Label: TLabel; t_f_Label: TLabel; Label7: TLabel;

  ch_e_ComBox: TComboBox; ch_f_ComBox: TComboBox; ch_b_ComBox: TComboBox;
  i_dfDG_DfnDD_Combox: TComboBox;
  i_xaxis_Combox: TComboBox; i_autoscale_x_Combox: TComboBox;  i_yaxis_Combox: TComboBox;

  MainMenu1: TMainMenu; About1: TMenuItem; Model1: TMenuItem;
  Fit_AMF: TMenuItem; Fit_Pe3: TMenuItem; Fit_Pe5: TMenuItem;
  File1: TMenuItem; Chi2Landscape1: TMenuItem;
  miOpenFile: TMenuItem; miSAveAs: TMenuItem;
  AnalyzeMultipleDataSets1: TMenuItem; Limits1: TMenuItem;
  N11: TMenuItem; N21: TMenuItem; N31: TMenuItem; N41: TMenuItem; N51: TMenuItem;
  N61: TMenuItem; N71: TMenuItem; N81: TMenuItem; N91: TMenuItem; N101: TMenuItem;
  vers_Show: TEdit; AspRat_Show: TEdit; vers_C: TCheckBox; AspRat_C: TCheckBox; vers_R: TRadioButton; AspRat_R: TRadioButton;
  vers_label: TLabel; AspRat_label: TLabel;
  x_axis_low_limit_Show: TEdit; x_axis_up_limit_Show: TEdit;
  Label30: TLabel; lower_Label: TLabel; upper_Label: TLabel; Limits_Label: TLabel; Label10: TLabel;
  miSave: TMenuItem; miNewFile: TMenuItem; LoadModel1: TMenuItem; DataFitsClipboard1: TMenuItem;
  FitParametersClipboard1: TMenuItem; DfdGvsactpar1: TMenuItem; Settings1: TMenuItem;
  chi_Label: TLabel; sqr_Label: TLabel; Label3: TLabel;
  i_fit_df_DG_Combox: TComboBox; i_wei_ninv_ComBox: TComboBox;
  n_fit_pars_label: TLabel; Label20: TLabel; Label28: TLabel;  Label31: TLabel; Chisqr_Label: TLabel;
  Fit_Btn: TButton; Retr_BU_Btn: TButton; FitPars2Clpbd_Btn: TButton;
    PyQTMmi: TMenuItem;
    Read_Simulation_from_QPY: TMenuItem;
    Write_to_QPYmi: TMenuItem;
    Fit1: TMenuItem;
    i_fit_method_Combox: TComboBox;

    procedure FormResize(Sender: TObject);
    procedure Read_Panel_Format;
    procedure Write_Panel_Format;
    procedure Arrange;
    procedure t10_BtnClick(Sender: TObject);   procedure t5_BtnClick(Sender: TObject);
    procedure t2_BtnClick(Sender: TObject);    procedure t1d5_BtnClick(Sender: TObject);
    procedure t1d1_BtnClick(Sender: TObject);  procedure t1d01_BtnClick(Sender: TObject);
    procedure t1d001_BtnClick(Sender: TObject); procedure b1d001_BtnClick(Sender: TObject);
    procedure b1d01_BtnClick(Sender: TObject); procedure b1d1_BtnClick(Sender: TObject);
    procedure b1d5_BtnClick(Sender: TObject);  procedure b2_BtnClick(Sender: TObject);
    procedure b5_BtnClick(Sender: TObject);    procedure b10_BtnClick(Sender: TObject);

    procedure t_e_CClick(Sender: TObject);   procedure t_f_CClick(Sender: TObject);
    procedure rho_e_CClick(Sender: TObject); procedure rho_f_CClick(Sender: TObject);
    procedure rho_b_CClick(Sender: TObject); procedure Jp_e_CClick(Sender: TObject);
    procedure Jp_f_CClick(Sender: TObject);  procedure Jp_b_CClick(Sender: TObject);
    procedure Jp_exp_e_CClick(Sender: TObject);    procedure Jp_exp_f_CClick(Sender: TObject);
    procedure Jp_exp_b_CClick(Sender: TObject); procedure Jpp_e_CClick(Sender: TObject);
    procedure Jpp_f_CClick(Sender: TObject); procedure Jpp_b_CClick(Sender: TObject);
    procedure Jpp_exp_e_CClick(Sender: TObject); procedure Jpp_exp_f_CClick(Sender: TObject);
    procedure Jpp_exp_b_CClick(Sender: TObject);
    procedure t_e_f_RClick(Sender: TObject); procedure t_f_f_RClick(Sender: TObject); procedure rho_e_f_RClick(Sender: TObject);procedure rho_f_f_RClick(Sender: TObject);
    procedure rho_b_f_RClick(Sender: TObject);  procedure Jp_e_f_RClick(Sender: TObject); procedure Jp_f_f_RClick(Sender: TObject);
    procedure Jp_b_f_RClick(Sender: TObject); procedure Jp_exp_e_f_RClick(Sender: TObject); procedure Jp_exp_f_f_RClick(Sender: TObject);
    procedure Jp_exp_b_f_RClick(Sender: TObject); procedure Jpp_e_f_RClick(Sender: TObject); procedure Jpp_f_f_RClick(Sender: TObject);
    procedure Jpp_b_f_RClick(Sender: TObject); procedure Jpp_exp_e_f_RClick(Sender: TObject); procedure Jpp_exp_f_f_RClick(Sender: TObject);
    procedure Jpp_exp_b_f_RClick(Sender: TObject);

    procedure vers_RClick(Sender: TObject); procedure AspRat_RClick(Sender: TObject);
    procedure vers_CClick(Sender: TObject);
    procedure AspRat_CClick(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Status_Read;
    procedure Update_Model;
    procedure Calc_Chisqr;
    procedure Update_Values;
    procedure Update_Values_Pars_panel;
    procedure Update_Ex_Panel;

    procedure Suggest_limits;
    procedure Set_Check_Boxes;
    procedure par_shift(fac : Double);
    procedure Display_Check_Trivial;
    procedure Update_RBtns;
    procedure Update_Model_Checks;
    procedure Uncheck_old_RBtn;
    procedure Update_All;
    procedure Update_Graphs;
    procedure Assign_Simul_XY_Data_to_Graph(Graph: PESGraph; p,ig,s : Integer; df_inpol,dG_inpol : TInpol);

    procedure Fit_BtnClick(Sender: TObject);
    procedure i_fit_df_DG_ComboxChange(Sender: TObject);

    procedure Ref_BtnClick(Sender: TObject);
    procedure Exponent_Labels;
    procedure Delay_secs(secs : Double);
    procedure Clp_BtnClick(Sender: TObject);
    procedure Accept_BtnClick(Sender: TObject);
    procedure i_dfDG_DfnDD_ComboxChange(Sender: TObject);
    procedure Clear_BtnClick(Sender: TObject);
    procedure Fit_AMFClick(Sender: TObject);
    procedure B_inc_clBoxClickCheck(Sender: TObject);
    procedure SG1KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure i_wei_ninv_ComBoxChange(Sender: TObject);
    procedure Fit_Pe3Click(Sender: TObject);
    procedure Fit_Pe5Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure AnalyzeMultipleDataSets1Click(Sender: TObject);
    procedure Chi2Landscape1Click(Sender: TObject);
    procedure miOpenFileClick(Sender: TObject);
    procedure miSAveAsClick(Sender: TObject);
    procedure Retr_BU_BtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure B_Liquid_Bulk_CBoxClick(Sender: TObject);
    procedure t_e_LabelDblClick(Sender: TObject);
    procedure t_f_LabelDblClick(Sender: TObject);
    procedure m_e_ShowDblClick(Sender: TObject);
    procedure m_f_ShowDblClick(Sender: TObject);
    procedure B_Layer_1_CBoxClick(Sender: TObject);
    procedure B_Layer_2_CBoxClick(Sender: TObject);
    procedure sqr_LabelDblClick(Sender: TObject);
    procedure SG1ContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure i_xaxis_ComboxChange(Sender: TObject);
    procedure i_yaxis_ComboxChange(Sender: TObject);
    procedure x_axis_low_limit_ShowKeyPress(Sender: TObject;  var Key: Char);
    procedure x_axis_up_limit_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure i_autoscale_x_ComboxChange(Sender: TObject);
    procedure Limits1Click(Sender: TObject);
    procedure KeyPressResponse(Sender: TObject; var Key: Char);
    procedure Set_prev_names(fn_Loc: string);
    procedure OpenPreviousFileClick(Sender: TObject);
    procedure open_file(fn_loc: string);
    procedure miSaveClick(Sender: TObject);
    function FloatFromEdit(Edit_obj: TEdit; else_value: extended = 0 ): extended;
    procedure miNewFileClick(Sender: TObject);
    procedure Align_Shows_start_from_Left;
    procedure df_Graph_to_clpbd_BtnClick(Sender: TObject);
    procedure dG_Graph_to_clpbd_BtnClick(Sender: TObject);
    procedure DataFitsClipboard1Click(Sender: TObject);
    procedure FitParametersClipboard1Click(Sender: TObject);
    procedure DfdGvsactpar1Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure Chisqr_LabelDblClick(Sender: TObject);

    procedure FitPars2Clpbd_BtnClick(Sender: TObject);
    procedure B_Roughness_CBoxClick(Sender: TObject);
    procedure Set_Roughness_to_False;
    procedure Change_VE_Pars_All(Sender: TObject);
    procedure Read_Simulation_from_QPYClick(Sender: TObject);
    procedure Read_QPY_FitPars;
    Procedure Read_QPY_Sim;
    procedure Write_to_QPYmiClick(Sender: TObject);
    procedure FitWithPython(Sender: TObject);
    Function WaitForPython(TimeOutTime: Double): boolean;
    procedure i_fit_method_ComboxChange(Sender: TObject);
    procedure Write_to_QPY;
    function ExecuteExe(aExeName: string): Boolean;
    procedure Close_Open_Chi2;

    private
      B_NoClick : Boolean;
      miPrevFilenames : array [1..nprefn] of TMenuItem;
      Prev_fn_arr : array[1..nprefn] of string;
      i_Filetype: Byte;

      procedure AssignArrays;
      Procedure ErrorHandler(Errorcode: Byte);
      Procedure GetSingleFileStrings(Files_fn: TStrings; Filefolder, Filename: string);
      procedure SetTmpFilePaths;
      Procedure CreateUnits;
      function DeleteTmpData: Boolean;
    public
      infile,outfile : text;
      ModelEdits : TEditWithnoUnitArray;
      i_ve_e_old,i_ve_f_old,i_ve_b_old,
      Sim_File_fn : string;
      i_fileage_old,i_fileage_new : integer;
      i_layer, i_ve_old, i_ve_new : integer;
      function VersionIsAtLeast(const TheFile: TMemIniFile; const MinimumVersion: string): Boolean;  Overload;
      function VersionIsAtLeast(const TheFile: TIniFile; const MinimumVersion: string): Boolean;     Overload;
      function VersionIsAtLeast(const VersionToCheck, MinimumVersion: string): Boolean;              Overload;
      function GetModelEdit(ID: integer): TEditWithnoUnit;
      function GetVersion: string;
      Procedure UpdateEdits(var Value: TPars; Edits: TEditWithnoUnitArray);
      function EditKeyPress(Sender: TObject; var Key: Char; var ToPars: TPars; Edits: TEditWithnoUnitArray): Boolean;
      function GetIDFromEdit(Edit: Tedit; EditsArr: TEditWithnoUnitArray): integer;
end;

var  M: TM;

implementation
uses QTM_SLA,QTM_Fit,QTM_Complex,QTM_MIO,QTM_Perturbation,QTM_Multiple,QTM_Chi2_Landscape,QTM_Limits,
  QTM_DfDG_vs_actpar,QTM_Settings;
{$R *.DFM}

function TM.GetModelEdit(ID: integer): TEditWithnoUnit;
var i:integer;
begin
  For i := low(ModelEdits) to high(ModelEdits) do begin
    if ID = ModelEdits[i].ID then result := ModelEdits[i];
  end;
end;

procedure TM.FormDestroy(Sender: TObject);
begin
  B_NoClick := True;
  Tmp_fn.Free;
end;

procedure TM.Chi2Landscape1Click(Sender: TObject);
begin
  if n_fit_pars = 0 then begin
    MessageDlg('Select Fit Parameters',mtinformation,[mbOK],0); Exit;
  end;
  chi2_Landscape.Show;
end;

procedure TM.DfdGvsactpar1Click(Sender: TObject); begin DfDG_vs_actpar.Show end;
procedure TM.Settings1Click(Sender: TObject); begin Settings.Show end;

procedure TM.AnalyzeMultipleDataSets1Click(Sender: TObject);
begin
  Multiple.Show;
  if Multiple.WindowState = wsMinimized	then Multiple.WindowState := wsNormal;
end;

procedure TM.Ref_BtnClick(Sender: TObject);
begin
  Ref_Pars := Pars; MIO.System_Write(j_par_Ref,QTMFile);
  Settings.Update_Values; Update_All;
end;

procedure TM.Retr_BU_BtnClick(Sender: TObject); begin Pars := BU_pars; Update_All; end;
procedure TM.Limits1Click(Sender: TObject); begin Limits.Show; end;

procedure TM.delay_secs(secs : Double);
var lStart,mseconds : longint;
begin {$R-} mseconds := Round(1000 * secs); lStart := gettickcount; repeat application.processmessages; until (gettickcount >= (lstart + mseconds))   {$R+} end;

procedure TM.SetTmpFilePaths;
begin
  Tmp_fn := TStringList.Create;   //Further Tmp Files can be added in Decl in "Filetypes" constant
  GetSingleFileStrings(tmp_fn, TmpDirectory_Str, '~tmpdata' + IntToStr(GetCurrentProcessID));
end;

Procedure TM.GetSingleFileStrings(Files_fn: TStrings; Filefolder, Filename: string);
var i: integer;
begin
  For i:= low(FileTypes) to high(FileTypes) do begin
    Files_fn.Add(Filefolder + Filename + FileTypes[i]);
  end;
end;

procedure TM.FormCreate(Sender: TObject);
var Ini_fn,FitPars_From_QPY_fn,LastFile_fn: string;
begin
  B_NoClick := True;
  DecimalSeparator := '.';
  VersionStr := GetVersion;
  TmpDirectory_Str := GetCurrentDir + '/TmpData/';
  Ini_fn := GetCurrentDir + '/QTM.ini' ;
  Ini := TIniFile.Create(Ini_fn);
  FitPars_From_QPY_fn := GetCurrentDir + '/PyQTM/~QPY_FitPars.txt';
  if fileexists(FitPars_From_QPY_fn) then begin
    FitPars_From_QPY := TiniFile.Create(FitPars_From_QPY_fn);
  end;
  QPY_fn         := ExtractFilePath(Paramstr(0)) + 'PYQTM\QPY.qpy';
  QPY_exe_fn     := ExtractFilePath(Paramstr(0)) + 'PYQTM\PYQTM.py';
  if fileexists(QPY_fn) then begin
    For_Python_File := TIniFile.Create(QPY_fn);
  end;

  if not DirectoryExists(TmpDirectory_Str) then CreateDir(TmpDirectory_Str);
  SetTmpFilePaths;
  AssignArrays;
  QTMFile := TIniFile.Create(tmp_fn[j_qtm]);
  QTMFile.WriteString('Main','Version', VersionStr);
  Ini.WriteString('Main','Version', VersionStr);
  CreateUnits;
  B_AutoLoad_Prev := Ini.ReadBool('Settings','B_Autoload_Prev', False);
  if B_AutoLoad_Prev then begin
    LastFile_fn := Ini.ReadString('Main','QTM_fn','');
    if FileExists(LastFile_fn) then begin
      open_file(LastFile_fn);
      Ini.WriteString('Main','QTM_fn',QTM_fn);
      QTMFile.WriteString('Main','QTM_fn',QTM_fn);
    end;
  end;
  Status_Read;
  B_NoClick := False;
end;

procedure TM.FormShow(Sender: TObject);
var i : integer;
begin
  B_NoClick := True;
  Align_Shows_start_from_Left;
  for i := 1 to nprefn do begin
    prev_fn_arr[i] := Ini.Readstring('Main','PreviousFilenames[' + IntToStr(i) + ']','');
    if (copy(prev_fn_arr[i],1,2) <> '\\') and FileExists(prev_fn_arr[i]) then
      miPrevFilenames[i].Enabled := True
    else miPrevFilenames[i].Enabled := False;
  end;
  Read_Panel_Format;   
  df_Graph.PEactions := sgreset; dG_Graph.PEactions := sgreset;
  chi_Label.Visible := False; sqr_Label.Visible := False; Chisqr_Label.Visible := False;
  m_e_Show.Visible := False; m_f_Show.Visible := False;
  Update_All;
  B_Changed := False; B_NoClick := False;
  Update_RBtns;
end;

Procedure TM.CreateUnits;
begin
  MIO := TMIO.Create; MIO.Set_IO_Labels_Main;
  SLA := TSLA.Create;
  Fit := TFit.Create;
  Pert := TPert.Create;
  Multiple := TMultiple.Create(Self);
  chi2_Landscape := Tchi2_Landscape.Create(Self);
  Limits := TLimits.Create(Self);
  Settings := TSettings.Create(Self);
  DfDG_vs_actpar := TDfDG_vs_actpar.Create(Self);
end;

procedure TM.AssignArrays;
begin
  setlength(ModelEdits, nEdits);
  ModelEdits[ 0].ID  := t_e_ID;      ModelEdits[ 0].Edit := t_e_Show;           ModelEdits[ 0].Describtion_Label := t_e_Label;
  ModelEdits[ 1].ID  := t_f_ID;      ModelEdits[ 1].Edit := t_f_Show;           ModelEdits[ 1].Describtion_Label := t_f_Label;
  ModelEdits[ 2].ID  := rho_e_ID;    ModelEdits[ 2].Edit := rho_e_Show;         ModelEdits[ 2].Describtion_Label := rho_e_Label;
  ModelEdits[ 3].ID  := rho_f_ID;    ModelEdits[ 3].Edit := rho_f_Show;         ModelEdits[ 3].Describtion_Label := rho_f_Label;
  ModelEdits[ 4].ID  := rho_b_ID;    ModelEdits[ 4].Edit := rho_b_Show;         ModelEdits[ 4].Describtion_Label := rho_b_Label;
  ModelEdits[ 5].ID  := Jp_e_ID;     ModelEdits[ 5].Edit := Jp_e_Show;          ModelEdits[ 5].Describtion_Label := Jp_e_Label;
  ModelEdits[ 6].ID  := Jp_f_ID;     ModelEdits[ 6].Edit := Jp_f_Show;          ModelEdits[ 6].Describtion_Label := Jp_f_Label;
  ModelEdits[ 7].ID  := Jp_b_ID;     ModelEdits[ 7].Edit := Jp_b_Show;          ModelEdits[ 7].Describtion_Label := Jp_b_Label;
  ModelEdits[ 8].ID  := Jp_exp_e_ID; ModelEdits[ 8].Edit := Jp_exp_e_Show;      ModelEdits[ 8].Describtion_Label := plp_e_Label;
  ModelEdits[ 9].ID  := Jp_exp_f_ID; ModelEdits[ 9].Edit := Jp_exp_f_Show;      ModelEdits[ 9].Describtion_Label := plp_f_Label;
  ModelEdits[10].ID  := Jp_exp_b_ID; ModelEdits[10].Edit := Jp_exp_b_Show;      ModelEdits[10].Describtion_Label := plp_b_Label;
  ModelEdits[11].ID  := Jpp_e_ID;    ModelEdits[11].Edit := Jpp_e_Show;         ModelEdits[11].Describtion_Label := Jpp_e_Label;
  ModelEdits[12].ID  := Jpp_f_ID;    ModelEdits[12].Edit := Jpp_f_Show;         ModelEdits[12].Describtion_Label := Jpp_f_Label;
  ModelEdits[13].ID  := Jpp_b_ID;    ModelEdits[13].Edit := Jpp_b_Show;         ModelEdits[13].Describtion_Label := Jpp_b_Label;
  ModelEdits[14].ID  := Jpp_exp_e_ID;ModelEdits[14].Edit := Jpp_exp_e_Show;     ModelEdits[14].Describtion_Label := plpp_e_Label;
  ModelEdits[15].ID  := Jpp_exp_f_ID;ModelEdits[15].Edit := Jpp_exp_f_Show;     ModelEdits[15].Describtion_Label := plpp_f_Label;
  ModelEdits[16].ID  := Jpp_exp_b_ID;ModelEdits[16].Edit := Jpp_exp_b_Show;     ModelEdits[16].Describtion_Label := plpp_b_Label;
  ModelEdits[17].ID  := vers_ID;     ModelEdits[17].Edit := vers_Show;              ModelEdits[17].Describtion_Label := vers_Label;
  ModelEdits[18].ID  := AspRat_ID;   ModelEdits[18].Edit := AspRat_Show;          ModelEdits[18].Describtion_Label := AspRat_Label;
end;

procedure TM.Status_Read;
var i : Integer;
begin
  miPrevFilenames[1]  := N11;  miPrevFilenames[2]  := N21;  miPrevFilenames[3] := N31;
  miPrevFilenames[4]  := N41;  miPrevFilenames[5]  := N51;  miPrevFilenames[6] := N61;
  miPrevFilenames[7]  := N71;  miPrevFilenames[8]  := N81;  miPrevFilenames[9] := N91;
  miPrevFilenames[10] := N101;

  one_c := Complex(1,0); im_c := Complex(0,1); zero_c := Complex(0.0, 0.0);
  i_fit_df_dG := QTMFile.ReadInteger('Main','i_fit_df_dG',3); QTMFile.WriteInteger('Main','i_fit_df_dG',i_fit_df_dG);
  i_wei_ninv := QTMFile.ReadInteger('Main','i_wei_ninv',2);   QTMFile.WriteInteger('Main','i_wei_ninv',i_wei_ninv);
  i_dfDG_DfnDD := QTMFile.ReadInteger('Main','i_dfDG_DfnDD',2);
  i_fit_method := Ini.ReadInteger('Main','i_fit_method',1);

  i_rbtn := QTMFile.ReadInteger('Main','i_rbtn',1); QTMFile.WriteInteger('Main','i_rbtn',i_rbtn);
  i_xaxis := QTMFile.ReadInteger('Main','i_xaxis',1);
  i_yaxis := QTMFile.ReadInteger('Main','i_yaxis',1);

  i_autoscale_x := QTMFile.ReadInteger('Main','i_autoscale_x',1);
  Err_df := QTMFile.ReadFloat('Main','err_Df',1); QTMFile.WriteFloat('Main','err_Df',err_Df);
  rho_b_default := QTMFile.ReadFloat('Main','rho_b_default',1); QTMFile.WriteFloat('Main','rho_b_default',rho_b_default);

  i_model          := QTMFile.ReadInteger('Main','i_model',1); QTMFile.WriteInteger('Main','i_model',i_model);
  x_axis_up_limit  := QTMFile.ReadFloat('Main','x_axis_up_limit',10);
  x_axis_low_limit := QTMFile.ReadFloat('Main','x_axis_low_limit',1);

  for i := 1 to nhm do begin B_fit_inc[i] := False; df[i] := GapV; dG[i] := GapV; end;

  B_Layer_1 := QTMFile.ReadBool('Main','B_Layer_1',True);
  B_Layer_2 := QTMFile.ReadBool('Main','B_Layer_2',False);
  B_liquid_bulk := QTMFile.ReadBool('Main','B_liquid_bulk',True);
  if not B_Liquid_Bulk then begin Set_Roughness_to_False; Roughness_Panel.Visible := False; end;
  B_Roughness := QTMFile.ReadBool('Main','B_Roughness',False);
  B_t_e_C := QTMFile.ReadBool('Main','B_t_e_C',True);
  B_rho_e_C := QTMFile.ReadBool('Main','B_rho_e_C',False);
  B_Jp_e_C := QTMFile.ReadBool('Main','B_Jp_e_C',True);
  B_Jpp_e_C := QTMFile.ReadBool('Main','B_Jpp_e_C',True);
  B_Jp_exp_e_C := QTMFile.ReadBool('Main','B_Jp_exp_e_C',True);
  B_Jpp_exp_e_C := QTMFile.ReadBool('Main','B_Jpp_exp_e_C',False);

  B_t_f_C := QTMFile.ReadBool('Main','B_t_f_C',False);
  B_rho_f_C := QTMFile.ReadBool('Main','B_rho_f_C',False);
  B_Jp_f_C := QTMFile.ReadBool('Main','B_Jp_f_C',False);
  B_Jpp_f_C := QTMFile.ReadBool('Main','B_Jpp_f_C',False);
  B_Jp_exp_f_C := QTMFile.ReadBool('Main','B_Jp_exp_f_C',False);
  B_Jpp_exp_f_C := QTMFile.ReadBool('Main','B_Jpp_exp_f_C',False);

  B_rho_b_C := QTMFile.ReadBool('Main','B_rho_b_C',False);
  B_Jp_b_C := QTMFile.ReadBool('Main','B_Jp_b_C',False);
  B_Jpp_b_C := QTMFile.ReadBool('Main','B_Jpp_b_C',False);
  B_Jp_exp_b_C := QTMFile.ReadBool('Main','B_Jp_exp_b_C',False);
  B_Jpp_exp_b_C := QTMFile.ReadBool('Main','B_Jpp_exp_b_C',False);

  B_vers_C := QTMFile.ReadBool('Main','B_vers_C',False);
  B_AspRat_C := QTMFile.ReadBool('Main','B_AspRat_C',False);

  for i := 1 to 1 do B_fit_inc[i] := QTMFile.ReadBool('Main','B_fit_inc' + inttostr(i),False);
  for i := 2 to 6 do B_fit_inc[i] := QTMFile.ReadBool('Main','B_fit_inc' + inttostr(i),True);
  for i := 7 to 10 do B_fit_inc[i] := QTMFile.ReadBool('Main','B_fit_inc' + inttostr(i),False);
  for i := 1 to nhm do QTMFile.WriteBool('Main','B_fit_inc' + inttostr(i),B_fit_inc[i]);
  for i := 1 to 4 do begin MIO.System_Read(i,QTMFile); MIO.System_Write(i,QTMFile); end;

  MIO.Set_IO_Labels_Main;
  for i := 1 to nhm do begin
    df[i] := QTMFile.ReadFloat('Main','Df' + inttostr(i),0);
    dG[i] := QTMFile.ReadFloat('Main','DG' + inttostr(i),0);
    n_arr[i] := QTMFile.ReadFloat('Main','n_arr[' + InttoStr(i)+ ']',2*i-1);
  end;
  for i := 1 to nhm do begin
    QTMFile.WriteFloat('Main','Df' + inttostr(i),df[i]);
    QTMFile.WriteFloat('Main','DG' + inttostr(i),dG[i]);
    QTMFile.WriteFloat('Main','n_arr[' + InttoStr(i)+ ']',n_arr[i]);
  end;
  MIO.Set_IO_Labels_Main;
  Limits.Defaults1Click(Self);
end;

procedure TM.Update_Values;
var i,iprfn : Integer;
begin
  Caption := 'QTM ' + Copy(VersionStr,0,5) + ' ';
  if (QTM_fn = '')
    then Caption := Caption + tmp_fn[j_qtm]
    else Caption := Caption + qtm_fn;
  if length(Caption) > 100 then  begin
    if (QTM_fn = '')
      then Caption := 'QTM ' + Copy(VersionStr,0,5) + ' ' + ExtractFilename(tmp_fn[j_qtm])
      else Caption := 'QTM ' + Copy(VersionStr,0,5) + ' ' + ExtractFilename(qtm_fn);
  end;
  if (QTM_fn = '') then Application.Title := 'QTM' else Application.Title := ExtractFileName(Qtm_fn);
  i_autoScale_x_Combox.ItemIndex := i_autoScale_x - 1;
  Limits_Panel.Visible := i_autoScale_x = 2;
//  i_fit_method_Combox.Visible := B_Development;
//  PyQTMmi.Visible := B_Development;
//  i_fit_method_Combox.Visible := True;
//  PyQTMmi.Visible := True;

  vers_label.Caption := 'vertical scale [nm]';
  AspRat_label.Caption := 'aspect ratio';
  case Pars.i_ve_e of
    1 : begin
      Jp_e_label.Caption := 'J'' [MPa^-1]';
      Jpp_e_label.Caption := 'J'''' [MPa^-1]';
    end;
    2 : begin
      Jp_e_label.Caption := 'G'' [MPa]';
      Jpp_e_label.Caption := 'G'''' [MPa]';
    end;
    3 : begin
      Jp_e_label.Caption := 'eta'' [mPa s]';
      Jpp_e_label.Caption := 'eta'''' [mPa s]';
    end;
    4 : begin
      Jp_e_label.Caption := 'G'' [MPa]';
      Jpp_e_label.Caption := 'eta'' [mPa s]';
    end;
    5 : begin
      Jp_e_label.Caption := '|J| [MPa^1]';
      Jpp_e_label.Caption := 'tan del';
    end;
    6 : begin
      Jp_e_label.Caption := '|G| [MPa]';
      Jpp_e_label.Caption := 'tan del';
    end;
    7 : begin
      Jp_e_label.Caption := '|eta| [mPa s]';
      Jpp_e_label.Caption := '(tan del)^-1';
    end;
  end;

  case pars.i_ve_f of
    1 : begin
      Jp_f_label.Caption := 'J'' [MPa^-1]';
      Jpp_f_label.Caption := 'J'''' [MPa^-1]';
    end;
    2 : begin
      Jp_f_label.Caption := 'G'' [MPa]';
      Jpp_f_label.Caption := 'G'''' [MPa]';
    end;
    3 : begin
      Jp_f_label.Caption := 'eta'' [mPa s]';
      Jpp_f_label.Caption := 'eta'''' [mPa s]';
    end;
    4 : begin
      Jp_f_label.Caption := 'G'' [MPa]';
      Jpp_f_label.Caption := 'eta'' [mPa s]';
    end;
    5 : begin
      Jp_f_label.Caption := '|J| [MPa^1]';
      Jpp_f_label.Caption := 'tan del';
    end;
    6 : begin
      Jp_f_label.Caption := '|G| [MPa]';
      Jpp_f_label.Caption := 'tan del';
    end;
    7 : begin
      Jp_f_label.Caption := '|eta| [mPa s]';
      Jpp_f_label.Caption := '(tan del)^-1';
    end;
  end;

case pars.i_ve_b of
    1 : begin
      Jp_b_label.Caption := 'J'' [MPa^-1]';
      Jpp_b_label.Caption := 'J'''' [MPa^-1]';
    end;
    2 : begin
      Jp_b_label.Caption := 'G'' [MPa]';
      Jpp_b_label.Caption := 'G'''' [MPa]';
    end;
    3 : begin
      Jp_b_label.Caption := 'eta'' [mPa s]';
      Jpp_b_label.Caption := 'eta'''' [mPa s]';
    end;
    4 : begin
      Jp_b_label.Caption := 'G'' [MPa]';
      Jpp_b_label.Caption := 'eta'' [mPa s]';
    end;
    5 : begin
      Jp_b_label.Caption := '|J| [MPa^1]';
      Jpp_b_label.Caption := 'tan del';
    end;
    6 : begin
      Jp_b_label.Caption := '|G| [MPa]';
      Jpp_b_label.Caption := 'tan del';
    end;
    7 : begin
      Jp_b_label.Caption := '|eta| [mPa s]';
      Jpp_b_label.Caption := '(tan del)^-1';
    end;
  end;

  vers_Show.Text := FloatToStrF(Pars.vers,fffixed,8,3);
  AspRat_Show.Text := FloatToStrF(Pars.AspRat,fffixed,8,3);
  vers_label.Visible := B_Roughness;
  AspRat_label.Visible := B_Roughness;
  vers_Show.Visible := B_Roughness;
  AspRat_label.Visible := B_Roughness;
  vers_R.Visible := B_Roughness;
  vers_C.Visible := B_Roughness;
  AspRat_R.Visible := B_Roughness;
  AspRat_C.Visible := B_Roughness;

  if x_axis_low_limit < 1 then begin
    x_axis_low_limit := 1; QTMFile.WriteFloat('Main','x_axis_low_limit',x_axis_low_limit);
    B_Changed := True;
  end;
  i_fit_df_DG_Combox.ItemIndex := i_fit_df_DG - 1;
  i_dfDG_DfnDD_Combox.ItemIndex := i_dfDG_DfnDD - 1;
  i_wei_ninv_Combox.ItemIndex := i_wei_ninv - 1;
  i_fit_method_Combox.ItemIndex := i_fit_method - 1;
  i_xaxis_ComBox.ItemIndex := i_xaxis - 1;
  x_axis_up_limit_Show.Text := FloatToStrF(x_axis_up_limit,fffixed,8,3);
  x_axis_low_limit_Show.Text := FloatToStrF(x_axis_low_limit,fffixed,8,3);

  i_yaxis_ComBox.ItemIndex := i_yaxis - 1;

  MIO.Determine_Fit_Pars;
  n_fit_pars_Label.Caption := IntToStr(n_fit_pars) + ' Fit Parameters';

  B_inc_clBox.Clear; for i := 1 to nhm do B_inc_clBox.Items.Add('');
  for i := 1 to nhm do B_inc_clBox.Checked[i-1] := B_Fit_inc[i]; B_inc_clBox.Update;
  with StatusBar1 do begin
    Panels[0].Width := 145;
    Panels[0].Text := 'Fundamental : ' + FloattoStrF(f_fund/1e6,fffixed,8,3) + ' MHz';
    Panels[1].Width := 170;
    Panels[1].Text := 'Ref. Freq. VE Pars : ' + FloattoStrF(f_Jref/1e6,fffixed,8,3) + ' MHz';
    Panels[2].Width := 155;
    Panels[2].Text := 'Zq [10^6 kg/(m^2 s)]: ' + FloattoStrF(Zq/1e6,fffixed,8,2);
    Panels[3].Width := 155;
    case i_model of
      j_model_AMF : Panels[3].Text := 'AMF';
      j_model_PE3 : Panels[3].Text := '3rd Order Pert.';
      j_model_PE5 : Panels[3].Text := '5th Order Pert.';
    end;
    Panels[4].Width := 322;
    Panels[4].Text := 'Ref: t_1 : ' + FloatToStrF(Ref_Pars.t_e,fffixed,8,1) +
                          ' t_2 : ' + FloatToStrF(Ref_Pars.t_f,fffixed,8,3) +
                          ' rho_b : ' + FloatToStrF(Ref_Pars.rho_b,fffixed,8,1);
  end;
  for iprfn := 1 to nprefn do begin
    miPrevFilenames[iprfn].Caption := IntToStr(iprfn) + ' : ' + prev_fn_arr[iprfn];
    miPrevFilenames[iprfn].Visible := prev_fn_arr[iprfn] <> '';
{ ...and disable if file is a remote file - then don't even try to check its existence,
  or if it is local, but does not exist anymore, e.g. because it is moved or renamed   }
    if ((prev_fn_arr[iprfn] <> '') and (copy(prev_fn_arr[iprfn],1,2) <> '\\')) and (FileExists(prev_fn_arr[iprfn])) then miPrevFilenames[iprfn].Enabled := True
    else miPrevFilenames[iprfn].Enabled := False;
  end;

  Update_Ex_Panel;
  Update_RBtns;
  Display_Check_Trivial;
  Update_Model_Checks;
  Update_Values_Pars_panel;
  Arrange;
  Limits.Set_Colors_all;
end;

procedure TM.Update_Model_Checks;
begin
  Fit_AMF.Checked := False;
  Fit_Pe3.Checked := False;
  Fit_Pe5.Checked := False;
  case i_model of
    j_model_AMF : Fit_AMF.Checked := True;
    j_model_PE3 : Fit_Pe3.Checked := True;
    j_model_PE5 : Fit_Pe5.Checked := True;
  end;
end;

procedure TM.Fit_AMFClick(Sender: TObject);
begin i_model := j_model_AMF; QTMFile.WriteInteger('Main','i_model',i_model); Update_All; end;

procedure TM.Fit_Pe3Click(Sender: TObject);
begin i_model := j_model_Pe3; QTMFile.WriteInteger('Main','i_model',i_model); Update_All; end;

procedure TM.Fit_Pe5Click(Sender: TObject);
begin i_model := j_model_Pe5; QTMFile.WriteInteger('Main','i_model',i_model); Update_All; end;

procedure set_Rough_to_false;
begin
  B_vers_C := False;
  B_AspRat_C := False;
  QTMFile.WriteBool('Main','B_vers_C',B_vers_C);
  QTMFile.WriteBool('Main','B_AspRat_C',B_AspRat_C);
  B_Changed := True;
end;

procedure TM.Fit_BtnClick(Sender: TObject);
var Errorcode: Byte;
begin
  try
    Errorcode := 0;
    M.Fit_Btn.Enabled := false;
    Multiple.Fit_Btn.Enabled := false;
    BU_Pars := Pars;
    MIO.Determine_Fit_Pars;
    case i_fit_method of
      1 : Fit.Simplex(Errorcode);
      2 : FitWithPython(Self);
    end;
    ErrorHandler(Errorcode);
    if B_fit_failed or not(Errorcode = 0) then Exit;
    if (Sender <> Multiple) or (Multiple.B_Update_Main) then begin
      Update_All;
      If Multiple.Showing and not Multiple.B_Fit_is_running then Multiple.UpdateFitPars;
      MIO.System_Write(j_par_Sample,QTMFile);
    end;
  finally
    M.Fit_Btn.Enabled := true;
    Multiple.Fit_Btn.Enabled := true;
  end;
end;

procedure TM.Exponent_Labels;
begin
  plp_e_Label.Caption := 'PLExp.Re'; plpp_e_Label.Caption := 'PLExp.Im';
  plp_f_Label.Caption := 'PLExp.Re'; plpp_f_Label.Caption := 'PLExp.Im';
  plp_b_Label.Caption := 'PLExp.Re'; plpp_b_Label.Caption := 'PLExp.Im';
end;

procedure TM.Assign_Simul_XY_Data_to_Graph(Graph: PESGraph; p,ig,s : Integer; df_inpol,dG_inpol : TInpol);
begin
  with graph do begin
    case i_xaxis of
      1 : XData[s-1,p-1] := Nn_inpol[p];
      2 : XData[s-1,p-1] := sqr(Nn_inpol[p]);
      3 : XData[s-1,p-1] := sqrt(Nn_inpol[p]);
      4 : XData[s-1,p-1] := 1/Nn_inpol[p];
      5 : XData[s-1,p-1] := -df_inpol[p];
      6 : XData[s-1,p-1] := -df_inpol[p]/Nn_inpol[p];
      7 : XData[s-1,p-1] := log10(Nn_inpol[p]);
    end;
    case ig of
      1,3 : begin
        case i_yaxis of
          1 : YData[s-1,p-1] := df_inpol[p];
          2,5,6,7 : YData[s-1,p-1] := df_inpol[p]/Nn_inpol[p];
          3   : YData[s-1,p-1] := df_inpol[p]/sqrt(Nn_inpol[p]);
          4   : YData[s-1,p-1] := df_inpol[p]*Nn_inpol[p];
        end;
      end;
      2,4 : begin
        case i_yaxis of
          1 : YData[s-1,p-1] := dG_inpol[p];
          2 : YData[s-1,p-1] := dG_inpol[p] / Nn_inpol[p];
          3 : YData[s-1,p-1] := dG_inpol[p] / sqrt(Nn_inpol[p]);
          4 : YData[s-1,p-1] := dG_inpol[p] * Nn_inpol[p];
          5 : if df_inpol[p] <>0 then YData[s-1,p-1] := -dG_inpol[p] / df_inpol[p] else YData[s-1,p-1] := GapV;
          6 : YData[s-1,p-1] := 1e6 * 2 * dG_inpol[p] / (f_fund * Nn_inpol[p]);
          7 : if df_inpol[p] <>0 then YData[s-1,p-1] := log10(-dG_inpol[p] / df_inpol[p]/Nn_inpol[p]) else YData[s-1,p-1] := GapV;
        end;
      end;
    end;
    if B_fit_failed or B_no_model then YData[s-1,p-1] := GapV;
  end;
end;

procedure TM.Update_All;
begin
  MIO.Avoid_Zeros(j_par_Sample);
  MIO.Avoid_Zeros(j_par_Ref);
  Arrange;
  Update_Values;
  Suggest_Limits;
  Update_Model;    //only called here
  Update_Graphs;
  if Multiple.Showing and not Multiple.B_Fit_is_running then begin
    Multiple.Update_Values;
    Multiple.Update_Freq_Graphs;
    Multiple.Update_FitPars_Graph;
    Multiple.UpdateFitPars;
  end;
end;

procedure TM.Update_Graphs;
var s,p,ig,i_show : Integer;
    graph : PESGraph;
    Maintitlestr, Subtitlestr : String;
    p_poi_arr : array[1..nhm] of Integer;
begin
  for ig := 1 to 4 do begin
    case ig of
      1 : graph := df_Graph;
      2 : graph := dG_Graph;
      3 : graph := Multiple.DF_from_Main;
      4 : graph := Multiple.DG_From_Main;
    end;
    with graph do begin
      PEactions := sgreset; CursorPromptTracking := True; CursorPromptStyle := sgXandYValue;
      AllowZooming := sgHorzPlusVertZooming; FontSize := sgLarge; ShadowColor := clNone;
      DataShadows := sgNo3D; GridLineControl := sgNoGrid; NullDataValueX := GapV; NullDataValueY := GapV;
      MainTitleFont := 'Arial'; SubTitleFont := 'Arial';
      Maintitlestr := Sample_String;
      Subtitlestr := Info_String;
      if B_IncludeFilename then SubtitleStr := SubtitleStr + QTM_fn;
      if B_fit_failed then SubtitleStr := 'fit failed';
      MainTitle := Copy(MainTitleStr,1,90); SubTitle := Copy(SubTitleStr,1,90);
      Points := n_inpol;
      i_show := 0;
      if B_Show_Exp then inc(i_show);
      if B_Show_RoughC and B_Roughness then inc(i_show);
      case i_model of
        j_model_AMF : inc(i_show);
        j_model_PE3,j_model_PE5 : begin
          if B_Perturbation_Show_All then begin inc(i_show); inc(i_show); inc(i_show); end
          else inc(i_show);
        end;  
      end;
      Subsets := i_show;
      i_show := 0;
      if B_Show_Exp then begin inc(i_show); SubsetLabels[i_show-1] := 'Experiment'; SubsetColors[i_show-1] := clBlack; end;
      case i_model of
        j_model_AMF : begin
          inc(i_show); SubsetLabels[i_show-1] := 'AMF'; SubsetColors[i_show-1] := clRed;
        end;
        j_model_Pe3,j_model_Pe5 : begin
          if B_Perturbation_Show_All then begin
            inc(i_show); SubsetLabels[i_show-1] := 'AMF'; SubsetColors[i_show-1] := clred;
            inc(i_show); SubsetLabels[i_show-1] := '3rd-prder Perturbation'; SubsetColors[i_show-1] := clLime;
            inc(i_show); SubsetLabels[i_show-1] := '5th-prder Perturbation'; SubsetColors[i_show-1] := clPurple;
          end else begin
            case i_model of
              j_model_Pe3 : begin
                inc(i_show); SubsetLabels[i_show-1] := '3rd-prder Perturbation'; SubsetColors[i_show-1] := clLime;
              end;
              j_model_Pe5 : begin
                inc(i_show); SubsetLabels[i_show-1] := '5th-prder Perturbation'; SubsetColors[i_show-1] := clLime;
              end;
            end;
          end;
        end;
      end;
      if B_Show_RoughC and B_Roughness then begin
        inc(i_show);
        SubsetLabels[i_show-1]:= 'Roughness';
        SubsetColors[i_show-1] := clFuchsia;
      end;
      if B_Show_Exp then ComparisonSubsets := Subsets - 1 else ComparisonSubsets := Subsets;
      PlottingMethod := sgpoint; PlottingMethodII := sgline2; PointSize := sgLargePoints;
      for s := 1 to Subsets do begin SubsetLineTypes[s-1] := PELT_ThinSOLID; SubsetPointTypes[s-1] := PEPT_dot; end;
      case i_xaxis of
        1 : XaxisLabel := 'Overtone Order n';
        2 : XaxisLabel := 'n^2';
        3 : XaxisLabel := 'n^1/2';
        4 : XaxisLabel := '1/n';
        5 : XaxisLabel := '-Df';
        6 : XaxisLabel := '-Df/n';
        7 : XaxisLabel := 'Log10(n)';
      end;
      case ig of
        1,3 : begin
          case i_yaxis of
            1 : YaxisLabel := 'Df [Hz]';
            2,5,6,7 : YaxisLabel := 'Df/n [Hz]';
            3 : YaxisLabel := 'Df/sqrt(n) [Hz]';
            4 : YaxisLabel := 'Df*n [Hz]';
          end;
        end;
        2,4 : begin
          case i_yaxis of
            1 : YaxisLabel := 'DG [Hz]';
            2 : YaxisLabel := 'DG/n [Hz]';
            3 : YaxisLabel := 'DG/sqrt(n) [Hz]';
            4 : YaxisLabel := 'DG*n [Hz]';
            5 : YaxisLabel := 'DG/(-Df)';
            6 : YaxisLabel := 'DDissfac [10^-6]';
            7 : YaxisLabel := 'log10(DG/(-Df)/n)';
          end;
        end;
      end;
      nhar_fit := 0;
      for p := 1 to nhm do begin
        if B_fit_inc[p] then begin
          inc(nhar_fit);
          p_poi_arr[nhar_fit] := p;
        end;
      end;
      i_show := 0;
      if B_Show_Exp then begin
        inc(i_show);
        for p := 1 to nhar_fit do begin
          case i_xaxis of
            1 : XData[0,p-1] := n_arr[p_poi_arr[p]];
            2 : XData[0,p-1] := sqr(n_arr[p_poi_arr[p]]);
            3 : XData[0,p-1] := sqrt(n_arr[p_poi_arr[p]]);
            4 : XData[0,p-1] := 1/n_arr[p_poi_arr[p]];
            5 : XData[0,p-1] := -df[p_poi_arr[p]];
            6 : XData[0,p-1] := -df[p_poi_arr[p]]/n_arr[p_poi_arr[p]];
            7 : XData[0,p-1] := log10(n_arr[p_poi_arr[p]]);
          end;
          case ig of
            1,3 : begin
              case i_yaxis of
                1 : YData[0,p-1] := df[p_poi_arr[p]]                  ;
                2,5,6,7 : YData[0,p-1] := df[p_poi_arr[p]] / n_arr[p_poi_arr[p]]       ;
                3   : YData[0,p-1] := df[p_poi_arr[p]] / sqrt(n_arr[p_poi_arr[p]]) ;
                4   : YData[0,p-1] := df[p_poi_arr[p]] * n_arr[p_poi_arr[p]]       ;
              end;
              if df[p_poi_arr[p]] = GapV then YData[0,p-1] := GapV;
            end;
            2,4 : begin
              case i_yaxis of
                1 : YData[0,p-1] := dG[p_poi_arr[p]]                  ;
                2 : YData[0,p-1] := dG[p_poi_arr[p]] / n_arr[p_poi_arr[p]]       ;
                3 : YData[0,p-1] := dG[p_poi_arr[p]] / sqrt(n_arr[p_poi_arr[p]]) ;
                4 : YData[0,p-1] := dG[p_poi_arr[p]] * n_arr[p_poi_arr[p]]       ;
                5 : if (df[p_poi_arr[p]] <> 0) then YData[0,p-1] := -dG[p_poi_arr[p]]/df[p_poi_arr[p]] else YData[0,p-1] := GapV;
                6 : YData[0,p-1] := 1e6 * 2 * dG[p_poi_arr[p]] / (f_fund * n_arr[p_poi_arr[p]]) ;
                7 : if (df[p_poi_arr[p]] <> 0) then YData[0,p-1] := log10(-dG[p_poi_arr[p]]/df[p_poi_arr[p]]/n_arr[p_poi_arr[p]]) else YData[0,p-1] := GapV;
              end;
              if dG[p_poi_arr[p]] = GapV then YData[0,p-1] := GapV;
            end;
          end;
        end;
        for p := nhar_fit + 1 to Points do XData[0,p-1] := GapV;
        if B_no_model then begin
           for p := 1 to Points do XData[0,p-1] := GapV;
        end;
      end;
      inc(i_show);
      for p := 1 to n_inpol do begin
        case i_model of
          j_model_AMF : Assign_Simul_XY_Data_to_Graph(graph, p,ig,i_show,df_SLA,dG_SLA);
          j_model_Pe3,j_model_Pe5 : begin
            if B_Perturbation_Show_All then begin
              Assign_Simul_XY_Data_to_Graph(graph, p,ig,i_show,df_SLA,dG_SLA);
              Assign_Simul_XY_Data_to_Graph(graph, p,ig,i_show+1,df_Pe3,dG_Pe3);
              Assign_Simul_XY_Data_to_Graph(graph, p,ig,i_show+2,df_Pe5,dG_Pe5);
            end else begin
              case i_model of
                j_model_Pe3 : Assign_Simul_XY_Data_to_Graph(graph, p,ig,i_show,df_Pe3,dG_Pe3);
                j_model_Pe5 : Assign_Simul_XY_Data_to_Graph(graph, p,ig,i_show,df_Pe5,dG_Pe5);
              end;
            end;
          end;
        end;
      end;
      if B_Show_RoughC and B_Roughness then begin
        inc(i_show);
        for p := 1 to n_inpol do Assign_Simul_XY_Data_to_Graph(graph, p,ig,i_show,df_Rou,dG_Rou);
      end;
      PEactions := sgReInitAndReset;
    end; //with
  end; //ig
end;

procedure TM.Update_Model;
var i : integer;
    Errorcode: Byte;
    test,dummy : Double;
{ErrorCode indices:  1: B_SLA_failed
                    2: B_kd_failed
                    4: B_Complex_failed
                    8: B_Fit_Failed
                    16: Floating Point Overflow}
begin
  Errorcode := 0;
  n_inpol := 0;
  test := x_axis_low_limit;
  while (test <= x_axis_up_limit + 1e-9) and (n_inpol < n_inpol_max) do begin
    n_inpol := n_inpol + 1;
    x_inpol[n_inpol] := test;
    Nn_inpol[n_inpol] := test;
    test := test + 0.1;
  end;
  for i := 1 to n_inpol do begin
    if not(Errorcode = 0) then Exit;
    n_r := x_inpol[i];
    case i_model of
      j_model_AMF : SLA.dfstar_from_Z(df_SLA[i],dG_SLA[i],df_Rou[i],dG_Rou[i],Errorcode);
      j_model_PE3,j_model_PE5 : begin
        Pert.dfstar_Pe3(df_Pe3[i],dG_Pe3[i],df_Rou[i],dG_Rou[i],Errorcode);
        Pert.dfstar_Pe5(df_Pe5[i],dG_Pe5[i],df_Rou[i],dG_Rou[i],Errorcode);
        SLA.dfstar_from_Z(df_SLA[i],dG_SLA[i],df_Rou[i],dG_Rou[i],Errorcode);
      end;
    end;
  end;

  for i := 1 to nhm do begin
    if not(Errorcode = 0) then begin
      ErrorHandler(Errorcode);
      Exit;
    end;
    n_r := n_arr[i];
    case i_model of
      j_model_AMF : SLA.dfstar_from_Z(df_fit[i],dG_fit[i],dummy,dummy,Errorcode);
      j_model_PE3 : Pert.dfstar_Pe3(df_fit[i],dG_fit[i],dummy,dummy,Errorcode);
      j_model_PE5 : Pert.dfstar_Pe5(df_fit[i],dG_fit[i],dummy,dummy,Errorcode);
    end;
  end;
  ErrorHandler(Errorcode);
  Calc_Chisqr;
end;

procedure TM.Calc_Chisqr;
var i,n_dat : integer;
begin
  n_dat := 0; chisqr := 0;
  for i := 1 to nhm do begin
    n_r := n_arr[i];
    if B_fit_inc[i] then begin
      case i_fit_df_DG of
        1 : begin
          case i_wei_ninv of
            1 :                 chisqr := chisqr +  sqr(df[i] - df_fit[i]);
            2 : if n_r > 0 then chisqr := chisqr + (sqr(df[i] - df_fit[i])) / n_r
                else            chisqr := chisqr + (sqr(df[i] - df_fit[i]));
            3 : if n_r > 0 then chisqr := chisqr + (sqr(df[i] - df_fit[i])) / sqr(n_r)
                else            chisqr := chisqr + (sqr(df[i] - df_fit[i]));
          end;
          n_dat := n_dat + 1;
        end;
        2 : begin
          case i_wei_ninv of
            1 :                 chisqr := chisqr +  sqr(dG[i] - dG_fit[i]);
            2 : if n_r > 0 then chisqr := chisqr + (sqr(dG[i] - dG_fit[i])) / n_r
                else            chisqr := chisqr +  sqr(dG[i] - dG_fit[i]) ;
            3 : if n_r > 0 then chisqr := chisqr + (sqr(dG[i] - dG_fit[i])) / sqr(n_r)
                else            chisqr := chisqr +  sqr(dG[i] - dG_fit[i]) ;
          end;
          n_dat := n_dat + 1;
        end;
        3 : begin
          case i_wei_ninv of
            1 :                 chisqr := chisqr +  sqr(df[i] - df_fit[i]) + sqr(dG[i] - dG_fit[i]);
            2 : if n_r > 0 then chisqr := chisqr + (sqr(df[i] - df_fit[i]) + sqr(dG[i] - dG_fit[i])) / n_r
                else            chisqr := chisqr +  sqr(df[i] - df_fit[i]) + sqr(dG[i] - dG_fit[i]);
            3 : if n_r > 0 then chisqr := chisqr + (sqr(df[i] - df_fit[i]) + sqr(dG[i] - dG_fit[i])) / sqr(n_r)
                else            chisqr := chisqr +  sqr(df[i] - df_fit[i]) + sqr(dG[i] - dG_fit[i]);
          end;
          n_dat := n_dat + 2;
        end;
      end;
    end;
  end;
  if err_df > 0 then chisqr := chisqr / sqr(err_df);
  if n_dat - n_fit_pars > 0 then chisqr := chisqr / (n_dat - n_fit_pars);
  chi_Label.Visible := True;
  sqr_Label.Visible := True;
  Chisqr_Label.Visible := True;
  chisqr_Label.Caption := FloatToStrF(chisqr,ffgeneral,5,3);
end;

procedure TM.Update_Ex_Panel;
var i,j,status : integer;
    test : Double;
begin
  with SG1 do begin
    ColWidths[0] := 45; ColCount := 3;
    Width := ColWidths[0] + ColWidths[1] + ColWidths[2] + 8;
    Ex_Panel.Width := left + width + 3;

    case i_dfDG_DfnDD of
      1 : begin
        Cells[1,0] := 'Df [Hz]';
        Cells[2,0] := 'DG [Hz]';
        for i := 1 to nhm do begin
          if df[i] <> GapV then Cells[1,i] := FloatToStrF(df[i],fffixed,8,2) else Cells[1,i] := '';
          if dG[i] <> GapV then Cells[2,i] := FloatToStrF(dG[i],fffixed,8,2) else Cells[2,i] := '';;
        end;
      end;
      2 : begin
        Cells[1,0] := 'Df/n [Hz]';
        Cells[2,0] := 'DD [10^-6]';
        for i := 1 to nhm do begin
          if df[i] <> GapV then Cells[1,i] := FloatToStrF(df[i] / (2*i-1),fffixed,8,2)  else Cells[1,i] := '';
          if dG[i] <> GapV then Cells[2,i] := FloatToStrF(dG[i] * 2 /((2*i-1)*5e6) * 1e6,fffixed,8,2)  else Cells[2,i] := '';
        end;
      end;
    end;
    Cells[0,0] := 'n';
    for i := 1 to nhm do Cells[0,i] := FloatToStrF(n_arr[i],fffixed,3,1);
  end;
  for i := 1 to SG1.Colcount do begin
    for j := 1 to SG1.Rowcount do begin
      val(Trim(MIO.str_w_dec_p(SG1.cells[i-1,j-1])),test,status);
      if status = 0 then begin
        if round(100*test) = -999900 then SG1.Cells[i-1,j-1] := '';
      end;
    end;
  end;
  B_inc_clBox.visible := not B_no_model;
  SG1.visible         := not B_no_model;
  Fit_Btn.enabled     := not B_no_model;
end;

procedure TM.Update_Values_Pars_panel;
begin
  with pars do begin
    ch_e_ComBox.ItemIndex    := i_ve_e - 1;
    ch_f_ComBox.ItemIndex    := i_ve_f - 1;
    ch_b_ComBox.ItemIndex    := i_ve_b - 1;
    B_Layer_1_CBox.Checked := B_Layer_1;
    B_Layer_2_CBox.Checked := B_Layer_2;
    B_liquid_bulk_CBox.Checked := B_liquid_bulk;
    B_Roughness_CBox.Checked := B_Roughness;

    m_e_Show.Text := FloatToStrF(Pars.t_e * Pars.rho_e * 1e-1,fffixed,8,4) + ' ug/cm^2';
    m_f_Show.Text := FloatToStrF(Pars.t_f * Pars.rho_f * 1e-1,fffixed,8,4) + ' ug/cm^2';
  end;
  UpdateEdits(Pars, ModelEdits);
  Set_Check_Boxes;
  Application.ProcessMessages;
end;

Procedure TM.UpdateEdits;
begin
  with Pars do begin
    t_e_Show.Text   := FloatToStrF(t_e,fffixed,8,3);
    t_f_Show.Text   := FloatToStrF(t_f,fffixed,8,3);
    rho_e_Show.Text := FloatToStrF(rho_e,fffixed,8,3);
    rho_f_Show.Text := FloatToStrF(rho_f,fffixed,8,3);
    rho_b_Show.Text := FloatToStrF(rho_b,fffixed,8,3);
    Jp_e_Show.Text  := FloatToStrF(Jp_e,fffixed,8,5);
    Jp_f_Show.Text  := FloatToStrF(Jp_f,fffixed,8,5);
    if Jpp_e <> GapV then Jpp_e_Show.Text := FloatToStrF(Jpp_e,fffixed,8,5) else Jpp_e_Show.Text := 'inf';
    if Jpp_f <> GapV then Jpp_f_Show.Text := FloatToStrF(Jpp_f,fffixed,8,5) else Jpp_f_Show.Text := 'inf';
    Jp_exp_e_Show.Text  := FloatToStrF (Jp_exp_e ,fffixed,8,3);
    Jp_exp_f_Show.Text  := FloatToStrF (Jp_exp_f ,fffixed,8,3);
    Jpp_exp_e_Show.Text := FloatToStrF(Jpp_exp_e,fffixed,8,3);
    Jpp_exp_f_Show.Text := FloatToStrF(Jpp_exp_f,fffixed,8,3);
    Jp_b_Show.Text      := FloatToStrF(Jp_b,fffixed,8,5);
    if Jpp_b <> GapV then Jpp_b_Show.Text := FloatToStrF(Jpp_b,fffixed,8,5) else Jpp_b_Show.Text := 'inf';
    Jp_exp_b_Show.Text  := FloatToStrF( Jp_exp_b ,fffixed,8,3);
    Jpp_exp_b_Show.Text := FloatToStrF(Jpp_exp_b,fffixed,8,3);
    vers_Show.Text      := FloatToStrF(vers,fffixed,8,3);
    AspRat_Show.Text    := FloatToStrF(AspRat,fffixed,8,3);
  end;
  if B_no_model then begin
    t_e_Show.Text   := '';
    t_f_Show.Text   := '';
    rho_e_Show.Text := '';
    rho_f_Show.Text := '';
    rho_b_Show.Text := '';
    Jp_e_Show.Text  := '';
    Jp_f_Show.Text  := '';
    Jpp_e_Show.Text := '';
    Jpp_f_Show.Text := '';
    Jp_exp_e_Show.Text  := '';
    Jp_exp_f_Show.Text  := '';
    Jpp_exp_e_Show.Text := '';
    Jpp_exp_f_Show.Text := '';
    Jp_b_Show.Text      := '';
    Jpp_b_Show.Text     := '';
    Jp_exp_b_Show.Text  := '';
    Jpp_exp_b_Show.Text := '';
    vers_Show.Text      := '';
    AspRat_Show.Text    := '';
  end;
  t_e_Show.Enabled := not B_no_model;
  t_f_Show.Enabled := not B_no_model;
  rho_e_Show.Enabled := not B_no_model;
  rho_f_Show.Enabled := not B_no_model;
  rho_b_Show.Enabled := not B_no_model;
  Jp_e_Show.Enabled := not B_no_model;
  Jp_f_Show.Enabled := not B_no_model;
  Jpp_e_Show.Enabled := not B_no_model;
  Jpp_f_Show.Enabled := not B_no_model;
  Jp_exp_e_Show.Enabled := not B_no_model;
  Jp_exp_f_Show.Enabled := not B_no_model;
  Jpp_exp_e_Show.Enabled := not B_no_model;
  Jpp_exp_f_Show.Enabled := not B_no_model;
  Jp_b_Show.Enabled := not B_no_model;
  Jpp_b_Show.Enabled := not B_no_model;
  Jp_exp_b_Show.Enabled := not B_no_model;
  Jpp_exp_b_Show.Enabled := not B_no_model;
  vers_Show.Enabled := not B_no_model;
  AspRat_Show.Enabled := not B_no_model;
end;

procedure TM.Update_RBtns;
begin
  if b_NoClick then Exit;
  B_NoClick := True;
  if DfDG_vs_actpar.Showing then DfDG_vs_actpar.FormShow(Self);
  case i_rbtn_old of
    t_e_ID        : t_e_f_R.Checked := False;
    t_f_ID        : t_f_f_R.Checked := False;
    rho_e_ID      : rho_e_f_R.Checked := False;
    rho_f_ID      : rho_f_f_R.Checked := False;
    rho_b_ID      : rho_b_f_R.Checked := False;
    Jp_e_ID       : Jp_e_f_R.Checked := False;
    Jp_f_ID       : Jp_f_f_R.Checked := False;
    Jp_b_ID       : Jp_b_f_R.Checked := False;
    Jp_exp_e_ID   : Jp_exp_e_f_R.Checked := False;
    Jp_exp_f_ID   : Jp_exp_f_f_R.Checked := False;
    Jp_exp_b_ID   : Jp_exp_b_f_R.Checked := False;
    Jpp_e_ID      : Jpp_e_f_R.Checked := False;
    Jpp_f_ID      : Jpp_f_f_R.Checked := False;
    Jpp_b_ID      : Jpp_b_f_R.Checked := False;
    Jpp_exp_e_ID  : Jpp_exp_e_f_R.Checked := False;
    Jpp_exp_f_ID  : Jpp_exp_f_f_R.Checked := False;
    Jpp_exp_b_ID  : Jpp_exp_b_f_R.Checked := False;
    vers_ID       : vers_R.Checked := False;
    AspRat_ID     : AspRat_R.Checked := False;

  end;

  case i_rbtn of
    t_e_ID        : t_e_f_R.Checked := True;
    t_f_ID        : t_f_f_R.Checked := True;
    rho_e_ID      : rho_e_f_R.Checked := True;
    rho_f_ID      : rho_f_f_R.Checked := True;
    rho_b_ID      : rho_b_f_R.Checked := True;
    Jp_e_ID       : Jp_e_f_R.Checked := True;
    Jp_f_ID       : Jp_f_f_R.Checked := True;
    Jp_b_ID       : Jp_b_f_R.Checked := True;
    Jp_exp_e_ID   : Jp_exp_e_f_R.Checked := True;
    Jp_exp_f_ID   : Jp_exp_f_f_R.Checked := True;
    Jp_exp_b_ID   : Jp_exp_b_f_R.Checked := True;
    Jpp_e_ID      : Jpp_e_f_R.Checked := True;
    Jpp_f_ID      : Jpp_f_f_R.Checked := True;
    Jpp_b_ID      : Jpp_b_f_R.Checked := True;
    Jpp_exp_e_ID  : Jpp_exp_e_f_R.Checked := True;
    Jpp_exp_f_ID  : Jpp_exp_f_f_R.Checked := True;
    Jpp_exp_b_ID  : Jpp_exp_b_f_R.Checked := True;
    vers_ID       : vers_R.Checked := True;
    AspRat_ID     : AspRat_R.Checked := True;

  end;
  i_rbtn_old := i_rbtn;
  B_NoClick := False;
  QTMFile.WriteInteger('Main','i_rbtn',i_rbtn);
end;

procedure TM.Clp_BtnClick(Sender: TObject);
var
  i,j,k,k_s : Integer;
  TextBuf : String;
  SysClip : TClipBoard;
  test : Double;
begin
  SysClip := TClipBoard.Create;
  TextBuf := SysClip.AsText;
  i := 1; j := 1; k_s := 1;
  for k := 1 to Length(TextBuf) do begin
    if TextBuf[k] = #9 then begin
      SG1.Cells[j,i] := Trim(copy(TextBuf,k_s,k - k_s));
      val(Trim(MIO.str_w_dec_p(SG1.cells[j,i])),test,status); if test = GapV then SG1.Cells[j,i] := '';
      k_s := k;
      j := j + 1;
    end;
    if (TextBuf[k] = #13) then begin
      SG1.Cells[j,i] := Trim(copy(TextBuf,k_s,k - k_s));
      val(Trim(MIO.str_w_dec_p(SG1.cells[j,i])),test,status); if test = GapV then SG1.Cells[j,i] := '';
      k_s := k;
      i := i + 1;
      j := 1;
    end;
  end;
  SysClip.Destroy; SG1.Color := cl3dlight;
  Accept_BtnClick(Self);
end;

procedure TM.Accept_BtnClick(Sender: TObject);
var i,status : integer;
  dfbyn,DD : Double;
  test : Double;
begin
  for i := 1 to nhm do begin
    case i_dfDG_DfnDD of
      1 : begin
        val(Trim(MIO.str_w_dec_p(SG1.cells[1,i])),test,status); if status = 0 then df[i] := test else df[i] := GapV;
        val(Trim(MIO.str_w_dec_p(SG1.cells[2,i])),test,status); if status = 0 then dG[i] := test else dG[i] := GapV;
      end;
      2 : begin
        val(Trim(MIO.str_w_dec_p(SG1.cells[1,i])),test,status); if status = 0 then dfbyn := test else dfbyn := GapV;
        val(Trim(MIO.str_w_dec_p(SG1.cells[2,i])),test,status); if status = 0 then DD    := test else DD    := GapV;
        if dfbyn <> GapV then df[i] := dfbyn * n_arr[i]    else df[i] := GapV;
        if DD    <> GapV then dG[i] := 2.5 * DD * n_arr[i] else dG[i] := GapV;
      end;
    end;
  end;
  for i := 1 to nhm do begin
    QTMFile.WriteFloat('Main','Df' + inttostr(i),df[i]);
    QTMFile.WriteFloat('Main','DG' + inttostr(i),dG[i]);
  end;
  for i := 1 to nhm do SG1.Cells[0,i] := FloatToStrF(n_arr[i],fffixed,8,5);
  Update_All; B_Changed := True; SG1.Color := clwindow;
end;

procedure TM.i_fit_df_DG_ComboxChange(Sender: TObject); begin i_fit_df_dG := i_fit_df_dG_ComBox.ItemIndex + 1; QTMFile.WriteInteger('Main','i_fit_df_dG',i_fit_df_dG); B_Changed := True; end;
procedure TM.i_yaxis_ComboxChange(Sender: TObject);
begin
  i_yaxis := i_yaxis_ComBox.ItemIndex + 1;
  QTMFile.WriteInteger('Main', 'i_yaxis', i_yaxis); Update_All; B_Changed := True;
  if DfDG_vs_actpar.Showing then DfDG_vs_actpar.Update_Graphs;
end;

procedure TM.i_dfDG_DfnDD_ComboxChange(Sender: TObject);
begin
  i_dfDG_DfnDD := i_dfDG_DfnDD_Combox.ItemIndex + 1; QTMFile.WriteInteger('Main','i_dfDG_DfnDD',i_dfDG_DfnDD); B_Changed := True;
  Update_Values; if Multiple.Showing then Multiple.Update_Values;
end;


procedure TM.i_wei_ninv_ComBoxChange(Sender: TObject); begin i_wei_ninv := i_wei_ninv_Combox.ItemIndex + 1; QTMFile.WriteInteger('Main','i_wei_ninv',i_wei_ninv); Update_Values; B_Changed := True; end;

procedure TM.i_fit_method_ComboxChange(Sender: TObject);
begin
  i_fit_method := i_fit_method_Combox.ItemIndex + 1; Ini.WriteInteger('Main','i_fit_method',i_fit_method); B_Changed := True;
end;

procedure TM.i_autoscale_x_ComboxChange(Sender: TObject);
begin
  if B_NoClick then Exit; i_autoscale_x := i_autoscale_x_Combox.ItemIndex + 1; QTMFile.WriteInteger('Main','i_autoscale_x',i_autoscale_x); B_Changed := True;
  Update_Values;
end;

procedure TM.i_xaxis_ComboxChange(Sender: TObject);
begin
  i_xaxis := i_xaxis_ComBox.ItemIndex + 1;
  QTMFile.WriteInteger('Main', 'i_xaxis', i_xaxis); B_Changed := True;
  Suggest_Limits;
  if x_axis_low_limit < 1 then begin x_axis_low_limit := 1; QTMFile.WriteFloat('Main', 'x_axis_low_limit', x_axis_low_limit); B_Changed := True; end;
  Update_All;
end;

procedure TM.Clear_BtnClick(Sender: TObject);
var i : integer;
begin
  for i := 1 to nhm do begin SG1.Cells[1,i] := ''; SG1.Cells[2,i] := ''; df[i] := GapV; dG[i] := GapV; end;
  for i := 1 to nhm do begin
    QTMFile.WriteFloat('Main','Df' + inttostr(i),df[i]);
    QTMFile.WriteFloat('Main','DG' + inttostr(i),dG[i]);
  end;
  if Sg1.colcount = 4 then begin
    for i := 1 to nhm do SG1.Cells[3,i] := '';
  end;
  MIO.System_Write(j_par_Sample,QTMFile); Update_All;
end;


procedure TM.B_inc_clBoxClickCheck(Sender: TObject);
var i : integer;
begin
  for i := 1 to nhm do begin
    B_fit_inc[i] := B_inc_clBox.Checked[i-1];
    QTMFile.WriteBool('Main','B_fit_inc' + inttostr(i),B_fit_inc[i]); B_Changed := True;
  end;
  Update_All; if Multiple.Showing then Multiple.Update_Freq_Graphs;
end;

procedure TM.SG1KeyPress(Sender: TObject; var Key: Char);
begin
  SG1.Color := cl3dlight;
  if key = #27 then SG1.Color := clwindow;
  if key = #13 then Accept_BtnClick(Self);
end;

procedure TM.FormResize(Sender: TObject); begin if B_NoClick then Exit; Arrange; end;

procedure TM.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not(DeleteTmpData) then begin
    Action := caNone;
    exit;
  end;
  B_NoClick := True;
  if assigned(Multiple) then Multiple.Release;
  if assigned(Settings) then Settings.Release;
  if assigned(chi2_Landscape) then chi2_Landscape.Release;
  if assigned(Limits) then Limits.Release;
  if assigned(DfDG_vs_actpar) then DfDG_vs_actpar.Release;
  Write_Panel_Format;
end;

function TM.DeleteTmpData: Boolean;
var MsgReturn: integer;
begin
  result := false;
  if B_Changed then begin
    if (qtm_fn = '') then begin
      MsgReturn := MessageDlg('Save data?', mtconfirmation, [mbYES, mbNo, mbAbort],0);
      Case MsgReturn of
        mrAbort: exit ;  //Cancel
        mrYes: miSAveAsClick(Self); //yes
      end;
    end
    else begin
      MsgReturn := MessageDlg('Save to ' + qtm_fn + '?', mtconfirmation, [mbYES, mbNo, mbAbort],0);
      Case MsgReturn of
        mrAbort: exit ; //cancel
        mrYes: miSaveClick(Self); //yes
      end;
    end;
  end;
  if Multiple.Showing then Multiple.Close;
  DeleteFile(tmp_fn[j_qtm]);
  DeleteFile(tmp_fn[j_qtd]);
  result := true
end;

procedure TM.Read_Panel_Format;
begin
  Top := Ini.ReadInteger('Main','Top',0);
  Height := Ini.ReadInteger('Main','Height',Screen.Height);
  if Height > Screen.Height then Height := Screen.Height;
  Left := Ini.ReadInteger('Main','Left',0);
  Width := Ini.ReadInteger('Main','Width',Screen.Width);
  if Width > Screen.Width then Width := Screen.Width;
end;

procedure TM.Write_Panel_Format;
begin
  Ini.WriteInteger('Main','Top',Top);
  Ini.WriteInteger('Main','Height',Height);
  Ini.WriteInteger('Main','Left',Left);
  Ini.WriteInteger('Main','Width',Width);
end;

procedure TM.Arrange;
begin
  Exponent_Labels;
  if Roughness_Panel.Visible then AMF_Panel.Width := Roughness_Panel.Left + Roughness_Panel.Width + 1
  else                            AMF_Panel.Width := Roughness_Panel.Left + 1;
  Ref_Btn.Visible := True;
  if Limits_Panel.Visible then Scale_Panel.Height := Limits_Panel.Top + Limits_Panel.Height
  else                         Scale_Panel.Height := Limits_Panel.Top - 1;
  df_Graph.Width := M.ClientWidth - Df_Graph.Left - 10;
  df_Graph.Height := round((M.ClientHeight - Df_Graph.Top - 3 - m.StatusBar1.Height) / 2);
  dG_Graph.Width := df_Graph.Width; dG_Graph.Height := df_Graph.Height;
  dG_Graph.Left  := df_Graph.Left;  dG_Graph.Top    := df_Graph.Top + df_Graph.Height + 3;
  df_Graph_to_clpbd_Btn.Left := df_Graph.Left + df_Graph.Width  - df_Graph_to_clpbd_Btn.Width  - 2;
  df_Graph_to_clpbd_Btn.Top  := df_Graph.Top + df_Graph.Height - df_Graph_to_clpbd_Btn.Height;
  dG_Graph_to_clpbd_Btn.Left := dG_Graph.Left + dG_Graph.Width  - dG_Graph_to_clpbd_Btn.Width  - 2;
  dG_Graph_to_clpbd_Btn.Top  := dG_Graph.Top + dG_Graph.Height - dG_Graph_to_clpbd_Btn.Height;
  if not B_Python_Installed then i_fit_method := 1;
  i_fit_method_Combox.visible := B_Python_Installed;
  PyQTMmi.visible := B_Python_Installed;
end;

function TM.GetIDFromEdit(Edit: Tedit; EditsArr: TEditWithnoUnitArray): integer;
var i: integer;
begin
  for i := low(EditsArr) to high(EditsArr) do begin
    if (EditsArr[i].Edit = Edit) then result := EditsArr[i].ID;
  end;
end;

procedure TM.KeyPressResponse(Sender: TObject; var Key: Char);
var ID: integer;
begin
  if EditKeyPress(Sender, Key, Pars, ModelEdits) then begin
    ID := GetIDFromEdit((Sender as TEdit), ModelEdits);
    MIO.System_Write_Part(ID,j_par_Sample,QTMFile); BU_Pars := Pars; B_Fit_Failed := False;
    if ID = rho_b_ID then begin
      rho_b_default := Pars.rho_b;
      QTMFile.WriteFloat('Main','rho_b_default',rho_b_default);
    end;
    Update_All;
    Limits.Set_Color(ID);
  end;
  if key = #13 then key := #0;
end;

function TM.EditKeyPress(Sender: TObject; var Key: Char; var ToPars: TPars; Edits: TEditWithnoUnitArray): Boolean;
var ID : Integer;
    value : Double;
begin
  result := false;
  with Sender as TEdit do begin
    Color := cl3dLight;
    if GetKeyState(VK_DECIMAL) < 0 then Key := DecimalSeparator;
    if key <> #13 then Exit;
    if key = #27 then begin Color := clwindow; Exit; end;
    result := true;
    ID := GetIDFromEdit((Sender as TEdit), Edits);
    value := FloatFromEdit(Sender as TEdit, 0);
    (Sender as TEdit).Text := Floattostr(value);
    case ID of
      t_e_ID  : Pars.t_e := value;
      t_f_ID  : Pars.t_f := value;
      rho_e_ID: Pars.rho_e := value;
      rho_f_ID: Pars.rho_f := value;
      rho_b_ID: Pars.rho_b := value;
      Jp_e_ID : Pars.Jp_e := value;
      Jp_f_ID : Pars.Jp_f := value;
      Jp_b_ID:  Pars.Jp_b := value;

      Jp_exp_e_ID: Pars.Jp_exp_e := value;
      Jp_exp_f_ID: Pars.Jp_exp_f := value;
      Jp_exp_b_ID: Pars.Jp_exp_b := value;

      Jpp_e_ID: Pars.Jpp_e := value;
      Jpp_f_ID: Pars.Jpp_f := value;
      Jpp_b_ID: Pars.Jpp_b := value;

      Jpp_exp_e_ID : Pars.Jpp_exp_e := value;
      Jpp_exp_f_ID : Pars.Jpp_exp_f := value;
      Jpp_exp_b_ID : Pars.Jpp_exp_b := value;

      vers_ID      : Pars.vers := value;
      AspRat_ID    : Pars.AspRat := value;
    end;
  end;
end;

procedure TM.x_axis_low_limit_ShowKeyPress(Sender: TObject; var Key: Char);
begin
  x_axis_low_limit_Show.Color := cl3dLight; if key <> #13 then Exit; if key = #27 then begin x_axis_low_limit_Show.Color := clwindow; Exit; end;
  x_axis_low_limit := M.FloatFromEdit(x_axis_low_limit_Show,x_axis_low_limit);
  QTMFile.WriteFloat('Main', 'x_axis_low_limit', x_axis_low_limit); B_Changed := True;
  x_axis_low_limit_Show.Text := FloatToStrF(x_axis_low_limit, fffixed, 8, 3);
  Update_All; (Sender as TEdit).Color := clwindow;;
end;

procedure TM.x_axis_up_limit_ShowKeyPress(Sender: TObject; var Key: Char);
begin
  x_axis_up_limit_Show.Color := cl3dLight; if key <> #13 then Exit; if key = #27 then begin x_axis_up_limit_Show.Color := clwindow; Exit; end;
  x_axis_up_limit := M.FloatFromEdit(x_axis_up_limit_Show,x_axis_up_limit);
  QTMFile.WriteFloat('Main', 'x_axis_up_limit', x_axis_up_limit); B_Changed := True;
  x_axis_up_limit_Show.Text := FloatToStrF(x_axis_up_limit, fffixed, 8, 3);
  Update_All; (Sender as TEdit).Color := clwindow;;
end;

procedure TM.t_e_f_RClick(Sender: TObject);       begin if B_NoClick then Exit; i_rbtn := t_e_ID; Update_RBtns;      end;
procedure TM.t_f_f_RClick(Sender: TObject);       begin if B_NoClick then Exit; i_rbtn := t_f_ID; Update_RBtns;      end;
procedure TM.rho_e_f_RClick(Sender: TObject);     begin if B_NoClick then Exit; i_rbtn := rho_e_ID; Update_RBtns;     end;
procedure TM.rho_f_f_RClick(Sender: TObject);     begin if B_NoClick then Exit; i_rbtn := rho_f_ID; Update_RBtns;     end;
procedure TM.rho_b_f_RClick(Sender: TObject);     begin if B_NoClick then Exit; i_rbtn := rho_b_ID; Update_RBtns;     end;
procedure TM.Jp_e_f_RClick(Sender: TObject);      begin if B_NoClick then Exit; i_rbtn := Jp_e_ID; Update_RBtns;     end;
procedure TM.Jp_f_f_RClick(Sender: TObject);      begin if B_NoClick then Exit; i_rbtn := Jp_f_ID; Update_RBtns;     end;
procedure TM.Jp_b_f_RClick(Sender: TObject);      begin if B_NoClick then Exit; i_rbtn := Jp_b_ID; Update_RBtns;   end;
procedure TM.Jp_exp_e_f_RClick(Sender: TObject);  begin if B_NoClick then Exit; i_rbtn := Jp_exp_e_ID; Update_RBtns; end;
procedure TM.Jp_exp_f_f_RClick(Sender: TObject);  begin if B_NoClick then Exit; i_rbtn := Jp_exp_f_ID; Update_RBtns; end;
procedure TM.Jp_exp_b_f_RClick(Sender: TObject);  begin if B_NoClick then Exit; i_rbtn := Jp_exp_b_ID; Update_RBtns; end;
procedure TM.Jpp_e_f_RClick(Sender: TObject);     begin if B_NoClick then Exit; i_rbtn := Jpp_e_ID; Update_RBtns;    end;
procedure TM.Jpp_f_f_RClick(Sender: TObject);     begin if B_NoClick then Exit; i_rbtn := Jpp_f_ID; Update_RBtns;    end;
procedure TM.Jpp_b_f_RClick(Sender: TObject);     begin if B_NoClick then Exit; i_rbtn := Jpp_b_ID; Update_RBtns;    end;
procedure TM.Jpp_exp_e_f_RClick(Sender: TObject); begin if B_NoClick then Exit; i_rbtn := Jpp_exp_e_ID; Update_RBtns; end;
procedure TM.Jpp_exp_f_f_RClick(Sender: TObject); begin if B_NoClick then Exit; i_rbtn := Jpp_exp_f_ID; Update_RBtns; end;
procedure TM.Jpp_exp_b_f_RClick(Sender: TObject); begin if B_NoClick then Exit; i_rbtn := Jpp_exp_b_ID; Update_RBtns; end;
procedure TM.vers_RClick(Sender: TObject);        begin if B_NoClick then Exit; i_rbtn := vers_ID; Update_RBtns;     end;
procedure TM.AspRat_RClick(Sender: TObject);      begin if B_NoClick then Exit; i_rbtn := AspRat_ID; Update_RBtns;     end;

procedure TM.t10_BtnClick(Sender: TObject);     begin par_shift(10); end;
procedure TM.t5_BtnClick(Sender: TObject);      begin par_shift(5); end;
procedure TM.t2_BtnClick(Sender: TObject);      begin par_shift(2); end;
procedure TM.t1d5_BtnClick(Sender: TObject);    begin par_shift(1.5); end;
procedure TM.t1d1_BtnClick(Sender: TObject);    begin par_shift(1.1); end;
procedure TM.t1d01_BtnClick(Sender: TObject);   begin par_shift(1.01); end;
procedure TM.t1d001_BtnClick(Sender: TObject);  begin par_shift(1.001); end;
procedure TM.b1d001_BtnClick(Sender: TObject);  begin shift_fac := 1/1.001; par_shift(shift_fac); end;
procedure TM.b1d01_BtnClick(Sender: TObject);   begin shift_fac := 1/1.01; par_shift(shift_fac); end;
procedure TM.b1d1_BtnClick(Sender: TObject);    begin shift_fac := 1/1.1; par_shift(shift_fac); end;
procedure TM.b1d5_BtnClick(Sender: TObject);    begin shift_fac := 1/1.5; par_shift(shift_fac); end;
procedure TM.b2_BtnClick(Sender: TObject);      begin par_shift(0.5); end;
procedure TM.b5_BtnClick(Sender: TObject);      begin par_shift(0.2); end;
procedure TM.b10_BtnClick(Sender: TObject);     begin par_shift(0.1); end;

procedure TM.t_e_CClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_t_e_C := not B_t_e_C;
  if B_rho_e_C and B_t_e_C then begin
    Messagedlg('Density and thickness cannot be fit parameters at the same time',mtinformation,[mbOK],0);
    B_t_e_C := False; B_NoClick := True; t_e_C.Checked := False; B_NoClick := False;
  end;
  QTMFile.WriteBool('Main','B_t_e_C',B_t_e_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2;
end;

procedure TM.t_f_CClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_t_f_C := not B_t_f_C;
  if B_rho_f_C and B_t_f_C then begin
    Messagedlg('Density and Thickness cannot be fit parameters at the same time',mtinformation,[mbOK],0);
    B_t_f_C := False; B_NoClick := True; t_f_C.Checked := False; B_NoClick := False;
  end;
  QTMFile.WriteBool('Main','B_t_f_C',B_t_f_C); MIO.Determine_Fit_Pars; B_Changed := True;Close_Open_Chi2;
end;

procedure TM.rho_e_CClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_rho_e_C  := not B_rho_e_C;
  if B_rho_e_C and B_t_e_C then begin
    Messagedlg('Density and Thickness cannot be fit parameters at the same time',mtinformation,[mbOK],0);
    B_rho_e_C := False; B_NoClick := True; rho_e_C.Checked := False; B_NoClick := False;
  end;
  QTMFile.WriteBool('Main','B_rho_e_C',B_rho_e_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2;
end;

procedure TM.rho_f_CClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_rho_f_C  := not B_rho_f_C;
  if B_rho_f_C and B_t_f_C then begin
    Messagedlg('Density and Thickness cannot be fit parameters at the same time',mtinformation,[mbOK],0);
    B_rho_f_C := False; B_NoClick := True; rho_f_C.Checked := False; B_NoClick := False;
  end;
  QTMFile.WriteBool('Main','B_rho_f_C',B_rho_f_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;

procedure TM.rho_b_CClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_rho_b_C := not B_rho_b_C;
  if B_rho_B_C and (B_Jp_b_C or B_Jpp_b_C) then begin
    Messagedlg('Density and viscoelasticity of bulk cannot be fit parameters at the same time',mtinformation,[mbOK],0);
    B_rho_B_C := False; B_NoClick := True; rho_b_C.Checked := False; B_NoClick := False;
  end;
  QTMFile.WriteBool('Main','B_rho_b_C',B_rho_b_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2;
end;

procedure TM.Jp_e_CClick(Sender: TObject); begin if B_NoClick then Exit;  B_Jp_e_C  := not B_Jp_e_C; QTMFile.WriteBool('Main','B_Jp_e_C',B_Jp_e_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.Jp_f_CClick(Sender: TObject); begin if B_NoClick then Exit;  B_Jp_f_C  := not B_Jp_f_C; QTMFile.WriteBool('Main','B_Jp_f_C',B_Jp_f_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.Jpp_e_CClick(Sender: TObject); begin if B_NoClick then Exit; B_Jpp_e_C := not B_Jpp_e_C; QTMFile.WriteBool('Main','B_Jpp_e_C',B_Jpp_e_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.Jpp_f_CClick(Sender: TObject); begin if B_NoClick then Exit; B_Jpp_f_C := not B_Jpp_f_C; QTMFile.WriteBool('Main','B_Jpp_f_C',B_Jpp_f_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.Jp_exp_e_CClick(Sender: TObject); begin if B_NoClick then Exit; B_Jp_exp_e_C  := not B_Jp_exp_e_C; QTMFile.WriteBool('Main','B_Jp_exp_e_C',B_Jp_exp_e_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.Jp_exp_f_CClick(Sender: TObject); begin if B_NoClick then Exit; B_Jp_exp_f_C  := not B_Jp_exp_f_C; QTMFile.WriteBool('Main','B_Jp_exp_f_C',B_Jp_exp_f_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.Jpp_exp_e_CClick(Sender: TObject); begin if B_NoClick then Exit; B_Jpp_exp_e_C  := not B_Jpp_exp_e_C; QTMFile.WriteBool('Main','B_Jpp_exp_e_C',B_Jpp_exp_e_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.Jpp_exp_f_CClick(Sender: TObject); begin if B_NoClick then Exit; B_Jpp_exp_f_C  := not B_Jpp_exp_f_C; QTMFile.WriteBool('Main','B_Jpp_exp_f_C',B_Jpp_exp_f_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;

procedure TM.Jp_b_CClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_Jp_b_C  := not B_Jp_b_C;
  if B_rho_B_C and (B_Jp_b_C or B_Jpp_b_C) then begin
    Messagedlg('Density and viscoelasticity of bulk cannot be fit parameters at the same time',mtinformation,[mbOK],0);
    B_Jp_b_C := False; B_NoClick := True; Jp_b_C.Checked := False; B_NoClick := False;
  end;
  QTMFile.WriteBool('Main','B_Jp_b_C',B_Jp_b_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2;
end;

procedure TM.Jpp_b_CClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_Jpp_b_C := not B_Jpp_b_C;
  if B_rho_B_C and (B_Jp_b_C or B_Jpp_b_C) then begin
    Messagedlg('Density and viscoelasticity of bulk cannot be fit parameters at the same time',mtinformation,[mbOK],0);
    B_Jpp_b_C := False; B_NoClick := True; Jpp_b_C.Checked := False; B_NoClick := False;
  end;
  QTMFile.WriteBool('Main','B_Jpp_b_C',B_Jpp_b_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2;
end;

procedure TM.Jp_exp_b_CClick(Sender: TObject);  begin if B_NoClick then Exit; B_Jp_exp_b_C  := not B_Jp_exp_b_C; QTMFile.WriteBool('Main','B_Jp_exp_b_C',B_Jp_exp_b_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.Jpp_exp_b_CClick(Sender: TObject); begin if B_NoClick then Exit; B_Jpp_exp_b_C := not B_Jpp_exp_b_C; QTMFile.WriteBool('Main','B_Jpp_exp_b_C',B_Jpp_exp_b_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.vers_CClick(Sender: TObject);      begin if B_NoClick then Exit; B_vers_C      := not B_vers_C; QTMFile.WriteBool('Main','B_vers_C',B_vers_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;
procedure TM.AspRat_CClick(Sender: TObject);    begin if B_NoClick then Exit; B_AspRat_C    := not B_AspRat_C; QTMFile.WriteBool('Main','B_AspRat_C',B_AspRat_C); MIO.Determine_Fit_Pars; B_Changed := True; Close_Open_Chi2; end;

procedure TM.Close_Open_Chi2;
begin
  if chi2_Landscape.Showing then begin
    chi2_Landscape.Close;
    chi2_Landscape.Show;
  end;
end;

procedure TM.Suggest_Limits;
var i : integer;
begin
  if (i_autoscale_x = 2) or (i_xaxis = 5) or (i_xaxis = 6) or (i_xaxis = 7) then Exit;
  case i_xaxis of
    1,2,3,4 : begin
      n_min := 100; n_max := 1;
      for i := 1 to nhm do begin
        if b_fit_inc[i] and (n_arr[i] > n_max) then n_max := n_arr[i];
        if b_fit_inc[i] and (n_arr[i] < n_min) then n_min := n_arr[i];
      end;
      if n_min = 100 then n_min := 1;
      if n_max = n_min then n_max := n_min + 1;
      x_axis_low_limit := n_min; x_axis_up_limit := n_max;
      QTMFile.WriteFloat('Main','x_axis_up_limit',x_axis_up_limit);
      QTMFile.WriteFloat('Main','x_axis_low_limit',x_axis_low_limit);
      x_axis_up_limit_Show.Text := FloatToStrF(x_axis_up_limit,fffixed,8,3);
      x_axis_low_limit_Show.Text := FloatToStrF(x_axis_low_limit,fffixed,8,3);
      B_Changed := True;
    end;
  end;
end;

procedure TM.Set_Check_Boxes;
begin
  B_NoClick := True;
  t_e_C.Checked      := B_t_e_C;
  t_f_C.Checked      := B_t_f_C;
  rho_e_C.Checked    := B_rho_e_C;
  rho_f_C.Checked    := B_rho_f_C;
  rho_b_C.Checked    := B_rho_b_C;
  Jp_e_C.Checked     := B_Jp_e_C;
  Jp_f_C.Checked     := B_Jp_f_C;
  Jp_b_C.Checked     := B_Jp_b_C;
  Jp_exp_e_C.Checked := B_Jp_exp_e_C;
  Jp_exp_f_C.Checked := B_Jp_exp_f_C;
  Jp_exp_b_C.Checked := B_Jp_exp_b_C;
  Jpp_e_C.Checked    := B_Jpp_e_C;
  Jpp_f_C.Checked    := B_Jpp_f_C;
  Jpp_b_C.Checked    := B_Jpp_b_C;
  Jpp_exp_e_C.Checked:= B_Jpp_exp_e_C;
  Jpp_exp_f_C.Checked:= B_Jpp_exp_f_C;
  Jpp_exp_b_C.Checked:= B_Jpp_exp_b_C;
  vers_C.Checked     := B_vers_C;
  AspRat_C.Checked   := B_AspRat_C;
  B_NoClick := False;
end;

procedure TM.par_shift(fac : Double);
begin
  with Pars do begin
    case i_rbtn of
      t_e_ID :        begin if t_e = 0 then t_e := 0.01; t_e := t_e * fac; MIO.System_Write_Part(t_e_ID,j_par_Sample,QTMFile); end;
      t_f_ID :        begin if t_f = 0 then t_f := 0.01; t_f := t_f * fac; MIO.System_Write_Part(t_f_ID,j_par_Sample,QTMFile); end;
      rho_e_ID :      begin if rho_e = 0 then rho_e := 0.01;     rho_e := rho_e * fac; MIO.System_Write_Part(rho_e_ID,j_par_Sample,QTMFile); end;
      rho_f_ID :      begin if rho_f = 0 then rho_f := 0.01;     rho_f := rho_f * fac; MIO.System_Write_Part(rho_f_ID,j_par_Sample,QTMFile); end;
      rho_b_ID :      begin if rho_b = 0 then rho_b := 0.01;     rho_b := rho_b * fac; MIO.System_Write_Part(rho_b_ID,j_par_Sample,QTMFile); end;
      Jp_e_ID :       begin if Jp_e = 0 then Jp_e := 0.01;     Jp_e := Jp_e * fac; MIO.System_Write_Part(Jp_e_ID,j_par_Sample,QTMFile); end;
      Jp_f_ID :       begin if Jp_f = 0 then Jp_f := 0.01;     Jp_f := Jp_f * fac; MIO.System_Write_Part(Jp_f_ID,j_par_Sample,QTMFile); end;
      Jp_b_ID :       begin if Jp_b = 0 then Jp_b := 0.01;     Jp_b := Jp_b * fac; MIO.System_Write_Part(Jp_b_ID,j_par_Sample,QTMFile); end;
      Jp_exp_e_ID :   begin if Jp_exp_e = 0 then Jp_exp_e := 0.01; Jp_exp_e := Jp_exp_e * fac; MIO.System_Write_Part(Jp_exp_e_ID,j_par_Sample,QTMFile); end;
      Jp_exp_f_ID :   begin if Jp_exp_f = 0 then Jp_exp_f := 0.01; Jp_exp_f := Jp_exp_f * fac; MIO.System_Write_Part(Jp_exp_f_ID,j_par_Sample,QTMFile); end;
      Jp_exp_b_ID :   begin if Jp_exp_b = 0 then Jp_exp_b := 0.01; Jp_exp_b := Jp_exp_b * fac; MIO.System_Write_Part(Jp_exp_b_ID,j_par_Sample,QTMFile); end;
      Jpp_e_ID :      begin if Jpp_e = 0 then Jpp_e := 0.01; Jpp_e := Jpp_e * fac; MIO.System_Write_Part(Jpp_e_ID,j_par_Sample,QTMFile); end;
      Jpp_f_ID :      begin if Jpp_f = 0 then Jpp_f := 0.01; Jpp_f := Jpp_f * fac; MIO.System_Write_Part(Jpp_f_ID,j_par_Sample,QTMFile); end;
      Jpp_b_ID :      begin if Jpp_b = 0 then Jpp_b := 0.01; Jpp_b := Jpp_b * fac; MIO.System_Write_Part(Jpp_b_ID,j_par_Sample,QTMFile); end;
      Jpp_exp_e_ID :  begin if Jpp_exp_e = 0   then Jpp_exp_e := 0.01; Jpp_exp_e   := Jpp_exp_e * fac; MIO.System_Write_Part(Jpp_exp_e_ID,j_par_Sample,QTMFile); end;
      Jpp_exp_f_ID :  begin if Jpp_exp_f = 0   then Jpp_exp_f := 0.01; Jpp_exp_f   := Jpp_exp_f * fac; MIO.System_Write_Part(Jpp_exp_f_ID,j_par_Sample,QTMFile); end;
      Jpp_exp_b_ID :  begin if Jpp_exp_b = 0 then Jpp_exp_b := 0.01; Jpp_exp_b := Jpp_exp_b * fac; MIO.System_Write_Part(Jpp_exp_b_ID,j_par_Sample,QTMFile); end;
      vers_ID :       begin if vers = 0 then vers := 0.01; vers := vers * fac; MIO.System_Write_Part(vers_ID,j_par_Sample,QTMFile); end;
      AspRat_ID :     begin if AspRat = 0 then AspRat := 0.01; AspRat := AspRat * fac; MIO.System_Write_Part(AspRat_ID,j_par_Sample,QTMFile); end;
    end;
  end;
  Update_All; B_Changed := True;
end;

procedure TM.Display_Check_Trivial;
begin
  t_e_Show.Visible := B_layer_1;
  t_f_Show.Visible := B_layer_2;
  rho_b_Show.Visible := B_liquid_Bulk;
  if not B_layer_1 then m_e_Show.Visible := False;
  if not B_layer_2 then m_f_Show.Visible := False;

  ch_e_ComBox.Visible := B_layer_1;
  ch_f_ComBox.Visible := B_layer_2;
  ch_b_ComBox.Visible := B_liquid_Bulk;

  rho_e_Show.Visible := B_layer_1;
  rho_f_Show.Visible := B_layer_2;

  Jp_e_Show.Visible := B_layer_1;
  Jp_f_Show.Visible := B_layer_2;
  Jp_b_Show.Visible := B_Liquid_Bulk;

  Jpp_e_Show.Visible := B_layer_1;
  Jpp_f_Show.Visible := B_layer_2;
  Jpp_b_Show.Visible := B_Liquid_Bulk;

  Jp_exp_e_Show.Visible := B_layer_1;
  Jp_exp_f_Show.Visible := B_layer_2;
  Jp_exp_b_Show.Visible :=  B_Liquid_Bulk;

  Jpp_exp_e_Show.Visible := B_layer_1;
  Jpp_exp_f_Show.Visible := B_layer_2;
  Jpp_exp_b_Show.Visible := B_Liquid_Bulk;

  vers_Show.Visible := B_Roughness;
  AspRat_Show.Visible := B_Roughness;

  t_e_Label.Visible := B_layer_1;
  t_f_Label.Visible := B_layer_2;
  rho_b_Label.Visible := B_liquid_bulk;

  rho_e_Label.Visible := B_layer_1;
  rho_f_Label.Visible := B_layer_2;

  Jp_e_Label.Visible := B_layer_1;
  Jp_f_Label.Visible := B_layer_2;
  Jp_b_Label.Visible   := B_Liquid_Bulk;

  Jpp_e_Label.Visible := B_layer_1;
  Jpp_f_Label.Visible := B_layer_2;
  Jpp_b_Label.Visible  := B_Liquid_Bulk;

  plp_e_Label.Visible := B_layer_1;
  plp_f_Label.Visible := B_layer_2;
  plp_b_Label.Visible := B_Liquid_Bulk;

  plpp_e_Label.Visible := B_layer_1;
  plpp_f_Label.Visible := B_layer_2;
  plpp_b_Label.Visible := B_Liquid_Bulk;

  vers_Label.Visible := B_Roughness and B_Liquid_Bulk;
  AspRat_Label.Visible := B_Roughness and B_Liquid_Bulk;

  t_e_C.Visible := B_layer_1;
  t_f_C.Visible := B_layer_2;

  rho_e_C.Visible := B_layer_1;
  rho_f_C.Visible := B_layer_2;
  rho_b_C.Visible := B_Liquid_Bulk;

  Jp_e_C.Visible := B_layer_1;
  Jp_f_C.Visible := B_layer_2;
  Jp_b_C.Visible := B_Liquid_Bulk;

  Jp_exp_e_C.Visible := B_layer_1;
  Jp_exp_f_C.Visible := B_layer_2;
  Jp_exp_b_C.Visible := B_Liquid_Bulk;

  Jpp_e_C.Visible := B_layer_1;
  Jpp_f_C.Visible := B_layer_2;
  Jpp_b_C.Visible := B_Liquid_Bulk;

  Jpp_exp_e_C.Visible := B_layer_1;
  Jpp_exp_f_C.Visible := B_layer_2;
  Jpp_exp_b_C.Visible := B_Liquid_Bulk;

  vers_C.Visible := B_Roughness and B_Liquid_Bulk;
  AspRat_C.Visible := B_Roughness and B_Liquid_Bulk;

  t_e_f_R.Visible := B_layer_1;   if not t_e_f_R.Visible  and (i_rbtn = t_e_ID) then i_rbtn := 0;
  t_f_f_R.Visible := B_layer_2;   if not t_f_f_R.Visible  and (i_rbtn = t_f_ID) then i_rbtn := 0;

  rho_e_f_R.Visible := B_layer_1;  if not rho_e_f_R.Visible and (i_rbtn = rho_e_ID) then i_rbtn := 0;
  rho_f_f_R.Visible := B_layer_2;  if not rho_f_f_R.Visible  and (i_rbtn = rho_f_ID) then i_rbtn := 0;
  rho_b_f_R.Visible := B_Liquid_Bulk; if not rho_b_f_R.Visible  and (i_rbtn = rho_b_ID) then i_rbtn := 0;

  Jp_e_f_R.Visible := B_layer_1;  if not Jp_e_f_R.Visible and (i_rbtn = Jp_e_ID) then i_rbtn := 0;
  Jp_f_f_R.Visible := B_layer_2;  if not Jp_f_f_R.Visible  and (i_rbtn = Jp_f_ID) then i_rbtn := 0;
  Jp_b_f_R.Visible := B_Liquid_Bulk; if not Jp_b_f_R.Visible  and (i_rbtn = Jp_b_ID) then i_rbtn := 0;

  Jpp_e_f_R.Visible := B_layer_1; if not Jpp_e_f_R.Visible and (i_rbtn = Jpp_e_ID) then i_rbtn := 0;
  Jpp_f_f_R.Visible := B_layer_2; if not Jpp_f_f_R.Visible and (i_rbtn = Jpp_f_ID) then i_rbtn := 0;
  Jpp_b_f_R.Visible := B_Liquid_Bulk; if not Jpp_b_f_R.Visible  and (i_rbtn = Jpp_b_ID) then i_rbtn := 0;

  Jp_exp_e_f_R.Visible := B_layer_1; if not Jp_exp_e_f_R.Visible and (i_rbtn = Jp_exp_e_ID) then i_rbtn := 0;
  Jp_exp_f_f_R.Visible := B_layer_2; if not Jp_exp_f_f_R.Visible and (i_rbtn = Jp_exp_f_ID) then i_rbtn := 0;
  Jp_exp_b_f_R.Visible := B_Liquid_Bulk; if not Jp_exp_b_f_R.Visible and (i_rbtn = Jp_exp_b_ID) then i_rbtn := 0;

  Jpp_exp_e_f_R.Visible :=  B_layer_1; if not Jpp_exp_e_f_R.Visible and (i_rbtn = Jpp_exp_e_ID) then i_rbtn := 0;
  Jpp_exp_f_f_R.Visible :=  B_layer_2; if not Jpp_exp_f_f_R.Visible and (i_rbtn = Jpp_exp_f_ID) then i_rbtn := 0;
  Jpp_exp_b_f_R.Visible := B_Liquid_Bulk; if not Jpp_exp_b_f_R.Visible and (i_rbtn = Jpp_exp_b_ID) then i_rbtn := 0;

  vers_R.Visible := B_Roughness and B_Liquid_Bulk; if not vers_R.Visible and (i_rbtn = vers_ID) then i_rbtn := 0;
  AspRat_R.Visible := B_Roughness and B_Liquid_Bulk; if not AspRat_R.Visible and (i_rbtn = AspRat_ID) then i_rbtn := 0;

  if not B_layer_1 then begin
    t_e_C.Checked := False;     B_t_e_C  := False; QTMFile.WriteBool('Main','B_t_e_C',B_t_e_C);
    rho_e_C.Checked := False;   B_rho_e_C  := False; QTMFile.WriteBool('Main','B_rho_e_C',B_rho_e_C);
    Jp_e_C.Checked := False;    B_Jp_e_C  := False; QTMFile.WriteBool('Main','B_Jp_e_C',B_Jp_e_C);
    Jp_exp_e_C.Checked := False; B_Jp_exp_e_C  := False; QTMFile.WriteBool('Main','B_Jp_exp_e_C',B_Jp_exp_e_C);
    Jpp_e_C.Checked := False;   B_Jpp_e_C  := False; QTMFile.WriteBool('Main','B_Jpp_e_C',B_Jpp_e_C);
    Jpp_exp_e_C.Checked := False; B_Jpp_exp_e_C  := False; QTMFile.WriteBool('Main','B_Jpp_exp_e_C',B_Jpp_exp_e_C);
  end;
  if not B_layer_2 then begin
    t_f_C.Checked := False;      B_t_f_C  := False; QTMFile.WriteBool('Main','B_t_f_C',B_t_f_C);
    rho_f_C.Checked := False;    B_rho_f_C  := False; QTMFile.WriteBool('Main','B_rho_f_C',B_rho_f_C);
    Jp_f_C.Checked := False;     B_Jp_f_C  := False; QTMFile.WriteBool('Main','B_Jp_f_C',B_Jp_f_C);
    Jp_exp_f_C.Checked := False; B_Jp_exp_f_C  := False; QTMFile.WriteBool('Main','B_Jp_exp_f_C',B_Jp_exp_f_C);
    Jpp_f_C.Checked := False;    B_Jpp_f_C  := False; QTMFile.WriteBool('Main','B_Jpp_f_C',B_Jpp_f_C);
    Jpp_exp_f_C.Checked := False; B_Jpp_exp_f_C  := False; QTMFile.WriteBool('Main','B_Jpp_exp_f_C',B_Jpp_exp_f_C);
  end;
  if not B_Liquid_Bulk then begin
    rho_b_C.Checked := False;     B_rho_b_C  := False; QTMFile.WriteBool('Main','B_rho_b_C',B_rho_b_C);
    Jp_b_C.Checked := False;      B_Jp_b_C  := False; QTMFile.WriteBool('Main','B_Jp_b_C',B_Jp_b_C);
    Jpp_b_C.Checked := False;     B_Jpp_b_C  := False; QTMFile.WriteBool('Main','B_Jpp_b_C',B_Jpp_b_C);
    Jp_exp_b_C.Checked := False;  B_Jp_exp_b_C  := False; QTMFile.WriteBool('Main','B_Jp_exp_b_C',B_Jp_exp_b_C);
    Jpp_exp_b_C.Checked := False; B_Jpp_exp_b_C  := False; QTMFile.WriteBool('Main','B_Jpp_exp_b_C',B_Jpp_exp_b_C);
  end;
  if not (B_Roughness and B_Liquid_Bulk) then begin
    vers_C.Checked := False; B_vers_C  := False; QTMFile.WriteBool('Main','B_vers_C',B_vers_C);
    AspRat_C.Checked := False; B_AspRat_C  := False; QTMFile.WriteBool('Main','B_AspRat_C',B_AspRat_C);
  end;
  Roughness_Panel.Visible := B_Liquid_Bulk;
  if Settings.Showing then Settings.Update_Values;
end;

procedure TM.Uncheck_old_RBtn;
begin
  case i_rbtn of
    t_e_ID        : t_e_f_R.Checked := False;
    t_f_ID        : t_f_f_R.Checked := False;

    rho_e_ID       : rho_e_f_R.Checked := False;
    rho_f_ID       : rho_f_f_R.Checked := False;
    rho_b_ID       : rho_b_f_R.Checked := False;

    Jp_e_ID       : Jp_e_f_R.Checked := False;
    Jp_f_ID       : Jp_f_f_R.Checked := False;
    Jp_b_ID       : Jp_b_f_R.Checked := False;

    Jp_exp_e_ID   : Jp_exp_e_f_R.Checked := False;
    Jp_exp_f_ID   : Jp_exp_f_f_R.Checked := False;
    Jp_exp_b_ID   : Jp_exp_b_f_R.Checked := False;

    Jpp_e_ID      : Jpp_e_f_R.Checked := False;
    Jpp_f_ID      : Jpp_f_f_R.Checked := False;
    Jpp_b_ID      : Jpp_b_f_R.Checked := False;

    Jpp_exp_e_ID  : Jpp_exp_e_f_R.Checked := False;
    Jpp_exp_f_ID  : Jpp_exp_f_f_R.Checked := False;
    Jpp_exp_b_ID  : Jpp_exp_b_f_R.Checked := False;

    vers_ID         : vers_R.Checked := False;
    AspRat_ID         : AspRat_R.Checked := False;

  end;
end;

procedure TM.About1Click(Sender: TObject);
begin
  Messagedlg('Version : ' + VersionStr + #13#10#13#10 + 'QTM was written by Diethelm Johannsmann and Philipp Sievers' + #13 + 'https://www.pc.tu-clausthal.de/' + #13 +
             'Feedback is appreciated',mtinformation,[mbOK],0);
end;

procedure TM.miOpenFileClick(Sender: TObject);
begin
  if qtm_fn = ''
    then OpenDialog1.InitialDir := GetCurrentDir
    else OpenDialog1.InitialDir := ExtractFilePath(qtm_fn);
  OpenDialog1.Filter := 'QTM File (.qtm)|*.qtm';
  OpenDialog1.Title := 'QTM-File : ';

  if not(DeleteTmpData) then Exit;
  if OpenDialog1.Execute then begin
    Set_prev_names(OpenDialog1.Filename);
    open_file(OpenDialog1.Filename);
    Ini.WriteString('Main','QTM_fn',QTM_fn);
    QTMFile.WriteString('Main','QTM_fn',QTM_fn);
  end;
  Update_All;
  Settings.Status_Read;
end;

procedure TM.Set_prev_names(fn_Loc: string);
var iprefn,k : Integer;
begin
  if prev_fn_arr[1] <> fn_Loc then begin
    iprefn := 1;
    repeat
      inc(iprefn);
      if AnsiUpperCase(prev_fn_arr[iprefn]) = AnsiUpperCase(fn_Loc) then begin
         for k := iprefn to nprefn -1 do begin
           prev_fn_arr[k] := prev_fn_arr[k + 1];
           miPrevFilenames[iprefn].Enabled := miPrevFilenames[k + 1].Enabled;
         end;
         prev_fn_arr[nprefn] := '';
         miPrevFilenames[nprefn].Enabled := True;
         dec(iprefn);
      end;
    until iprefn > nprefn - 1;
    for iprefn := nprefn downto 2 do begin
      prev_fn_arr[iprefn] := prev_fn_arr[iprefn - 1];
      miPrevFilenames[iprefn].Enabled := miPrevFilenames[iprefn - 1].Enabled;
    end;
    prev_fn_arr[1] := fn_Loc;
    miPrevFilenames[1].Enabled := True;
    for iprefn := 1 to nprefn do Ini.WriteString('Main','PreviousFilenames[' + IntToStr(iprefn) + ']',prev_fn_arr[iprefn]);
    Ini.UpdateFile;
    Update_Values;
  end;
end;

procedure TM.miSaveClick(Sender: TObject);
var i: integer;
begin
  QTMFile.WriteString('Main','Version', VersionStr);
  QTMFile.WriteString('Main', 'QTM_fn', qtm_fn);
  for i := low(FileTypes) to high(FileTypes) do begin
    CopyFile(pChar(tmp_fn[i]),pChar(ChangeFileExt(QTM_fn,FileTypes[i])), false);
  end;
  B_Changed := false;
end;


procedure TM.miSAveAsClick(Sender: TObject);
var i: integer;
begin
  if qtm_fn = ''
  then begin
    SaveDialog1.InitialDir := GetCurrentDir;
    I := 0;
    repeat inc(i) until not(FileExists(GetCurrentDir + 'Data' + IntToStr(i) + '.qtm'));
    SaveDialog1.FileName   := 'Data' + IntToStr(i);
  end
  else begin
    SaveDialog1.InitialDir := ExtractFilePath(qtm_fn);
    SaveDialog1.FileName   := ExtractFileName(qtm_fn);
  end;

  SaveDialog1.Filter     := 'QTM Data (Ver. 2.0) (*.qtm, *.qtd)|*.qtm';
  SaveDialog1.Title      := 'Save as...';
  if SaveDialog1.Execute then begin
//    i_Filetype := SaveDialog1.FilterIndex;
i_Filetype := 2;
{    if FileExists(changefileext(SaveDialog1.filename,'.qtm')) then begin
      if (Messagedlg('File already exists. Overwrite?',mtinformation,mbOKCancel,0) = mrCancel) then Exit;
    end;  //Not needed, Savedialog has OverwritePrompt = True DJ Aug 2018}
    QTM_fn := changefileext(SaveDialog1.filename,'.qtm');
    miSaveClick(self);
    Ini.WriteString('Main','QTM_fn',QTM_fn);
    QTMFile.WriteString('Main','QTM_fn',QTM_fn);
    Set_prev_names(QTM_fn);
    Update_Values;
  end;
end;

procedure TM.B_Layer_1_CBoxClick(Sender: TObject);
begin
  B_Layer_1 := B_Layer_1_CBox.Checked; QTMFile.WriteBool('Main','B_Layer_1',B_Layer_1); B_Changed := True;
  if not B_Layer_1 then begin
    Pars.t_e := 0; Ref_Pars.t_e := 0; MIO.System_Write_part(t_e_ID,j_par_Sample,QTMFile); MIO.System_Write_part(t_e_ID,j_par_Ref,QTMFile);
  end;
  if Settings.Showing then Settings.Update_Values;
  if Limits.Showing then Limits.Update_Values;
  BU_Pars := Pars; B_Fit_Failed := False; Update_All;
end;

procedure TM.B_Layer_2_CBoxClick(Sender: TObject);
begin
  B_Layer_2 := B_Layer_2_CBox.Checked; QTMFile.WriteBool('Main','B_Layer_2',B_Layer_2); B_Changed := True;
  if not B_Layer_2 then begin
    Pars.t_f := 0; Ref_Pars.t_f := 0; MIO.System_Write_part(t_f_ID,j_par_Sample,QTMFile); MIO.System_Write_part(t_f_ID,j_par_Ref,QTMFile);
  end;
  if Settings.Showing then Settings.Update_Values;
  if Limits.Showing then Limits.Update_Values;
  BU_Pars := Pars; B_Fit_Failed := False; Update_All;
end;

procedure TM.B_Liquid_Bulk_CBoxClick(Sender: TObject);
begin
  B_NoClick := True;
  B_Liquid_Bulk := B_Liquid_Bulk_CBox.Checked; QTMFile.WriteBool('Main','B_Liquid_Bulk',B_Liquid_Bulk); B_Changed := True;
  if not B_Liquid_Bulk then begin
    Pars.rho_b := 0; Ref_Pars.rho_b := 0;
    MIO.System_Write_part(rho_b_ID,j_par_Sample,QTMFile);
    MIO.System_Write_part(rho_b_ID,j_par_Ref,QTMFile);
    Set_Roughness_to_False;
    Roughness_Panel.visible := False;
  end else begin
    Pars.rho_b := rho_b_default; Ref_Pars.rho_b := rho_b_default;
    MIO.System_Write_part(rho_b_ID,j_par_Sample,QTMFile);
    MIO.System_Write_part(rho_b_ID,j_par_Ref,QTMFile);
    Roughness_Panel.visible := True;
  end;

  if Settings.Showing then Settings.Update_Values;
  if Limits.Showing then Limits.Update_Values;
  BU_Pars := Pars; B_Fit_Failed := False; Update_All;
end;

procedure TM.B_Roughness_CBoxClick(Sender: TObject);
begin
  B_Roughness := B_Roughness_CBox.Checked; QTMFile.WriteBool('Main','B_Roughness',B_Roughness); B_Changed := True;
  if not B_Roughness then Set_Roughness_to_False;
  if Settings.Showing then Settings.Update_Values;
  if Limits.Showing then Limits.Update_Values;
  BU_Pars := Pars; B_Fit_Failed := False; Update_All;
end;

procedure TM.t_e_LabelDblClick(Sender: TObject);
begin case m_e_Show.Visible of True : m_e_Show.Visible := False; False : m_e_Show.Visible := True; end; end;
procedure TM.t_f_LabelDblClick(Sender: TObject);
begin case m_f_Show.Visible of True : m_f_Show.Visible := False; False : m_f_Show.Visible := True; end; end;

procedure TM.m_e_ShowDblClick(Sender: TObject); begin m_e_Show.Visible := False; end;
procedure TM.m_f_ShowDblClick(Sender: TObject); begin m_f_Show.Visible := False; end;

procedure TM.sqr_LabelDblClick(Sender: TObject);
begin
  instring := FloatToStrF(err_Df,fffixed,6,3);
  repeat
    if not(InputQuery('Input','Statistical error on Df and DG [Hz] ',instring)) then exit;
  until TryStrToFloat(StringReplace(Trim(instring),',', DecimalSeparator,[rfReplaceAll]	),err_Df);
  QTMFile.WriteFloat('Main','err_Df',err_Df); B_Changed := True;
  Update_All;
end;

procedure TM.SG1ContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
var i_row : Integer;
    instring : String;
begin
  i_row := round(MousePos.Y / (SG1.DefaultRowHeight + 1));
  instring := FloatToStrF(n_arr[i_row],fffixed,8,6);
  repeat
    if not(InputQuery('Input','New overtone order, #' + Inttostr(i_row),instring)) then exit;
  until TryStrToFloat(StringReplace(Trim(instring),',', DecimalSeparator,[rfReplaceAll]	),n_arr[i_row]);
  QTMFile.WriteFloat('Main','n_arr[' + InttoStr(i_row)+ ']',n_arr[i_row]); B_Changed := True;
  Update_All;
end;

procedure TM.OpenPreviousFileClick(Sender: TObject);
var n : Byte;
begin
  if (Sender as TMenuItem).Name = 'N11' then n := 1;
  if (Sender as TMenuItem).Name = 'N21' then n := 2;
  if (Sender as TMenuItem).Name = 'N31' then n := 3;
  if (Sender as TMenuItem).Name = 'N41' then n := 4;
  if (Sender as TMenuItem).Name = 'N51' then n := 5;
  if (Sender as TMenuItem).Name = 'N61' then n := 6;
  if (Sender as TMenuItem).Name = 'N71' then n := 7;
  if (Sender as TMenuItem).Name = 'N81' then n := 8;
  if (Sender as TMenuItem).Name = 'N91' then n := 9;
  if (Sender as TMenuItem).Name = 'N101'then n := 10;
  if not(DeleteTmpData) then exit;
  open_file(ChangefileExt(prev_fn_arr[n],'.qtm'));
  Ini.WriteString('Main','QTM_fn',QTM_fn);
  QTMFile.WriteString('Main','QTM_fn',QTM_fn);
  Update_All;
end;

procedure TM.open_file(Fn_loc: string);
var i : integer;
begin
  if not FileExists(Fn_loc) then Exit;
  CopyFile(Pchar(Fn_loc), PChar(tmp_fn[j_qtm]), false);
  if FileExists(ChangeFileExt(Fn_loc,'.qtd')) then begin
    CopyFile(Pchar(ChangeFileExt(Fn_loc,'.qtd')), PChar(tmp_fn[j_qtd]), false);
  end;
  Status_Read;
  Settings.Status_Read;
  Limits.Status_Read;
  for i := 1 to 4 do MIO.System_Read(i,QTMFile);
  Chi2_Landscape.Status_Read;
  MIO.Determine_Fit_Pars;
  if FileExists(tmp_fn[j_qtd]) then begin
    Multiple.Status_Read;
    Multiple.Close;
    Multiple.Show;
  end;
  QTM_fn := Fn_loc;
end;

function TM.FloatFromEdit(Edit_obj: TEdit; else_value: extended = 0 ): extended;
begin
  if not(TryStrToFloat(StringReplace(Trim(Edit_obj.text),',',DecimalSeparator,[rfReplaceAll]),result)) then
  begin
    Edit_obj.text := '####';
    M.Delay_secs(0.5);
    result := else_value;
  end;
  Edit_obj.text:= FloatToStr(result);
end;

procedure TM.miNewFileClick(Sender: TObject);
begin
  if not(DeleteTmpData) then Exit;
  QTM_fn := '';
  QTMFile := TIniFile.Create(tmp_fn[j_qtm]);
  Status_Read; FormShow(Self); Multiple.Close;
end;

procedure TM.Align_Shows_start_from_Left;
begin
  t_e_Show.BiDiMode := bdRightToLeft;
  t_f_Show.BiDiMode := bdRightToLeft;
  rho_e_Show.BiDiMode := bdRightToLeft;
  rho_f_Show.BiDiMode := bdRightToLeft;
  rho_b_Show.BiDiMode := bdRightToLeft;
  Jp_e_Show.BiDiMode := bdRightToLeft;
  Jp_f_Show.BiDiMode := bdRightToLeft;
  Jp_b_Show.BiDiMode := bdRightToLeft;
  Jp_exp_e_Show.BiDiMode := bdRightToLeft;
  Jp_exp_f_Show.BiDiMode := bdRightToLeft;
  Jp_exp_b_Show.BiDiMode := bdRightToLeft;
  Jpp_e_Show.BiDiMode := bdRightToLeft;
  Jpp_f_Show.BiDiMode := bdRightToLeft;
  Jpp_b_Show.BiDiMode := bdRightToLeft;
  Jpp_exp_e_Show.BiDiMode := bdRightToLeft;
  Jpp_exp_f_Show.BiDiMode := bdRightToLeft;
  Jpp_exp_b_Show.BiDiMode := bdRightToLeft;
  m_e_Show.BiDiMode := bdRightToLeft;
  m_f_Show.BiDiMode := bdRightToLeft;

  vers_Show.BiDiMode := bdRightToLeft;
  AspRat_Show.BiDiMode := bdRightToLeft;

end;

Procedure TM.ErrorHandler(Errorcode: Byte);
var MsgStr: string;
begin
  if Errorcode = 0 then exit;
  case Errorcode of
    E_kd_failed:  MsgStr := 'An argument of a tangent became too large' + #13 + 'Layer is either  too thick or too soft';
    E_SLA_failed: MsgStr := 'Acoustic impedance = 0, check layer system';
    E_Overflow:   MsgStr := 'Floating Point Overflow. Check Parameters';
    E_Fit_Failed: MsgStr := 'Acoustic impedance = 0, check layer system';
  end;
  if Multiple.B_Stop = true then begin
    MessageDlg(MsgStr,mtInformation,[mbOK],0);
  end
  else begin
    if MessageDlg(MsgStr,mtInformation,mbAbortIgnore,0) = 3 then Multiple.B_Stop := true;
  end;
end;

procedure TM.df_Graph_to_clpbd_BtnClick(Sender: TObject); begin MIO.GraphToClpbd(M.df_Graph); end;
procedure TM.dG_Graph_to_clpbd_BtnClick(Sender: TObject); begin MIO.GraphToClpbd(M.dG_Graph); end;

procedure TM.DataFitsClipboard1Click(Sender: TObject);
var p,s : Integer;
    TextBuf : String;
    SysClip : TClipBoard;
begin
  SysClip := TClipBoard.Create; TextBuf := '';
  for p := 1 to df_Graph.Points do begin
    for s := 1 to df_Graph.Subsets do begin
      if (df_Graph.XData[s-1,p-1] <> GapV) and (df_Graph.YData[s-1,p-1] <> GapV) then
          TextBuf := TextBuf + FloatToStr(df_Graph.XData[s-1,p-1]) + #9 +
                               FloatToStr(df_Graph.YData[s-1,p-1]) + #9
      else TextBuf := TextBuf  + #9 + #9;
    end;
    for s := 1 to dG_Graph.Subsets do begin
      if (dG_Graph.XData[s-1,p-1] <> GapV) and (dG_Graph.YData[s-1,p-1] <> GapV) then
          TextBuf := TextBuf + FloatToStr(dG_Graph.XData[s-1,p-1]) + #9 +
                               FloatToStr(dG_Graph.YData[s-1,p-1]) + #9
      else TextBuf := TextBuf  + #9 + #9;
    end;
    TextBuf := TextBuf + #10;
  end;
  SysClip.AsText := TextBuf; SysClip.Destroy;
end;

procedure TM.FitParametersClipboard1Click(Sender: TObject);
var TextBuf : String; SysClip : TClipBoard;
begin
  MIO.Set_IO_Labels_Main;
  SysClip := TClipBoard.Create;
  TextBuf := 'Sample';
  with Pars do begin
    if B_Layer_1 then begin
      Textbuf := Textbuf + 'Layer 1' + #10;
      Textbuf := Textbuf + t_e_label.caption + #9 + FloatToStr(t_e) + #10;
      Textbuf := Textbuf + rho_e_label.caption + #9 + FloatToStr(rho_e) + #10;
      Textbuf := Textbuf + Jp_e_label.caption + #9 + FloatToStr(Jp_e) + #10;
      Textbuf := Textbuf + plp_e_label.caption + #9 + FloatToStr(Jp_exp_e) + #10;
      Textbuf := Textbuf + Jpp_e_label.caption + #9 + FloatToStr(Jpp_e) + #10;
      Textbuf := Textbuf + plpp_e_label.caption + #9 + FloatToStr(Jpp_exp_e) + #10;
    end;
    if B_Layer_2 then begin
      Textbuf := Textbuf + 'Layer 2' + #10;
      Textbuf := Textbuf + t_f_label.caption + #9 + FloatToStr(t_f) + #10;
      Textbuf := Textbuf + rho_f_label.caption + #9 + FloatToStr(rho_f) + #10;
      Textbuf := Textbuf + Jp_f_label.caption + #9 + FloatToStr(Jp_f) + #10;
      Textbuf := Textbuf + plp_f_label.caption + #9 + FloatToStr(Jp_exp_f) + #10;
      Textbuf := Textbuf + Jpp_f_label.caption + #9 + FloatToStr(Jpp_f) + #10;
      Textbuf := Textbuf + plpp_f_label.caption + #9 + FloatToStr(Jpp_exp_f) + #10;
    end;
    if B_Liquid_Bulk then begin
      Textbuf := Textbuf + 'Bulk' + #10;
      Textbuf := Textbuf + rho_b_label.caption + #9 + FloatToStr(rho_b) + #10;
      Textbuf := Textbuf + Jp_b_label.caption + #9 + FloatToStr(Jp_b) + #10;
      Textbuf := Textbuf + plp_b_label.caption + #9 + FloatToStr(Jp_exp_b) + #10;
      Textbuf := Textbuf + Jpp_b_label.caption + #9 + FloatToStr(Jpp_b) + #10;
      Textbuf := Textbuf + plpp_b_label.caption + #9 + FloatToStr(Jpp_exp_b) + #10;
    end;
    if B_roughness then begin
      Textbuf := Textbuf + 'Roughness' + #10;
      Textbuf := Textbuf + vers_label.caption + #9 + FloatToStr(vers) + #10;
      Textbuf := Textbuf + Asprat_label.caption + #9 + FloatToStr(Asprat) + #10;
    end;
  end;
  Textbuf := Textbuf + 'Reference' + #10;
  with Ref_Pars do begin
    if B_Layer_1 then begin
      Textbuf := Textbuf + 'Layer 1' + #10;
      Textbuf := Textbuf + t_e_label.caption + #9 + FloatToStr(t_e) + #9;
      Textbuf := Textbuf + rho_e_label.caption + #9 + FloatToStr(rho_e) + #10;
      Textbuf := Textbuf + Jp_e_label.caption + #9 + FloatToStr(Jp_e) + #9;
      Textbuf := Textbuf + plp_e_label.caption + #9 + FloatToStr(Jp_exp_e) + #10;
      Textbuf := Textbuf + Jpp_e_label.caption + #9 + FloatToStr(Jpp_e) + #9;
      Textbuf := Textbuf + plpp_e_label.caption + #9 + FloatToStr(Jpp_exp_e) + #10;
    end;
    if B_Layer_2 then begin
      Textbuf := Textbuf + 'Layer 2' + #10;
      Textbuf := Textbuf + t_f_label.caption + #9 + FloatToStr(t_f) + #9;
      Textbuf := Textbuf + rho_f_label.caption + #9 + FloatToStr(rho_f) + #10;
      Textbuf := Textbuf + Jp_f_label.caption + #9 + FloatToStr(Jp_f) + #9;
      Textbuf := Textbuf + plp_f_label.caption + #9 + FloatToStr(Jp_exp_f) + #10;
      Textbuf := Textbuf + Jpp_f_label.caption + #9 + FloatToStr(Jpp_f) + #9;
      Textbuf := Textbuf + plpp_f_label.caption + #9 + FloatToStr(Jpp_exp_f) + #10;
    end;
    if B_Liquid_Bulk then begin
      Textbuf := Textbuf + 'Bulk' + #10;
      Textbuf := Textbuf + rho_b_label.caption + #9 + FloatToStr(rho_b) + #10;
      Textbuf := Textbuf + Jp_b_label.caption + #9 + FloatToStr(Jp_b) + #9;
      Textbuf := Textbuf + plp_b_label.caption + #9 + FloatToStr(Jp_exp_b) + #10;
      Textbuf := Textbuf + Jpp_b_label.caption + #9 + FloatToStr(Jpp_b) + #9;
      Textbuf := Textbuf + plpp_b_label.caption + #9 + FloatToStr(Jpp_exp_b) + #10;
    end;
    if B_roughness then begin
      Textbuf := Textbuf + 'Roughness' + #10;
      Textbuf := Textbuf + vers_label.caption + #9 + FloatToStr(vers) + #9;
      Textbuf := Textbuf + Asprat_label.caption + #9 + FloatToStr(Asprat) + #10;
    end;
  end;
  SysClip.AsText := TextBuf; SysClip.Free;
end;

function TM.GetVersion: string;
{ VERSION X.Y.Z.aaaa:
  X: major version,affecting essentially file structure & downward compatibility,
     1 : binary qtz- (without version info) and ini/cfg file (with version info);
  Y: minor version,affecting ess. major features,
     2 : saving raw data,up/down overtone sweeps;
  Z: 'patch level' or 'bug fix level' - no changes in functionality,only bugfixing;
  aaaa: build number,should be incremented each time a new compiled version is created;}
const InfoNum = 10;
      InfoStr: array[1..InfoNum] of string = ('CompanyName', 'FileDescription', 'FileVersion', 'InternalName', 'LegalCopyright', 'LegalTradeMarks', 'OriginalFileName', 'ProductName', 'ProductVersion', 'Comments');
var S: string;
    n, Len : DWORD;
    Buf: PChar;
    Value: PChar;
begin
  result:='';
  S := Application.ExeName;
  n := GetFileVersionInfoSize(PChar(S), n);
  if n > 0 then
  begin
    Buf := AllocMem(n);
    GetFileVersionInfo(PChar(S), 0, n, Buf);
    if VerQueryValue(Buf, PChar('StringFileInfo\040904E4\' + InfoStr[3]), Pointer(Value), Len) then
       result:= Value;
    FreeMem(Buf, n);
  end;
end;

function TM.VersionIsAtLeast(const TheFile: TMemIniFile; const MinimumVersion: string): Boolean;
{ 1. type of overloaded function: determines whether the version of a TMemIniFile
  (.cfg, .ini) IN MEMORY is at least equal to or higher than MinimumVersion }
var fileverstr: string;
begin
  fileverstr := TheFile.ReadString('Main','Version','0.0.0.0');
  result := VersionIsAtLeast(fileverstr, MinimumVersion);
end;

function TM.VersionIsAtLeast(const TheFile: TIniFile; const MinimumVersion: string): Boolean;
{ 2. type of overloaded function: determines whether the version of a TIniFile
  (.cfg, .ini) ON HARDDISK is at least equal to or higher than MinimumVersion }
var fileverstr: string;
begin
  fileverstr := TheFile.ReadString('Main','Version','0.0.0.0');
  result := VersionIsAtLeast(fileverstr, MinimumVersion);
end;

function TM.VersionIsAtLeast(const VersionToCheck, MinimumVersion: string): Boolean;
{ 3. type of overloaded function: compares two version strings (format: '0.0.0.0')
  and returns true when VersionToCheck is at least equal to or higher than MinimumVersion }
var minverstr, checkverstr: string;
    valm, valf, i: integer;
begin
  result := false;
  checkverstr := VersionToCheck;
  minverstr := MinimumVersion;
  for i := 1 to 3 do begin
    if (not TryStrToInt(LeftStr(minverstr, AnsiPos('.', minverstr)-1), valm)) then begin
      if (minverstr = '') then valm := 0
      else begin
        MessageDlg('Internal error: File version check failed due to improper version format string.',
                    mtError, [mbOK], 0);
        exit;
      end;
    end;
    if (not TryStrToInt(LeftStr(checkverstr, AnsiPos('.', checkverstr)-1), valf)) then begin
      if (checkverstr = '') then valf := 0 else valf := -1;
    end;
    if valf < valm then exit;
    if valf > valm then begin
      result := true;
      exit;
    end;
    minverstr := Rightstr(minverstr, Length(minverstr)-AnsiPos('.', minverstr));
    checkverstr := Rightstr(checkverstr, Length(checkverstr)-AnsiPos('.', checkverstr));
  end;
  TryStrToInt(minverstr, valm);
  TryStrToInt(checkverstr, valf);
  if valf < valm then exit;
  result := true;
end;

{procedure TM.File1Click(Sender: TObject);
begin
  M.miSave.Enabled := not(QTM_fn = '')
end;
}
procedure TM.Chisqr_LabelDblClick(Sender: TObject);
begin
  instring := FloatToStrF(err_Df,fffixed,6,3);
  repeat
    if not(InputQuery('Input','Statistical error on Df and DG [Hz] ',instring)) then exit;
  until TryStrToFloat(StringReplace(Trim(instring),',', DecimalSeparator,[rfReplaceAll]	),err_Df);
  QTMFile.WriteFloat('Main','err_Df',err_Df); B_Changed := True;
  Update_All;
end;

procedure TM.FitPars2Clpbd_BtnClick(Sender: TObject); begin FitParametersClipboard1Click(Self); end;

procedure TM.Set_Roughness_to_False;
begin
  QTMFile.WriteBool('Main','B_Roughness',B_Roughness); B_Roughness := False;
  Pars.vers := 0;
  Ref_Pars.vers := 0;
  MIO.System_Write_part(vers_ID,j_par_Sample,QTMFile);
  MIO.System_Write_part(vers_ID,j_par_Ref,QTMFile);
  B_Changed := True;
  if Settings.Showing then Settings.Update_Values;
  if Limits.Showing then Limits.Update_Values;
end;

procedure TM.Change_VE_Pars_All(Sender: TObject);
var Pars_old : TPars;
begin
  move(Pars,Pars_old,Sizeof(TPars));
  with Sender as TCombobox do begin
    if Name = 'ch_e_ComBox' then begin i_ve_old := Pars.i_ve_e; i_layer := 1; end;
    if Name = 'ch_f_ComBox' then begin i_ve_old := Pars.i_ve_f; i_layer := 2; end;
    if Name = 'ch_b_ComBox' then begin i_ve_old := Pars.i_ve_b; i_layer := 3; end;
    i_ve_new := Itemindex + 1;
  end;
  SLA.Convert_VE_Pars(i_layer,i_ve_old, i_ve_new, Pars_old, Pars);
  Limits.Defaults1Click(Self);
  Update_Values;
  Settings.Update_Values;
  If Multiple.Showing then Multiple.Change_VE_Pars;
  If chi2_Landscape.Showing then chi2_Landscape.Change_VE_Pars;
//  Limits.Change_VE_Pars(i_layer,i_ve_old,i_ve_new);
  BU_Pars := Pars;
end;

procedure TM.Read_Simulation_from_QPYClick(Sender: TObject);
begin
  Read_QPY_Sim;
end;

procedure TM.Read_QPY_Sim;
var p : integer;
    df_inpol,dG_inpol : TInpol;
begin
  if not(FileExists(Sim_File_fn)) then exit;
  assignfile(infile,Sim_File_fn); reset(infile);
  try
    p := 0;
    while not eof(infile) do begin
      inc(p);
      readln(infile,Nn_inpol[p],df_inpol[p],dG_inpol[p]);
    end;
  finally
    closefile(infile);
  end;
  n_inpol := p;
  for p := 1 to n_inpol do begin
    case i_model of
      j_model_AMF : begin df_SLA[p] := df_inpol[p]; dG_SLA[p] := dG_inpol[p]; end;
      j_model_Pe3 : begin df_Pe3[p] := df_inpol[p]; dG_Pe3[p] := dG_inpol[p]; end;
      j_model_Pe5 : begin df_Pe5[p] := df_inpol[p]; dG_Pe5[p] := dG_inpol[p]; end;
    end;
  end;
  Calc_Chisqr;
  Update_Graphs;
end;

Procedure TM.Read_QPY_FitPars;
begin
  MIO.System_Read(j_par_Sample, FitPars_From_QPY);
//  BU_Pars := Pars;
  Update_Values_Pars_panel;
  MIO.System_Write(j_par_Sample,QTMFile);
  Limits.Set_Colors_all;
end;

procedure TM.Write_to_QPY;
var ih : integer;
begin
  For_Python_File.WriteBool('Main','B_t_e_C',B_t_e_C);
  For_Python_File.WriteBool('Main','B_rho_e_C',B_rho_e_C);
  For_Python_File.WriteBool('Main','B_Jp_e_C',B_Jp_e_C);
  For_Python_File.WriteBool('Main','B_Jpp_e_C',B_Jpp_e_C);
  For_Python_File.WriteBool('Main','B_Jp_exp_e_C',B_Jp_exp_e_C);
  For_Python_File.WriteBool('Main','B_Jpp_exp_e_C',B_Jpp_exp_e_C);

  For_Python_File.WriteBool('Main','B_t_f_C',B_t_f_C);
  For_Python_File.WriteBool('Main','B_rho_f_C',B_rho_f_C);
  For_Python_File.WriteBool('Main','B_Jp_f_C',B_Jp_f_C);
  For_Python_File.WriteBool('Main','B_Jpp_f_C',B_Jpp_f_C);
  For_Python_File.WriteBool('Main','B_Jp_exp_f_C',B_Jp_exp_f_C);
  For_Python_File.WriteBool('Main','B_Jpp_exp_f_C',B_Jpp_exp_f_C);

  For_Python_File.WriteBool('Main','B_rho_b_C',B_rho_b_C);
  For_Python_File.WriteBool('Main','B_Jp_b_C',B_Jp_b_C);
  For_Python_File.WriteBool('Main','B_Jpp_b_C',B_Jpp_b_C);
  For_Python_File.WriteBool('Main','B_Jp_exp_b_C',B_Jp_exp_b_C);
  For_Python_File.WriteBool('Main','B_Jpp_exp_b_C',B_Jpp_exp_b_C);

  For_Python_File.WriteBool('Main','B_vers_C',B_vers_C);
  For_Python_File.WriteBool('Main','B_AspRat_C',B_AspRat_C);

  for ih := 1 to nhm do begin
  For_Python_File.WriteBool('Main','B_fit_inc' + inttostr(ih),B_fit_inc[ih]);
    For_Python_File.WriteFloat('Main','Df' + inttostr(ih),df[ih]);
    For_Python_File.WriteFloat('Main','DG' + inttostr(ih),dG[ih]);
    For_Python_File.WriteFloat('Main','n_arr[' + InttoStr(ih)+ ']',n_arr[ih]);
  end;

  For_Python_File.WriteInteger('Main','i_model',i_model);
  For_Python_File.WriteFloat('Main','x_axis_low_limit',x_axis_low_limit);
  For_Python_File.WriteFloat('Main','x_axis_up_limit',x_axis_up_limit);
  For_Python_File.WriteInteger('Main','i_action_PyQTM',i_action_PyQTM);
  For_Python_File.WriteInteger('Main','i_fit_df_dG',i_fit_df_dG);
  For_Python_File.WriteInteger('Main','i_wei_ninv',i_wei_ninv);
  For_Python_File.WriteBool('Limits','B_limits_active',B_limits_active);
  For_Python_File.WriteFloat('chi2_Landscape','lo_limit',chi2_Landscape.lo_limit);
  For_Python_File.WriteFloat('chi2_Landscape','up_limit',chi2_Landscape.up_limit);
  For_Python_File.WriteString('chi2_Landscape','Varied_Par',IO_labels[fit_pointer[chi2_Landscape.i_x_axis]]);
  For_Python_File.WriteInteger('Multiple','i_time_direction',Multiple.i_time_direction);
  For_Python_File.WriteInteger('Multiple','n_skip_dis',n_skip[Multiple.i_skip_dis]);

  For_Python_File.WriteFloat('Main','err_Df',err_Df);
  For_Python_File.WriteBool('Main','B_no_Graph_in_Python',B_no_Graph_in_Python);
  For_Python_File.WriteString('Settings','Sample_String',Sample_String);
  For_Python_File.WriteString('Settings','Info_String',Info_String);
  For_Python_File.WriteFloat('Settings','f_fund',f_fund);
  For_Python_File.WriteFloat('Settings','Zq',Zq);
  For_Python_File.WriteFloat('Settings','f_Jref',f_Jref);

  MIO.System_Write(j_par_Sample,     For_Python_File);
  MIO.System_Write(j_par_Ref, For_Python_File);
  MIO.System_Write(j_par_Limits_Min,     For_Python_File);
  MIO.System_Write(j_par_Limits_Max,     For_Python_File);
end;

procedure TM.Write_to_QPYmiClick(Sender: TObject);
begin
  B_no_Graph_in_Python := False;
  i_action_PyQTM := j_Python_Simulate; Write_to_QPY;
end;

procedure TM.FitWithPython(Sender: TObject);
begin
  i_action_PyQTM := j_Python_Fit; B_no_Graph_in_Python := True;
  Sim_File_fn := GetCurrentDir + '/PyQTM/~QPY_Sim.txt';
  i_fileage_old := fileage(Sim_File_fn);
  Write_to_QPY;
  if ExecuteExe(QPY_exe_fn) then begin
    WaitForPython(5);
    Read_QPY_Sim;
    Read_QPY_FitPars;
    Update_All;
    Update_Values;
    Update_Graphs;
  end;
end;

function TM.ExecuteExe(aExeName: string):boolean;
begin
  result := false;
  if FileExists(aExeName)
    then result := (ShellExecute(Application.Handle,'open',PChar(aExeName), '',PChar(ExtractFilePath(aExeName)),SW_SHOWNOACTIVATE) > 32);
end;

Function TM.WaitForPython(TimeOutTime: Double) : boolean;
var StartTick: Cardinal;
    B_TimeOut: Boolean;
begin
  StartTick := GetTickCount;
  repeat
    i_fileage_new := Fileage(Sim_File_fn); delay_secs(0.05);
    B_TimeOut := ((StartTick + TimeOutTime * 1000) < GetTickCount)
  until (i_fileage_new > i_fileage_old) or B_TimeOut;
  if B_TimeOut then Messagedlg('Timeout, PyQTM did not respond', mtwarning, [mbOK], 0);
  result := not(B_TimeOut);
end;

end.
