unit QTM_Multiple;
interface
uses Windows,Messages,SysUtils,Variants,Classes,Graphics,Controls,Forms,Inifiles,
  Dialogs,Pesgvcl,StdCtrls,Grids,ExtCtrls,QTM_Decl,pegrpapi,Clipbrd,Math,CheckLst,Menus,StrUtils,
  ComCtrls;
const n_skip : array[1..14] of integer = (1,2,3,4,5,10,20,50,100,200,500,1000,3000,10000); ColCount_Max = 5;
  j_ready_clear = 0; j_ready_selectRange = 2; j_ready_hidePoint = 3; j_ready_hideSet = 4; j_ready_hideRange = 5; j_ready_New_Zero = 6;
  j_ready_New_Zero_Fit_Ref = 7;
type
  TMultiple = class(TForm)
    df_graph: PESGraph; dg_graph: PESGraph; FitPars_Graph: PESGraph;
    i_y_axis_Combox: TComboBox; i_y_axis_par_Combox: TComboBox;
    i_guess_Combox: TComboBox; i_time_direction_Combox: TComboBox; i_skip_dis_Combox: TComboBox;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu; miNewRef: TMenuItem; miSelectRange: TMenuItem; miResultstoClipboard: TMenuItem;
    miHideSet: TMenuItem; miHidePoint: TMenuItem; miUnhide: TMenuItem; miHideRange: TMenuItem;
    B_fit_inc_clBox: TCheckListBox;
    Label5: TLabel; Label6: TLabel; Display_Panel: TPanel; Fit_Panel: TPanel; RunFits_Btn: TButton; Abort_Btn: TButton; Clear_Fits_Btn: TButton;
    DF_from_Main: PESGraph;
    DG_From_Main: PESGraph;
    ShowOverLImit: TCheckBox;
    AnnotImport_OpenDlg: TOpenDialog;
    df_Graph_to_clpbd_Btn: TButton;
    dG_Graph_to_clpbd_Btn: TButton;
    Pars_Graph_to_clpbd_Btn: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Label7: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    SG1: TStringGrid;
    i_format_Combox: TComboBox;
    Clear_Btn: TButton;
    Comment_Show: TEdit;
    i_skip_Combox: TComboBox;
    From_txt_Btn: TButton;
    TabSheet2: TTabSheet;
    FitParPanel: TPanel;
    FitPar1Panel: TPanel;
    FitPar1Label: TLabel;
    RadioButton1: TRadioButton;
    FitPar1Edit: TEdit;
    FitPar2Panel: TPanel;
    FitPar2Label: TLabel;
    RadioButton2: TRadioButton;
    FitPar2Edit: TEdit;
    FitPar3Panel: TPanel;
    FitPar3Label: TLabel;
    RadioButton3: TRadioButton;
    FitPar3Edit: TEdit;
    FitPar4Panel: TPanel;
    FitPar4Label: TLabel;
    RadioButton4: TRadioButton;
    FitPar4Edit: TEdit;
    FitPar5Panel: TPanel;
    FitPar5Label: TLabel;
    RadioButton5: TRadioButton;
    FitPar5Edit: TEdit;
    FitPar6Panel: TPanel;
    FitPar6Label: TLabel;
    RadioButton6: TRadioButton;
    FitPar6Edit: TEdit;
    Fit_Btn: TButton;
    ActLimits_Btn: TButton;
    ConstPanel: TPanel;
    ConstParLabel: TLabel;
    fac_panel: TPanel;
    t10_Btn: TButton;
    b10_Btn: TButton;
    t5_Btn: TButton;
    b5_Btn: TButton;
    t2_Btn: TButton;
    b2_Btn: TButton;
    t1d5_Btn: TButton;
    b1d5_Btn: TButton;
    t1d1_Btn: TButton;
    b1d1_Btn: TButton;
    t1d01_Btn: TButton;
    b1d01_Btn: TButton;
    Accept_Btn: TButton;
    miRight: TMenuItem;
    miLeft: TMenuItem;
    i_MLAfr_UD: TUpDown;
    Discard_Btn: TButton;
    miHide1: TMenuItem;
    miExport: TMenuItem;
    miExportFitParameter1: TMenuItem;
    GenerateInfoforPython1mi: TMenuItem;
    ReadFitParsfromPython1mi: TMenuItem;
    Red_Label: TLabel;
    NewZeroFitMakeReferenc1: TMenuItem;
    nsmoEdit: TEdit;
    Label3: TLabel;

    procedure Read_Panel_Format;
    procedure Write_Panel_Format;
    procedure Status_Read;
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Update_Values;
    procedure Update_Freq_Graphs;
    procedure Update_df_dG_Graph(i_graph : Byte);
    procedure Update_FitPars_Graph;
    procedure Arrange;
    procedure Clear_BtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Show_Fit_Pars;
    procedure i_guess_ComboxChange(Sender: TObject);
    procedure Set_j_poi_inp;
    procedure From_HotSpots(Sender: TObject; DblClick,SubsetIndex,PointIndex: Integer);
    procedure i_format_ComboxChange(Sender: TObject);
    procedure i_skip_ComboxChange(Sender: TObject);
    procedure i_y_axis_par_ComboxChange(Sender: TObject);
    procedure i_y_axis_ComboxChange(Sender: TObject);
    procedure Comment_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure Initialize(B_fits_only : Boolean);
    procedure Load_Data;
    procedure Save_Data(Save_fn: string);
    procedure Clear_Fits_BtnClick(Sender: TObject);
    procedure miNewRefClick(Sender: TObject);
    procedure miSelectRangeClick(Sender: TObject);
    procedure miResultstoClipboardClick(Sender: TObject);
    procedure miHideSetClick(Sender: TObject);
    procedure i_time_direction_ComboxChange(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure ClearFits1Click(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure i_skip_dis_ComboxChange(Sender: TObject);
    procedure B_fit_inc_clBoxClickCheck(Sender: TObject);
    procedure Determine_B_Import_inc_QTZ(line : String);
    procedure Determine_B_Import_inc_QTools(line : String);
    procedure Determine_B_Import_inc_AWSensors(line : String);
    procedure From_txt_BtnClick(Sender: TObject);
    procedure miHidePointClick(Sender: TObject);
    procedure miUnhideClick(Sender: TObject);
    procedure miHideRangeClick(Sender: TObject);
    procedure RunFits_BtnClick(Sender: TObject);
    procedure Abort_BtnClick(Sender: TObject);
    procedure ClearReadyState;
    procedure ShowOverLImitClick(Sender: TObject);
    procedure GraphZoomIn(Sender: TObject);
    procedure GraphZoomOut(Sender: TObject);
    procedure miDFGraph1Click(Sender: TObject);
    procedure Smoothen;

    procedure df_Graph_to_clpbd_BtnClick(Sender: TObject);
    procedure dG_Graph_to_clpbd_BtnClick(Sender: TObject);
    procedure Pars_Graph_to_clpbd_BtnClick(Sender: TObject);
    procedure Check_nhmloc;
    procedure Fit_BtnClick(Sender: TObject);
    procedure FitParEditKeyPress(Sender: TObject; var Key: Char);
    procedure ActLimits_BtnClick(Sender: TObject);
    procedure FitParRadioButtonClick(Sender: TObject);
   procedure t10_BtnClick(Sender: TObject);
   procedure t5_BtnClick(Sender: TObject);
   procedure t2_BtnClick(Sender: TObject);
   procedure t1d5_BtnClick(Sender: TObject);
   procedure t1d1_BtnClick(Sender: TObject);
   procedure t1d01_BtnClick(Sender: TObject);
   procedure t1d001_BtnClick(Sender: TObject);
   procedure b1d001_BtnClick(Sender: TObject);
   procedure b1d01_BtnClick(Sender: TObject);
   procedure b1d1_BtnClick(Sender: TObject);
   procedure b1d5_BtnClick(Sender: TObject);
   procedure b2_BtnClick(Sender: TObject);
   procedure b5_BtnClick(Sender: TObject);
   procedure b10_BtnClick(Sender: TObject);
   procedure PageControl1Change(Sender: TObject);
   procedure AcceptFit1Click(Sender: TObject);
   procedure miRightClick(Sender: TObject);
   procedure miLeftClick(Sender: TObject);
   procedure Shift_i_PointSelected(i_dir : Integer);
   procedure i_MLAfr_UDMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
   procedure Discard_BtnClick(Sender: TObject);
   procedure miExportFitParameter1Click(Sender: TObject);
   procedure Import_from_txt_QTZ;
   procedure Import_from_txt_QTools;
   procedure Import_from_txt_AWSensors;
   procedure Change_VE_Pars;
   procedure fit_pars_to_Pars(i : integer);
   procedure Pars_to_fit_pars(i : integer);
   procedure Fit_From_Python;
//   Function WaitForPython(TimeOutMins: Double) : boolean;
//   function WaitForPython : boolean;
//   procedure TimeOutMins_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure GenerateInfoforPython1miClick(Sender: TObject);
    procedure ReadFitParsfromPython1miClick(Sender: TObject);
    procedure NewZeroFitMakeReferenc1Click(Sender: TObject);
    procedure nsmoEditKeyPress(Sender: TObject; var Key: Char);

  private
    MultipleGraphs: Array [1..3] of PESGraph;
    FitParEdits: Array [1..6] of TEdit;
    FitParLabels: Array [1..6] of TLabel;
    FitParPanels: Array [1..6] of TPanel;
    FitParRBtn: Array[1..6] of TRadioButton;
    n_pts,nhloc,n_dat : Integer;
    B_NoClick, B_ShowPointsoverLimit : Boolean;
    Multiple_Pars : TPars;
    i_fileage_old,i_fileage_new,i_fileage_finished_old,i_fileage_finished_new : integer;
    nsmo : integer;
//    TimeOutMins : Double;

    i_FitParRBtn: Byte;
    Procedure SetGraphSettings(i_Graph: integer);
    procedure Update_Freq_Graphs_Settings;
    procedure Update_Freq_Graphs_Value;
    Procedure UpdateGraphs;
    procedure AssignArrays;
    Procedure GraphZoomInEvent(Sender: TObject);
  public
    B_Stop,B_Update_Main,B_Fit_is_running : Boolean;
    time_arr,chisqr_arr,fp_avg_arr : array [1..n_dat_max] of Double;
    B_ShowAnnot: array[1..3] of Boolean;
    i_Hide : array [1..n_dat_max] of Integer;
    df_arr,dG_arr,df_arr_raw,dG_arr_raw,df_fit_arr,dG_fit_arr : array [1..nhm,1..n_dat_max] of Double;
    par_arr : array [1..n_dat_max] of TDouble_npar;
    i_y_axis,i_y_axis_par,n_hs_act,i_guess,i_skip,i_skip_dis,
    i_PointSelected,i_PointStart,i_PointStop,i_time_direction,i_ready, i_format : Integer;
    i_poi_arr,j_poi_inp : array[1..nhm] of Integer;
    B_import_inc : array[1..nhm] of Boolean;
    start_range,stop_range,mintime,maxtime : Double;
    comment,io_fn : String;
    infile,outfile : text;
    teststr : String;
    nhm_loc : Integer;
    test_Double : Double;
    guess_multiple  : TDouble_NP;
    procedure CommonGraphSettings(Graph: PESGraph);
    Procedure UpdateFitPars;
  end;

var Multiple: TMultiple;

implementation
uses QTM_MIO,QTM_Main,QTM_Fit,QTM_Limits,QTM_SLA, QTM_Settings;
{$R *.dfm}
procedure TMultiple.miRightClick(Sender: TObject); begin Shift_i_PointSelected(1); end;
procedure TMultiple.miLeftClick(Sender: TObject); begin Shift_i_PointSelected(-1); end;

procedure TMultiple.FormResize(Sender: TObject);
begin
  if B_NoClick then Exit;
  Write_Panel_Format;
  Arrange;
end;

procedure TMultiple.FormCreate(Sender: TObject);
begin
  Status_Read;
  AssignArrays;
end;

procedure TMultiple.AssignArrays;
begin
  MultipleGraphs[1] :=  df_graph;
  MultipleGraphs[2] :=  dg_graph;
  MultipleGraphs[3] :=  FitPars_Graph;

  FitParEdits[1] := FitPar1Edit;
  FitParEdits[2] := FitPar2Edit;
  FitParEdits[3] := FitPar3Edit;
  FitParEdits[4] := FitPar4Edit;
  FitParEdits[5] := FitPar5Edit;
  FitParEdits[6] := FitPar6Edit;

  FitParLabels[1] := FitPar1Label;
  FitParLabels[2] := FitPar2Label;
  FitParLabels[3] := FitPar3Label;
  FitParLabels[4] := FitPar4Label;
  FitParLabels[5] := FitPar5Label;
  FitParLabels[6] := FitPar6Label;

  FitParPanels[1] := FitPar1Panel;
  FitParPanels[2] := FitPar2Panel;
  FitParPanels[3] := FitPar3Panel;
  FitParPanels[4] := FitPar4Panel;
  FitParPanels[5] := FitPar5Panel;
  FitParPanels[6] := FitPar6Panel;

  FitParRBtn[1] := RadioButton1;
  FitParRBtn[2] := RadioButton2;
  FitParRBtn[3] := RadioButton3;
  FitParRBtn[4] := RadioButton4;
  FitParRBtn[5] := RadioButton5;
  FitParRBtn[6] := RadioButton6;
end;

procedure TMultiple.miNewRefClick(Sender: TObject);
begin
  if i_ready = j_ready_New_Zero then ClearReadyState
  else begin
    i_ready := j_ready_New_Zero;
    Red_Label.Caption := 'Click onto Data Point,Upper Graph';
    Red_Label.Visible := True;
  end;
end;

procedure TMultiple.NewZeroFitMakeReferenc1Click(Sender: TObject);
begin
  if i_ready = j_ready_New_Zero_Fit_Ref then ClearReadyState
  else begin
    i_ready := j_ready_New_Zero_Fit_Ref;
    Red_Label.Caption := 'Click onto Data Point,Upper Graph';
    Red_Label.Visible := True;
  end;
end;

procedure TMultiple.miSelectRangeClick(Sender: TObject);
begin
  if i_ready = j_ready_SelectRange then ClearReadyState
  else begin
    i_ready := j_ready_SelectRange;
    Red_Label.Caption := 'Drag over upper Graph';
    Red_Label.Visible := True;
  end;
end;

procedure TMultiple.miHideSetClick(Sender: TObject);
begin
  if i_ready = j_ready_HideSet then ClearReadyState
  else begin
    i_ready := j_ready_HideSet;
    Red_Label.Caption := 'Click onto Data Point';
    Red_Label.Visible := True;
  end;
end;

procedure TMultiple.miHideRangeClick(Sender: TObject);
begin
  if i_ready = j_ready_HideRange then ClearReadyState
  else begin
    i_ready := j_ready_HideRange;
    Red_Label.Caption := 'Drag over Data Range';
    Red_Label.Visible := True;
  end;
end;

procedure TMultiple.miHidePointClick(Sender: TObject);
begin
  if i_ready = j_ready_HidePoint then ClearReadyState
  else begin
    i_ready := j_ready_HidePoint;
    Red_Label.Caption := 'Click onto Data Point';
    Red_Label.Visible := True;
  end;
end;


procedure TMultiple.Update_Freq_Graphs;
begin
  Update_Freq_Graphs_Settings;
  Update_Freq_Graphs_Value;
end;

procedure TMultiple.Update_Freq_Graphs_Value;
begin
  Update_df_dG_Graph(1);
  Update_df_dG_Graph(2);
end;

procedure TMultiple.Update_Freq_Graphs_Settings;
begin
  SetGraphSettings(1);
  SetGraphSettings(2);
end;

procedure TMultiple.FormDeactivate(Sender: TObject); begin Write_Panel_Format; end;

procedure TMultiple.Abort_BtnClick(Sender: TObject);
begin
  B_Stop := True;
  B_from_Multiple := False;
  assignfile(outfile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Abort.txt'); Rewrite(outfile); Writeln(outfile,1); closefile(outfile);
end;

procedure TMultiple.Clear1Click(Sender: TObject); begin Initialize(False); end;
procedure TMultiple.ClearFits1Click(Sender: TObject); begin Initialize(True); end;

procedure TMultiple.From_txt_BtnClick(Sender: TObject);
begin
  case i_format of
    1 : Import_from_txt_QTZ;
    2 : Import_from_txt_AWSensors;
    3 : Import_from_txt_QTools;
  end;
end;

procedure TMultiple.Import_from_txt_QTZ;
var ic,j,ih,i : integer;
    line : String;
begin
  for ih := 1 to nhm do begin
    for i := 1 to n_dat_max do begin
      df_arr_raw[ih,i] := GapV;
      dG_arr_raw[ih,i] := GapV;
    end;
  end;
  OpenDialog1.InitialDir := ExtractFilePath(ParamStr(0));
  OpenDialog1.Filter := 'Raw Data from QTZ(*.txt)|*.txt';
  OpenDialog1.Title := 'Load';
  if OpenDialog1.Execute then begin
    Screen.Cursor := crHourglass; Application.ProcessMessages;
    Initialize(False);
    assignfile(infile,OpenDialog1.filename);
    assignfile(outfile,ChangeFileExt(OpenDialog1.filename,'.tx2'));
    reset(infile); rewrite(outfile);
    try
      while not eof(infile) do begin
        readln(infile,line);
        for j := 1 to length(line) do if line[j] = ',' then line[j] := '.';
        writeln(outfile,line);
      end;
    finally
      closefile(infile);
      closefile(outfile);
    end;
    assignfile(infile,ChangeFileExt(OpenDialog1.filename,'.tx2')); reset(infile);
    readln(infile,line);
    try
      Determine_B_Import_inc_QTZ(line);
      ic := 0;
      while not eof(infile) do begin
        inc(ic);
        if ic <= n_dat_max then begin
          read(infile,time_arr[ic]);
          if ic <= Colcount_max then SG1.Cells[0,ic] := FloatToStrF(time_arr[ic],fffixed,8,3);
          for j := 1 to nhloc do begin
            read(infile,df_arr_raw[j_poi_inp[j],ic]);
            df_arr_raw[j_poi_inp[j],ic] := df_arr_raw[j_poi_inp[j],ic] * n_arr[j_poi_inp[j]];
            read(infile,dG_arr_raw[j_poi_inp[j],ic]);
            dG_arr_raw[j_poi_inp[j],ic] := dG_arr_raw[j_poi_inp[j],ic] * n_arr[j_poi_inp[j]] * f_fund / 2;
          end;
          if ic <= SG1.Rowcount - 1  then begin
            SG1.Cells[2*j-1,ic] := FloatToStrF(df_arr_raw[j_poi_inp[j],ic],fffixed,8,3);
            SG1.Cells[2*j  ,ic] := FloatToStrF(dG_arr_raw[j_poi_inp[j],ic],fffixed,8,3);
          end;
          readln(infile);
          case i_skip of
            2 : readln(infile);
            3 : for j := 1 to 2   do readln(infile);
            4 : for j := 1 to 3   do readln(infile);
            5 : for j := 1 to 5   do readln(infile);
            6 : for j := 1 to 10  do readln(infile);
            7 : for j := 1 to 20  do readln(infile);
            8 : for j := 1 to 50  do readln(infile);
            9 : for j := 1 to 100 do readln(infile);
          end;
        end;
      end;
    finally
      closefile(infile);
    end;
  end;
  Smoothen;
  n_dat := ic; SG1.Refresh; Screen.Cursor := crDefault;
  Update_Values;
  Smoothen;
  Update_Freq_Graphs;
  start_range := time_arr[i_PointStart];
  stop_range  := time_arr[i_PointStop];
  Save_Data(tmp_fn[j_qtm]);
end;

procedure TMultiple.Import_from_txt_QTools;
var ic : longint;
    j,ih,i : integer;
    line : String;
begin
  for ih := 1 to nhm do begin
    for i := 1 to n_dat_max do begin
      df_arr_raw[ih,i] := GapV;
      dG_arr_raw[ih,i] := GapV;
    end;
  end;

  OpenDialog1.InitialDir := ExtractFilePath(ParamStr(0));
  OpenDialog1.Filter := 'Raw Data from Q-Tools(*.txt)|*.txt';
  OpenDialog1.Title := 'Load';
  if OpenDialog1.Execute then begin
    Screen.Cursor := crHourglass; Application.ProcessMessages;
    Initialize(False);
    assignfile(infile,OpenDialog1.filename);
    assignfile(outfile,ChangeFileExt(OpenDialog1.filename,'.tx2'));
    reset(infile); rewrite(outfile);
    try
      while not eof(infile) do begin
        readln(infile,line);
        for j := 1 to length(line) do if line[j] = ',' then line[j] := '.';
        writeln(outfile,line);
      end;
    finally
      closefile(infile); closefile(outfile);
    end;
    assignfile(infile,ChangeFileExt(OpenDialog1.filename,'.tx2')); reset(infile);
    readln(infile,line);
    try
      Determine_B_Import_inc_QTools(line);
      ic := 0;
      while not eof(infile) do begin
        inc(ic); if ic = n_dat_max then exit;
        if ic <= n_dat_max then begin
          read(infile,time_arr[ic]);
          if ic <= Colcount_max then SG1.Cells[0,ic] := FloatToStrF(time_arr[ic],fffixed,8,3);
          for j := 1 to nhloc do begin
            read(infile,df_arr_raw[j_poi_inp[j],ic]);
            df_arr_raw[j_poi_inp[j],ic] := df_arr_raw[j_poi_inp[j],ic] * n_arr[j_poi_inp[j]];
            read(infile,dG_arr_raw[j_poi_inp[j],ic]);
            dG_arr_raw[j_poi_inp[j],ic] := dG_arr_raw[j_poi_inp[j],ic] * n_arr[j_poi_inp[j]] * f_fund * 1e-6 / 2;
            if ic <= SG1.Rowcount - 1  then begin
              SG1.Cells[2*j-1,ic] := FloatToStrF(df_arr_raw[j_poi_inp[j],ic],fffixed,8,3);
              SG1.Cells[2*j  ,ic] := FloatToStrF(dG_arr_raw[j_poi_inp[j],ic],fffixed,8,3);
            end;
          end;
          readln(infile);
          case i_skip of
            2 : readln(infile);
            3 : for j := 1 to 2   do readln(infile);
            4 : for j := 1 to 3   do readln(infile);
            5 : for j := 1 to 5   do readln(infile);
            6 : for j := 1 to 10  do readln(infile);
            7 : for j := 1 to 20  do readln(infile);
            8 : for j := 1 to 50  do readln(infile);
            9 : for j := 1 to 100 do readln(infile);
          end;
        end;
      end;
    finally
      closefile(infile);
    end;
  end;
  n_dat := ic; SG1.Refresh; Screen.Cursor := crDefault;
  Update_Values;
  Smoothen;
  Update_Freq_Graphs;
  start_range := time_arr[i_PointStart];
  stop_range  := time_arr[i_PointStop];
  Save_Data(tmp_fn[j_qtm]);
end;

procedure TMultiple.Import_from_txt_AWSensors;
var ic,j,ih,i : integer;
    line : String;
begin
  for ih := 1 to nhm do begin
    for i := 1 to n_dat_max do begin
      df_arr_raw[ih,i] := GapV;
      dG_arr_raw[ih,i] := GapV;
    end;
  end;
  OpenDialog1.InitialDir := ExtractFilePath(ParamStr(0));
  OpenDialog1.Filter := 'Raw Data from AWSensors(*.txt)|*.txt';
  OpenDialog1.Title := 'Load';
  if OpenDialog1.Execute then begin
    Screen.Cursor := crHourglass; Application.ProcessMessages;
    Initialize(False);
    assignfile(infile,OpenDialog1.filename);
    assignfile(outfile,ChangeFileExt(OpenDialog1.filename,'.tx2'));
    reset(infile); rewrite(outfile);
    try
      while not eof(infile) do begin
        readln(infile,line);
        for j := 1 to length(line) do if line[j] = ',' then line[j] := '.';
        writeln(outfile,line);
      end;
    finally
      closefile(infile);
      closefile(outfile);
    end;
    assignfile(infile,ChangeFileExt(OpenDialog1.filename,'.tx2')); reset(infile);
    readln(infile,line);
    try
      Determine_B_Import_inc_AWSensors(line);
      ic := 0;
      while not eof(infile) do begin
        inc(ic);
        if ic <= n_dat_max then begin
          read(infile,time_arr[ic]);
          if ic <= Colcount_max then SG1.Cells[0,ic] := FloatToStrF(time_arr[ic],fffixed,8,3);
          for j := 1 to nhloc do begin
            read(infile,df_arr_raw[j_poi_inp[j],ic]);
            df_arr_raw[j_poi_inp[j],ic] := df_arr_raw[j_poi_inp[j],ic] * n_arr[j_poi_inp[j]];
          end;
          for j := 1 to nhloc do begin
            read(infile,dG_arr_raw[j_poi_inp[j],ic]);
            dG_arr_raw[j_poi_inp[j],ic] := dG_arr_raw[j_poi_inp[j],ic] * n_arr[j_poi_inp[j]] * f_fund / 2;
            if ic <= SG1.Rowcount - 1  then begin
              SG1.Cells[2*j-1,ic] := FloatToStrF(df_arr_raw[j_poi_inp[j],ic],fffixed,8,3);
              SG1.Cells[2*j  ,ic] := FloatToStrF(dG_arr_raw[j_poi_inp[j],ic],fffixed,8,3);
            end;
          end;
          readln(infile);
          case i_skip of
            2 : readln(infile);
            3 : for j := 1 to 2   do readln(infile);
            4 : for j := 1 to 3   do readln(infile);
            5 : for j := 1 to 5   do readln(infile);
            6 : for j := 1 to 10  do readln(infile);
            7 : for j := 1 to 20  do readln(infile);
            8 : for j := 1 to 50  do readln(infile);
            9 : for j := 1 to 100 do readln(infile);
          end;
        end;
      end;
    finally
      closefile(infile);
    end;
  end;
  n_dat := ic; SG1.Refresh; Screen.Cursor := crDefault;
  Update_Values;
  Smoothen;
  Update_Freq_Graphs;
  start_range := time_arr[i_PointStart];
  stop_range  := time_arr[i_PointStop];
  Save_Data(tmp_fn[j_qtm]);
end;

procedure TMultiple.miUnhideClick(Sender: TObject);
var i,j : Integer;
begin
  for i := 1 to n_dat do i_hide[i] := 0;
  B_no_Model := False;
  Save_Data(tmp_fn[j_qtm]); Update_Freq_Graphs; Update_FitPars_Graph;
  M.Update_All;
end;

procedure TMultiple.Status_Read;
var i : Integer;
begin
//  TimeOutMins := QTMFile.ReadFloat('Multiple','TimeOutMins',1);
  nsmo := QTMFile.ReadInteger('Multiple','nsmo',1);
  i_skip := QTMFile.ReadInteger('Multiple','i_skip',1);
  i_skip_dis := QTMFile.ReadInteger('Multiple','i_skip_dis',5);
  i_guess := QTMFile.ReadInteger('Multiple','i_guess',1);
  i_y_axis := QTMFile.ReadInteger('Multiple','i_y_axis',1);
  i_y_axis_par := QTMFile.ReadInteger('Multiple','i_y_axis_par',1);
  i_time_direction := QTMFile.ReadInteger('Multiple','i_time_direction',1);
  i_format := Ini.ReadInteger('Multiple','i_format',1);
  comment := QTMFile.ReadString('Multiple','comment','');
  i_PointSelected := QTMFile.ReadInteger('Multiple','i_PointSelected',1);
  i_PointStart := QTMFile.ReadInteger('Multiple','i_PointStart',1);
  i_PointStop := QTMFile.ReadInteger('Multiple','i_PointStop',1);
  B_ShowPointsoverLimit := QTMFile.ReadBool('Multiple','B_ShowPointsoverLimit',false);
  B_Stop := true;
  for i := 1 to nhm do B_Import_inc[i] := QTMFile.ReadBool('Multiple','B_Import_inc' + inttostr(i),True);
  nhloc := 0; for i := 1 to nhm do if B_Import_inc[i] then inc(nhloc);
  i_FitParRBtn := 1;
end;

procedure TMultiple.FormShow(Sender: TObject);
var ih : Integer;
begin
  B_NoClick := True;
  B_Fit_is_running := False;
  Read_Panel_Format;
  Arrange;
  Initialize(False);
  Load_Data;
  if i_hide[i_PointSelected] = 0 then B_no_model := False else B_no_model := True;
  Update_Values; Update_Freq_Graphs; Update_FitPars_Graph; UpdateFitPars;
  for ih := 1 to nhm do begin
    df[ih] := df_arr[ih,i_PointSelected];
    dG[ih] := dG_arr[ih,i_PointSelected];
    QTMFile.WriteFloat('Main','Df' + inttostr(ih),df[ih]);
    QTMFile.WriteFloat('Main','DG' + inttostr(ih),dG[ih]);
  end;
  Red_Label.Visible := False; Red_Label.BringToFront;
  i_ready := 0;
  PageControl1.TabIndex := QTMFile.ReadInteger('Multiple', 'PageControlIndex', 0);
  PageControl1Change(nil);
  FitParRadioButtonClick(FitParRBtn[1]);
  B_NoClick := False;
end;

procedure TMultiple.Read_Panel_Format;
begin
  Top := Ini.ReadInteger('Multiple','Top',0);   Height := Ini.ReadInteger('Multiple','Height',300);
  Left := Ini.ReadInteger('Multiple','Left',0); Width := Ini.ReadInteger('Multiple','Width',500);
end;

procedure TMultiple.Write_Panel_Format;
begin
  if B_NoClick then Exit;
  Ini.WriteInteger('Multiple','Top',Top);   Ini.WriteInteger('Multiple','Height',Height);
  Ini.WriteInteger('Multiple','Left',Left); Ini.WriteInteger('Multiple','Width',Width);
  B_Changed := True; 
end;

procedure TMultiple.Arrange;
begin
  df_Graph.Left := Panel1.Left + Panel1.Width + 5;
  dG_Graph.Left := df_Graph.Left;
  FitPars_Graph.Left := df_Graph.Left;

  df_Graph.Width := ClientWidth - df_Graph.Left - 5;
  dG_Graph.Width := df_Graph.Width;
  FitPars_Graph.Width := df_Graph.Width;

  df_Graph.Height := Round(1/3 * ClientHeight) - 2;
  dG_Graph.Height := df_Graph.Height;
  FitPars_Graph.Height := df_Graph.Height;

  df_Graph.Top := 1;
  dG_Graph.Top := df_Graph.Top + df_Graph.Height + 1;
  FitPars_Graph.Top := dG_Graph.Top + dG_Graph.Height + 1;

  DF_from_Main.Top := PageControl1.Top + PageControl1.Height + 1;
  DF_from_Main.Left := PageControl1.Left;
  DF_from_Main.Height := (ClientHeight - DF_from_Main.Top) div 2 - 4;
  DF_from_Main.Width :=  PageControl1.Width;

  DG_From_Main.Width := DF_from_Main.Width;
  DG_From_Main.Height := DF_from_Main.Height;
  DG_From_Main.Top := DF_from_Main.Top + DF_from_Main.Height + 1;
  DG_From_Main.Left := DF_from_Main.Left;


  ShowOverLImit.Top := FitPars_Graph.Top + FitPars_Graph.Height - ShowOverLImit.Height;
  ShowOverLImit.Left := FitPars_Graph.Left + FitPars_Graph.Width - ShowOverLImit.width;

  df_Graph_to_clpbd_Btn.Left := df_Graph.Left + df_Graph.Width  - df_Graph_to_clpbd_Btn.Width  - 2;
  df_Graph_to_clpbd_Btn.Top  := df_Graph.Top + df_Graph.Height - df_Graph_to_clpbd_Btn.Height - 1;
  dG_Graph_to_clpbd_Btn.Left := dG_Graph.Left + dG_Graph.Width  - dG_Graph_to_clpbd_Btn.Width  - 2;
  dG_Graph_to_clpbd_Btn.Top  := dG_Graph.Top + dG_Graph.Height - dG_Graph_to_clpbd_Btn.Height - 1;
  Pars_Graph_to_clpbd_Btn.Left := FitPars_Graph.Left + FitPars_Graph.Width  - Pars_Graph_to_clpbd_Btn.Width  - 2;
  Pars_Graph_to_clpbd_Btn.Top  := FitPars_Graph.Top + 2;
  Pars_Graph_to_clpbd_Btn.Top  := FitPars_Graph.Top + FitPars_Graph.Height - Pars_Graph_to_clpbd_Btn.Height - 1;

  FitParPanel.Top := Panel1.Top;
  FitParPanel.Left := Panel1.Left;
  FitParPanel.Height := Panel1.Height;
  FitParPanel.Width  := Panel1.Width;
end;

procedure TMultiple.Update_Values;
var i,j : Integer;
begin
//  GenerateInfoforPython1mi.visible := not B_Python_Installed;
//  ReadFitParsfromPython1mi.visible := not B_Python_Installed;
  i_guess_Combox.visible := i_fit_method = 1;
//  TimeOutMins_Show.visible := B_Python_Installed and (i_fit_method_multiple = 2);
//  TimeOutMins_Label.visible := B_Python_Installed and (i_fit_method_multiple = 2);
//  TimeOutMins_Show.Text := FloatToStrF(TimeOutMins, fffixed, 8, 3);
  i_format_Combox.Clear;
  i_format_Combox.Items.Add('Df [Hz], DG[Hz]');
  i_format_Combox.Items.Add('Df/n [Hz], DD (AWS)');
  i_format_Combox.Items.Add('Df/n [Hz], DD[10^-6] (QS)');
  i_format_Combox.Refresh;
  Multiple.UpdateFitPars;
  ShowOverLImit.Visible := B_Limits_Active;
  Caption := 'Analyze Time Traces ' + ChangeFileExt(qtm_fn,'.qtd');
  Set_j_poi_inp; Screen.Cursor := crDefault;
  i_time_direction_Combox.ItemIndex := i_time_direction - 1;
  i_format_Combox.ItemIndex := i_format - 1;
  if B_stop then begin
    i_y_axis_Combox.ItemIndex := i_y_axis - 1;
    i_y_axis_par_Combox.Clear;
    for i := 1 to n_fit_pars do i_y_axis_par_Combox.Items.Add(MIO.Graph_Labels(fit_pointer[i]));
    i_y_axis_par_Combox.Items.Add('chi^2');
    i_y_axis_par_Combox.Refresh;
    i_y_axis_par_Combox.ItemIndex := i_y_axis_par - 1;
  end;
//  i_fit_method_multiple_Combox.ItemIndex := i_fit_method_multiple - 1;

  Application.ProcessMessages;
  nsmoEdit.Text := IntToStr(nsmo);
  i_skip_Combox.itemIndex := i_skip - 1;
  i_skip_dis_Combox.itemIndex := i_skip_dis - 1;
  i_guess_combox.itemIndex := i_guess - 1;
  comment_Show.Text := Comment;
  B_fit_inc_clBox.Clear; for i := 1 to nhm do B_fit_inc_clBox.Items.Add(FloatToStrF(n_arr[i],fffixed,5,2));
  B_fit_inc_clBox.Update;
  for i := 1 to nhm do B_fit_inc_clBox.Checked[i-1] := B_Fit_inc[i];
  with SG1 do begin
    ColCount := 2 * nhloc + 1;
    Cells[0,0] := 'time [a.u.]';
    for i := 1 to min(RowCount,n_dat) do begin
      if time_arr[i] <> GapV then Cells[0,i] := FloatToStrf(time_arr[i],fffixed,8,3) else Cells[i,1] := '';
    end;
    for j := 1 to nhloc do begin
      if j_poi_inp[j] > 0 then begin
        case i_dfDG_DfnDD of
          1 : begin
            Cells[2*j-1,0] := 'Df ' + FloatToStrF(n_arr[j],fffixed,3,1);
            Cells[2*j,0  ] := 'DG ' + FloatToStrF(n_arr[j],fffixed,3,1);
          end;
          2 : begin
            Cells[2*j-1,0] := 'Fn ' + FloatToStrF(n_arr[j],fffixed,3,1);
            Cells[2*j,0  ] := 'DD ' + FloatToStrF(n_arr[j],fffixed,3,1);
          end;
        end;
      end else begin Cells[2*j-1,0] := ''; Cells[2*j,0] := ''; end;
    end;
    for i := 1 to min(RowCount-1,n_dat) do begin
      for j := 1 to nhloc do begin
        case i_dfDG_DfnDD of
          1 : begin
            if df_arr_raw[j,i] <> GapV then Cells[2*j-1,i] := FloatToStrf(df_arr_raw[j,i],fffixed,8,2) else Cells[2*j-1,i] := '';
            if dG_arr_raw[j,i] <> GapV then Cells[2*j,i]   := FloatToStrf(dG_arr_raw[j,i],fffixed,8,2) else Cells[2*j  ,i] := '';
          end;
          2 : begin
            if df_arr_raw[j,i] <> GapV then Cells[2*j-1,i] := FloatToStrf(    df_arr_raw[j,i] / n_arr[j],fffixed,8,2) else Cells[2*j-1,i] := '';
            if dG_arr_raw[j,i] <> GapV then Cells[2*j,i]   := FloatToStrf(2 * dG_arr_raw[j,i] / n_arr[j] / f_fund * 1e6,fffixed,8,2) else Cells[2*j,i] := '';
          end;
        end;
      end;
    end;
  end;
end;

Procedure TMultiple.SetGraphSettings(i_Graph: integer);
var graph : PESGraph;
    j,s,p : Integer;
begin
  case i_graph of  1 : graph := df_Graph; 2: graph := dG_Graph; end;
  with Graph do begin
    PEactions := sgreset;                   CursorPromptTracking := True;
    CursorPromptStyle := sgXandYValue;      AllowZooming := sgHorzPlusVertZooming;
    AllowDataHotSpots := True;              FontSize := sgLarge;
    ShadowColor := clNone;                  DataShadows := sgNo3D;
    GridLineControl := sgNoGrid;            NullDataValueX := GapV;
    NullDataValueY := GapV;                 PointSize := sgMicroPoints;
    MainTitle := ''; Subtitle := '';
    n_hs_act := 0;
    for j := 1 to nhm do begin
      if B_Import_inc[j] and B_fit_inc[j] then begin
        n_hs_act := n_hs_act + 1; i_poi_arr[n_hs_act] := j;
      end;
    end;
    Subsets := 2 * n_hs_act;
    ComparisonSubsets := n_hs_act;
    if Subsets = 0 then Subsets := 1;
    PlottingMethod := sgpoint;
    PlottingMethodII := sgline2;
    for s := 1 to n_hs_act do begin
      case i_graph of
        1 : begin
          case i_y_axis of
            1 : Subsetlabels[s-1] := 'Df_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            2,4,5 : Subsetlabels[s-1] := 'Df_by_n_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            3 : Subsetlabels[s-1] := 'Df_by_sqrtn_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
          end;
        end;
        2 : begin
          case i_y_axis of
            1,5 : Subsetlabels[s-1] := 'DG_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            2 : Subsetlabels[s-1] := 'DG_by_n_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            3 : Subsetlabels[s-1] := 'DG_by_sqrtn_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            4 : Subsetlabels[s-1] := 'DDiss_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
          end;
        end;
      end;
      Subsetcolors[s-1] := QTZ_Colors[i_poi_arr[s]];
      SubsetLineTypes[s-1] := PELT_ThinSOLID;
      SubsetPointTypes[s-1] := PEPT_DOT;
      case i_graph of
        1 : begin
          case i_y_axis of
            1 : Subsetlabels[s+n_hs_act-1] := 'Df_fit_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            2,4,5 : Subsetlabels[s+n_hs_act-1] := 'Df_by_n_fit_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            3 : Subsetlabels[s+n_hs_act-1] := 'Df_by_sqrtn_fit_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
          end;
        end;
        2 : begin
          case i_y_axis of
            1,5 : Subsetlabels[s+n_hs_act-1] := 'DG_fit_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            2 : Subsetlabels[s+n_hs_act-1] := 'DG_by_n_fit_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            3 : Subsetlabels[s+n_hs_act-1] := 'DG_by_sqrtn_fit_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
            4 : Subsetlabels[s+n_hs_act-1] := 'DDiss_fit_' + FloattoStrF(n_arr[i_poi_arr[s]],fffixed,3,1);
          end;
        end;
      end;
      Subsetcolors[s+n_hs_act-1] := QTZ_Colors[i_poi_arr[s]];
      SubsetLineTypes[s+n_hs_act-1] := PELT_ThickSOLID;
    end;
    Points := n_dat;
    XaxisLabel := 'time [a.u.]';
    case i_graph of
      1 : begin
        case i_y_axis of
          1 :     YaxisLabel := 'Df [Hz]';
          2,4,5 : YaxisLabel := 'Df/n [Hz]';
          3 :     YaxisLabel := 'Df/sqrt(n) [Hz]';
        end;
      end;
      2 : begin
        case i_y_axis of
          1 : YaxisLabel := 'DG [Hz]';
          2 : YaxisLabel := 'DG/n [Hz]';
          3 : YaxisLabel := 'DG/sqrt(n) [Hz]';
          4 : YaxisLabel := 'DD * 10^6';
          5 : YaxisLabel := 'DG / (-Df)';
        end;
      end;
    end;
    for p := 1 to Points do begin
      for s := 1 to subsets do begin
        XData[s-1,p-1] := GapV;
        YData[s-1,p-1] := GapV;
      end;
    end;
    PEactions := sgReinitAndReset;
  end;//with
end;

Procedure TMultiple.UpdateGraphs;
begin
  Multiple.Update_df_dG_Graph(1);
  Multiple.Update_df_dG_Graph(2);
  Multiple.Update_FitPars_Graph;
end;

procedure TMultiple.Update_df_dG_Graph(i_graph : Byte);
var graph : PESGraph;
    s,p : Integer;
begin
  mintime := 1e22; maxtime := -1e22;
  for p := 1 to n_dat do begin
    if (time_arr[p] <> GapV) and (time_arr[p] > maxtime) then maxtime := time_arr[p];
    if (time_arr[p] <> GapV) and (time_arr[p] < mintime) then mintime := time_arr[p];
  end;
  case i_graph of  1 : graph := df_Graph; 2: graph := dG_Graph; end;
  with Graph do begin
    for p := 1 to Points do begin
      for s := 1 to n_hs_act do begin
        if time_arr[p] <> GapV then XData[s-1,p-1] := time_arr[p]          else XData[s-1,p-1] := GapV;
        if time_arr[p] <> GapV then XData[s+n_hs_act-1,p-1] := time_arr[p] else XData[s+n_hs_act-1,p-1] := GapV;
        if i_poi_arr[s] > 0 then begin
          case i_graph of
            1 : begin
              if (df_arr[i_poi_arr[s],p] = GapV) or (i_hide[p] = 1) then YData[s-1,p-1] := GapV
              else begin
                case i_y_axis of
                  1 : YData[s-1,p-1] := df_arr[i_poi_arr[s],p];
                  2,4,5 : YData[s-1,p-1] := df_arr[i_poi_arr[s],p] / n_arr[i_poi_arr[s]];
                  3 : YData[s-1,p-1] := df_arr[i_poi_arr[s],p] / Sqrt(n_arr[i_poi_arr[s]]);
                end;
                if df_arr[i_poi_arr[s],p] = GapV then YData[s-1,p-1] := GapV;
              end;
              if (df_fit_arr[i_poi_arr[s],p] <> GapV) then begin
                case i_y_axis of
                  1 : YData[s+n_hs_act-1,p-1] := df_fit_arr[i_poi_arr[s],p];
                  2,4,5 : YData[s+n_hs_act-1,p-1] := df_fit_arr[i_poi_arr[s],p] / n_arr[i_poi_arr[s]];
                  3 : YData[s+n_hs_act-1,p-1] := df_fit_arr[i_poi_arr[s],p] / Sqrt(n_arr[i_poi_arr[s]]);
                end;
                if df_fit_arr[i_poi_arr[s],p] = GapV then YData[s+n_hs_act-1,p-1] := GapV;
              end else YData[s+n_hs_act-1,p-1] := GapV;
            end;
            2 : begin
              if (dG_arr[i_poi_arr[s],p] = GapV) or (i_hide[p] = 1) then YData[s-1,p-1] := GapV
              else begin
                case i_y_axis of
                  1 : YData[s-1,p-1] := dG_arr[i_poi_arr[s],p];
                  2 : YData[s-1,p-1] := dG_arr[i_poi_arr[s],p] / n_arr[i_poi_arr[s]];
                  3 : YData[s-1,p-1] := dG_arr[i_poi_arr[s],p] / Sqrt(n_arr[i_poi_arr[s]]);
                  4 : YData[s-1,p-1] := 2 * dG_arr[i_poi_arr[s],p] / n_arr[i_poi_arr[s]] / f_fund * 1e6;
                  5 : if abs(df_arr[i_poi_arr[s],p]) > 0.1 then
                      YData[s-1,p-1] := dG_arr[i_poi_arr[s],p] / (-df_arr[i_poi_arr[s],p])
                     else YData[s-1,p-1] := GapV;
                end;
                if dG_arr[i_poi_arr[s],p] = GapV then YData[s-1,p-1] := GapV;
              end;
              if (dG_fit_arr[i_poi_arr[s],p] <> GapV) then begin
                case i_y_axis of
                  1 : YData[s+n_hs_act-1,p-1] := dG_fit_arr[i_poi_arr[s],p];
                  2 : YData[s+n_hs_act-1,p-1] := dG_fit_arr[i_poi_arr[s],p] / n_arr[i_poi_arr[s]];
                  3 : YData[s+n_hs_act-1,p-1] := dG_fit_arr[i_poi_arr[s],p] / Sqrt(n_arr[i_poi_arr[s]]);
                  4 : YData[s+n_hs_act-1,p-1] := 2 * dG_fit_arr[i_poi_arr[s],p] / n_arr[i_poi_arr[s]] / f_fund * 1e6;
                  5 : if abs(df_fit_arr[i_poi_arr[s],p]) > 0.1 then
                      YData[s+n_hs_act-1,p-1] := dG_fit_arr[i_poi_arr[s],p] / (-df_fit_arr[i_poi_arr[s],p])
                     else YData[s-1,p-1] := GapV;
                end;
                if dG_fit_arr[i_poi_arr[s],p] = GapV then YData[s+n_hs_act-1,p-1] := GapV;
              end else YData[s+n_hs_act-1,p-1] := GapV;
            end;
          end;
        end;
      end;
    end;
    for p := 1 to Points do begin
      if i_hide[p] = 1 then begin
        for s := 1 to nhm do begin
          XData[s-1,p-1] := GapV;
          YData[s-1,p-1] := GapV;
        end;
      end;
    end;
    VertLineAnnotation[-1] := 0;
    ShowAnnotations := True;
    if (i_PointStart > 0) and (i_PointStart <= Points) then begin
      start_range := time_arr[i_PointStart];
      VertLineAnnotation[0] := time_arr[i_PointStart];
      VertLineAnnotationColor[0] := clblack;
      VertLineAnnotationType[0] := PELT_THICKSOLID;//PELT_THINSOLID;
    end;
    if (i_PointStop > 0) and (i_PointStop <= Points) then begin
      stop_range := time_arr[i_PointStop];
      VertLineAnnotation[1] := time_arr[i_PointStop];
      VertLineAnnotationColor[1] := clblack;
      VertLineAnnotationType[1] := PELT_THICKSOLID;//PELT_THINSOLID;
    end;
    if (i_PointSelected > 0) and (i_PointSelected <= Points) and (i_hide[i_PointSelected] = 0) then begin
      VertLineAnnotation[2] := time_arr[i_PointSelected];
      VertLineAnnotationColor[2] := clblue;
      VertLineAnnotationType[2] := PELT_THICKSOLID;//PELT_THINSOLID;
    end;
    if Points = 1 then begin
      for s := 1 to Subsets do Xdata[s-1,0] := GapV;
    end;
    ManualScaleControlX := sgManualMinandMax;
    ManualMinX := mintime - 0.05*(maxtime - mintime);
    ManualMaxX := maxtime + 0.05*(maxtime - mintime);
    PEactions := sgReinitAndReset;
  end;
end;

procedure TMultiple.CommonGraphSettings(Graph: PESGraph);
begin
  with Graph do begin
    CursorPromptTracking := True;
    CursorPromptStyle := sgXandYValue;        ScrollingHorzZoom := true;
    ScrollingVertZoom := true;                AllowZooming := sgHorzPlusVertZooming;
    AllowDataHotSpots := True;                FontSize := sgLarge;
    ShadowColor := clNone;                    DataShadows := sgNo3D;
    GridLineControl := sgNoGrid;              NullDataValueX := GapV;
    NullDataValueY := GapV;                   PlottingMethod := sgPointsPlusLine;
    PointSize := sgmicropoints;               SubsetLineTypes[0] := PELT_ThinSOLID;
    Subsetcolors[0] := clred;                 MainTitle := '';
    PEactions := sgReinitAndReset;            LogScaleExpLabels := false;
    AutoScaleData := False;
  end;
end;

procedure TMultiple.Update_FitPars_Graph;
var p,s : Integer;
begin
  with FitPars_Graph do begin
    CommonGraphSettings(FitPars_Graph);
    PlottingMethod := sgPoint;
    PointSize := sgMicroPoints;
    SubsetLabels[0] := 'Value';
    Subtitle := 'Fit parameters';
    Subsets := 1;
    for s := 1 to Subsets do begin XData[s-1,-1] := 0; YData[s-1,-1] := 0; end; { clear Graph x,y arrays }
    Points := df_Graph.Points;
    XaxisLabel := 'Time [a.u]';
    if i_y_axis_par <= n_fit_pars then begin
      YaxisLabel := MIO.Graph_Labels(fit_pointer[i_y_axis_par])
    end
    else begin
      if i_y_axis_par = n_fit_pars + 1 then YaxisLabel := 'chi^2' else YaxisLabel := '';
    end;
    for p := 1 to Points do begin
      for s := 1 to Subsets do XData[s-1,p-1] := time_arr[p];
      if (i_Hide[p] = 1) or ((i_y_axis_par <= n_fit_pars) and (par_arr[p,i_y_axis_par] = GapV)) or (Limits.IsOverLimit(par_arr[p]) and B_Limits_Active and not(B_ShowPointsoverLimit))
          or (i_y_axis_par > n_fit_pars + 1) or (i_y_axis_par < 0) then begin
        YData[0,p-1] := GapV
      end
      else begin
        if i_y_axis_par = n_fit_pars + 1 then begin
          YData[0,p-1] := chisqr_arr[p];
        end;
        if (i_y_axis_par <= n_fit_pars) then YData[0,p-1] := par_arr[p,i_y_axis_par];
      end;
    end;
    ManualScaleControlX := sgManualMinandMax;
    ManualMinX := mintime - 0.05*(maxtime - mintime);
    ManualMaxX := maxtime + 0.05*(maxtime - mintime);
    PEactions := sgReinitAndReset;
  end;
end;

procedure TMultiple.miResultstoClipboardClick(Sender: TObject);
var
  TextBuf,DateStr : String;
  s,p : integer;
begin
  Screen.Cursor := crHourglass;
  try
    DateTimeToString(DateStr,'yyyy-mm-dd_hh-nn-ss',Now);
    TextBuf := TextBuf + comment + #9 + io_fn  + #10;
    TextBuf := TextBuf + DateStr + #10;

    TextBuf := TextBuf + df_Graph.XAxisLabel +  #9;
    for s := 1 to df_Graph.Subsets do TextBuf := TextBuf + df_Graph.SubsetLabels[s-1] + #9;
    for s := 1 to dG_Graph.Subsets do TextBuf := TextBuf + dG_Graph.SubsetLabels[s-1] + #9;
    for s := 1 to n_fit_pars + 1 do begin
      if s <= n_fit_pars then TextBuf := TextBuf + MIO.Graph_Labels(fit_pointer[s]) + #9
      else if s = n_fit_pars + 1 then TextBuf := TextBuf + 'chi^2' + #9;
    end;
    TextBuf := TextBuf + #10;


    for p := 1 to df_Graph.Points do begin
      //write time
      if df_Graph.XData[0,p-1] <> GapV then begin
        TextBuf := TextBuf + FloatToStr(df_Graph.XData[0,p-1]*Power(10,df_Graph.ScaleforXData)) + #9;
        //write df an df Fit
        for s := 1 to Df_Graph.Subsets do begin
          if df_Graph.YData[s-1,p-1] <> GapV
            then TextBuf := TextBuf + FloatToStr(df_Graph.YData[s-1,p-1]*Power(10,df_Graph.ScaleforYData)) + #9
            else TextBuf := TextBuf  + #9;
        end;
        //write dG an dG Fit
        for s := 1 to DG_Graph.Subsets do begin
          if dG_Graph.YData[s-1,p-1] <> GapV
            then TextBuf := TextBuf + FloatToStr(dG_Graph.YData[s-1,p-1]*Power(10,dG_Graph.ScaleforYData)) + #9
            else TextBuf := TextBuf  + #9;
        end;
        for s := 1 to n_fit_pars do begin
          if par_arr[p,s] <> GapV
            then TextBuf := TextBuf + FloatToStr(par_arr[p,s])+ #9
            else  TextBuf := TextBuf + #9;
        end;
        if chisqr_arr[p] <> GapV
          then TextBuf := TextBuf + FloatToStr(chisqr_arr[p])+ #9
          else  TextBuf := TextBuf + #9;
        TextBuf := TextBuf + #10;
      end;
    end;
    MIO.ExportStrToClpb(TextBuf);
  finally Screen.Cursor := crDefault;
  end;
  Application.ProcessMessages;
end;

procedure TMultiple.i_format_ComboxChange(Sender: TObject);
begin
  if B_NoClick then Exit; i_format := i_format_Combox.ItemIndex + 1; Ini.WriteInteger('Multiple','i_format',i_format);
  B_Changed := True;
  Update_Values; M.Update_Values;
end;

procedure TMultiple.i_guess_ComboxChange(Sender: TObject);
begin
  i_guess := i_guess_Combox.ItemIndex + 1; QTMFile.WriteInteger('Multiple','i_guess',i_guess); B_Changed := True;
  Update_Values;
end;

{procedure TMultiple.i_fit_method_multiple_ComboxChange(Sender: TObject);
begin
  i_fit_method_multiple := i_fit_method_multiple_Combox.ItemIndex + 1;
  QTMFile.WriteInteger('Multiple','i_fit_method_multiple',i_fit_method_multiple);
  B_Changed := True;
  Update_Values;
end;
}
procedure TMultiple.Set_j_poi_inp;
var i,j,j_count : Integer;
begin
  j_count := 0;
  for j := 1 to nhm do begin
    if B_Import_inc[j] then begin inc(j_count); j_poi_inp[j_count] := j;
    end else begin B_fit_inc[j] := False; QTMFile.WriteBool('Main','B_fit_inc' + inttostr(j),B_fit_inc[j]); B_Changed := True; end;
  end;
  for j := j_count + 1 to nhm do j_poi_inp[j] := 0;
  nhloc := 0; for i := 1 to nhm do if B_Import_inc[i] then inc(nhloc);
end;

procedure TMultiple.i_y_axis_ComboxChange(Sender: TObject);
begin
  if B_NoClick then Exit;
  i_y_axis := i_y_axis_Combox.ItemIndex + 1; QTMFile.WriteInteger('Multiple','i_y_axis',i_y_axis); B_Changed := True;
  Update_Freq_Graphs;
end;

procedure TMultiple.i_y_axis_par_ComboxChange(Sender: TObject);
begin
  if B_NoClick then Exit;
  i_y_axis_par := i_y_axis_par_Combox.ItemIndex + 1;
  QTMFile.WriteInteger('Multiple','i_y_axis_par',i_y_axis_par);
  Update_FitPars_Graph;
  B_Changed := True;
end;

procedure TMultiple.i_time_direction_ComboxChange(Sender: TObject);
begin
  if B_NoClick then Exit;
  i_time_direction := i_time_direction_Combox.ItemIndex + 1; QTMFile.WriteInteger('Multiple','i_time_direction',i_time_direction); B_Changed := True;
end;

procedure TMultiple.Comment_ShowKeyPress(Sender: TObject; var Key: Char);
begin
  Comment_Show.Color := cl3dLight; if key <> #13 then Exit; if key = #27 then begin Comment_Show.Color := clwindow; Exit; end;
  Comment := Comment_Show.Text;
  QTMFile.WriteString('Multiple','Comment',Comment);  B_Changed := True; 
  Comment_Show.Color := clwindow;
end;

procedure TMultiple.Clear_BtnClick(Sender: TObject);
var i,j : Integer;
begin
  Initialize(False);
  for j := 0 to SG1.ColCount do begin
    for i := 1 to SG1.RowCount do SG1.Cells[j,i] := '';
  end;
  if Fileexists(tmp_fn[j_qtd]) then begin
    Assignfile(infile,tmp_fn[j_qtd]);
    Rewrite(infile);
    closefile(infile);
    //Erase(infile);
  end;
  Clear_Fits_BtnClick(Self);
  Update_Freq_Graphs;
  Update_FitPars_Graph;
end;

procedure TMultiple.Clear_Fits_BtnClick(Sender: TObject);
var i,j : Integer;
begin
  for i := 1 to n_dat_max do begin
    chisqr_arr[i] := GapV; fp_avg_arr[i] := GapV;
    for j := 1 to nhm do begin df_fit_arr[j,i] := GapV; dG_fit_arr[j,i] := GapV; end;
    for j := 1 to n_fit_pars_max do par_arr[i,j] := GapV;
  end;
  Update_Freq_Graphs;
  Update_FitPars_Graph;
end;

procedure TMultiple.Show_Fit_Pars;
begin
  if B_t_e_C                then M.t_e_Show.Text                  := FloatToStrF(Pars.t_e,fffixed,8,3);
  if B_rho_e_C              then M.rho_e_Show.Text                := FloatToStrF(Pars.rho_e,fffixed,8,3);
  if B_Jp_e_C               then M.Jp_e_Show.Text                 := FloatToStrF(Pars.Jp_e,fffixed,8,3);
  if B_Jpp_e_C              then M.Jpp_e_Show.Text                := FloatToStrF(Pars.Jpp_e,fffixed,8,3);
  if B_Jp_exp_e_C           then M.Jp_exp_e_Show.Text             := FloatToStrF(Pars.Jp_exp_e,fffixed,8,3);
  if B_Jpp_exp_e_C          then M.Jpp_exp_e_Show.Text            := FloatToStrF(Pars.Jpp_exp_e,fffixed,8,3);
  if B_t_f_C                then M.t_f_Show.Text                  := FloatToStrF(Pars.t_f,fffixed,8,3);
  if B_rho_f_C              then M.rho_f_Show.Text                := FloatToStrF(Pars.rho_f,fffixed,8,3);
  if B_Jp_f_C               then M.Jp_f_Show.Text                 := FloatToStrF(Pars.Jp_f,fffixed,8,3);
  if B_Jpp_f_C              then M.Jpp_f_Show.Text                := FloatToStrF(Pars.Jpp_f,fffixed,8,3);
  if B_Jp_exp_f_C           then M.Jp_exp_f_Show.Text             := FloatToStrF(Pars.Jp_exp_f,fffixed,8,3);
  if B_Jpp_exp_f_C          then M.Jpp_exp_f_Show.Text            := FloatToStrF(Pars.Jpp_exp_f,fffixed,8,3);
  if B_rho_b_C              then M.rho_b_Show.Text                := FloatToStrF(Pars.rho_b,fffixed,8,3);
  if B_Jp_b_C               then M.Jp_b_Show.Text                 := FloatToStrF(Pars.Jp_b,fffixed,8,3);
  if B_Jpp_b_C              then M.Jpp_b_Show.Text                := FloatToStrF(Pars.Jpp_b,fffixed,8,3);
  if B_Jp_exp_b_C           then M.Jp_exp_b_Show.Text             := FloatToStrF(Pars.Jp_exp_b,fffixed,8,3);
  if B_Jpp_exp_b_C          then M.Jpp_exp_b_Show.Text            := FloatToStrF(Pars.Jpp_exp_b,fffixed,8,3);
  if B_vers_C               then M.vers_Show.Text                 := FloatToStrF(Pars.vers,fffixed,8,3);
  if B_AspRat_C             then M.AspRat_Show.Text               := FloatToStrF(Pars.AspRat,fffixed,8,3);
end;

procedure TMultiple.i_skip_ComboxChange(Sender: TObject);
begin
  i_skip := i_skip_Combox.ItemIndex + 1; QTMFile.WriteInteger('Multiple','i_skip',i_skip); B_Changed := True;
  Update_Freq_Graphs; Update_FitPars_Graph;
end;

procedure TMultiple.i_skip_dis_ComboxChange(Sender: TObject);
begin
  i_skip_dis := i_skip_dis_Combox.ItemIndex + 1; QTMFile.WriteInteger('Multiple','i_skip_dis',i_skip_dis); B_Changed := True;
//  Update_Freq_Graphs; Update_FitPars_Graph;
end;

procedure TMultiple.From_HotSpots(Sender: TObject; DblClick, SubsetIndex, PointIndex: Integer);
var i,ih,k,i_line : Integer;
    df_ref,dg_ref : array[1..nhm] of Double;
begin
  if ((Sender as PESGraph) = FitPars_Graph) and (i_ready <> j_ready_HidePoint) and (GetKeyState(164) < -1) then begin
    i_ready := 0;
    Red_Label.Visible := False;
    Exit;
  end;
  case i_ready of
    j_ready_new_Zero : begin
      for ih := 1 to nhm do begin
        df_ref[ih] := df_arr[ih,PointIndex+1];
        dG_ref[ih] := dG_arr[ih,PointIndex+1];
      end;
      for i_line := 1 to n_dat do begin
        for ih := 1 to nhm do begin
          if not(df_arr[ih,i_line] = GapV) then df_arr[ih,i_line] := df_arr[ih,i_line] - df_ref[ih];
          if not(dG_arr[ih,i_line] = GapV) then dG_arr[ih,i_line] := dG_arr[ih,i_line] - dG_ref[ih];
          if not(df_arr_raw[ih,i_line] = GapV) then df_arr_raw[ih,i_line] := df_arr_raw[ih,i_line] - df_ref[ih];
          if not(dG_arr_raw[ih,i_line] = GapV) then dG_arr_raw[ih,i_line] := dG_arr_raw[ih,i_line] - dG_ref[ih];
        end;
      end;
      i_ready := 0; Red_Label.Visible := False;
    end;

    j_ready_New_Zero_Fit_Ref : begin
      M.Fit_BtnClick(Self); M.Ref_BtnClick(Self);
      i_ready := 0; Red_Label.Visible := False;
      for ih := 1 to nhm do begin
        df_ref[ih] := df_arr[ih,PointIndex+1];
        dG_ref[ih] := dG_arr[ih,PointIndex+1];
      end;
      for i_line := 1 to n_dat do begin
        for ih := 1 to nhm do begin
          if not(df_arr[ih,i_line] = GapV) then df_arr[ih,i_line] := df_arr[ih,i_line] - df_ref[ih];
          if not(dG_arr[ih,i_line] = GapV) then dG_arr[ih,i_line] := dG_arr[ih,i_line] - dG_ref[ih];
          if not(df_arr_raw[ih,i_line] = GapV) then df_arr_raw[ih,i_line] := df_arr_raw[ih,i_line] - df_ref[ih];
          if not(dG_arr_raw[ih,i_line] = GapV) then dG_arr_raw[ih,i_line] := dG_arr_raw[ih,i_line] - dG_ref[ih];
        end;
      end;
    end;

    j_ready_HideSet : begin
      i_Hide[PointIndex + 1] := 1;
      Save_Data(tmp_fn[j_qtm]);
      Update_Freq_Graphs;
    end;
    j_ready_clear: begin
      i_PointSelected := PointIndex + 1;
      QTMFile.WriteInteger('Multiple','i_PointSelected',i_PointSelected); B_Changed := True;
      for ih := 1 to nhm do begin
        if i_hide[i_PointSelected] = 0 then begin
          df[ih] := df_arr[ih,i_PointSelected];
          dG[ih] := dG_arr[ih,i_PointSelected];
        end else begin
          df[ih] := GapV;
          dG[ih] := GapV;
        end;
      end;
      if i_hide[i_PointSelected] = 0 then begin
        Info_String := FloatToStrF(time_arr[i_PointSelected],fffixed,8,3);
        for k := 1 to n_fit_pars_max do begin
          if par_arr[i_PointSelected,k] <> GapV then a_fit[k] := par_arr[i_PointSelected,k];
        end;
        SLA.a_to_Pars(a_fit);
      end else begin
        Info_String := '';
      end;
      QTMFile.WriteString('Graphs','Info_String',Info_String);
      for i := 1 to n_hs_act do begin
        QTMFile.WriteFloat('Main','Df' + inttostr(i),df[i]);
        QTMFile.WriteFloat('Main','DG' + inttostr(i),dG[i]);
      end;
      Update_Values;
      Update_Freq_Graphs;
      i_ready := 0; Red_Label.Visible := False;
    end;
  end;//case
  If (i_ready = j_ready_HidePoint) or (GetKeyState(164{Alt}) < -1) then begin
    i_Hide[PointIndex + 1] := 1;
    Save_Data(tmp_fn[j_qtm]);
    Update_Freq_Graphs;
  end;
  ClearReadyState;
  if i_hide[i_PointSelected] = 0 then B_no_model := False else B_no_model := True;
  M.Update_All;
end;

Procedure TMultiple.GraphZoomInEvent(Sender: TObject);
var ih : integer;
    df_ref,dg_ref : array[1..nhm] of Double;
    norm : Integer;
    start_avg,stop_avg : Double;
    p,i_line : Longint;
    Graph: PESGraph;
begin
  if (Sender is PESGraph)
    then Graph := (Sender as PESGraph)
    else exit;
  with Graph do begin
    case i_ready of
      j_ready_SelectRange : begin
        start_range := ZoomMinX;
        stop_range  := ZoomMaxX;
        i_PointStart := 1;
        i_PointStop  := 1;
        p := 0;
        while (p < Points) do begin
          if ((Xdata[0,Points - p - 1] >  start_range) and (Xdata[0, Points - p - 1] <> GapV))  then i_PointStart := Points - p;
          if ((Xdata[0,p] <  stop_range)  and (Xdata[0,p] <> GapV))  then i_PointStop  := p + 1;
          inc(p);
        end;
        QTMFile.WriteInteger('Multiple','i_PointStart',i_PointStart);
        QTMFile.WriteInteger('Multiple','i_PointStop' ,i_PointStop); B_Changed := True;
        i_ready := 0; Red_Label.Visible := False;
        Update_Freq_Graphs;
        Application.ProcessMessages;
      end;

      j_ready_New_Zero : begin
        if (Graph = Multiple.FitPars_Graph) then exit;
        start_avg := ZoomMinX;
        stop_avg  := ZoomMaxX;
        norm := 0;
        for ih := 1 to nhm do begin df_ref[ih] := 0; dG_ref[ih] := 0; end;
        for p := 1 to Points do begin
          if (Xdata[0,p] >= start_avg) and
             (Xdata[0,p] <= Stop_avg) then begin
            inc(norm);
            for ih := 1 to nhm do begin
              df_ref[ih] := df_ref[ih] + df_arr[ih,p];
              dG_ref[ih] := dG_ref[ih] + dG_arr[ih,p];
            end;
          end;
        end;
        if norm > 0 then begin
          for ih := 1 to nhm do begin
            df_ref[ih] := df_ref[ih]/norm;
            dG_ref[ih] := dG_ref[ih]/norm;
          end;
        end;
        for i_line := 1 to n_dat do begin
          for ih := 1 to nhm do begin
            if not(df_arr[ih,i_line] = GapV ) then df_arr[ih,i_line] := df_arr[ih,i_line] - df_ref[ih];
            if not(dG_arr[ih,i_line] = GapV ) then dG_arr[ih,i_line] := dG_arr[ih,i_line] - dG_ref[ih];
            if not(df_arr_raw[ih,i_line] = GapV ) then df_arr_raw[ih,i_line] := df_arr_raw[ih,i_line] - df_ref[ih];
            if not(dG_arr_raw[ih,i_line] = GapV ) then dG_arr_raw[ih,i_line] := dG_arr_raw[ih,i_line] - dG_ref[ih];
          end;
        end;
        i_ready := 0; Red_Label.Visible := False;
        Update_Freq_Graphs;
      end;

      j_ready_HideRange : begin
        start_range := ZoomMinX;
        stop_range  := ZoomMaxX;
        for p := 1 to Points do begin
          if (Xdata[0,p-1] >  ZoomMinX) and (Xdata[0,p-1] <= ZoomMaxX) and
             (Ydata[0,p-1] >  ZoomMinY) and (Ydata[0,p-1] <= ZoomMaxY) then i_Hide[p] := 1;
        end;
        for ih := 1 to nhm do begin
          df[ih] := df_arr[ih,i_PointSelected];
          dG[ih] := dG_arr[ih,i_PointSelected];
          QTMFile.WriteFloat('Main','Df' + inttostr(ih),df[ih]);
          QTMFile.WriteFloat('Main','DG' + inttostr(ih),dG[ih]);
        end;
        Save_Data(tmp_fn[j_qtm]);
        i_ready := 0; Red_Label.Visible := False;
        UpdateGraphs;
        Application.ProcessMessages;
        if i_hide[i_PointSelected] = 1 then B_no_Model := True else B_no_Model := False;
        M.Update_All;
        if (i_PointSelected > 0) and (i_PointSelected <= Points) and (i_hide[i_PointSelected] = 0) then B_no_model := False else B_no_model := True;
      end;
    end; //case
  end; //with
  ClearReadyState;
end;

procedure TMultiple.Initialize(B_fits_only : Boolean);
var i,j : integer;
begin
  for i := 1 to n_dat_max do begin
    if not B_fits_only then begin
      i_Hide[i] := 0;
      time_arr[i] := GapV;
      for j := 1 to nhm do begin
        df_arr[j,i] := GapV;
        dG_arr[j,i] := GapV;
        df_arr_raw[j,i] := GapV;
        dG_arr_raw[j,i] := GapV;
      end;
    end;
    for j := 1 to nhm do begin
      df_fit_arr[j,i] := GapV;
      dG_fit_arr[j,i] := GapV;
    end;
    for j := 1 to n_fit_pars_max do par_arr[i,j] := GapV;
    chisqr_arr[i] := GapV;
    fp_avg_arr[i] := GapV;
  end;
end;

procedure TMultiple.Check_nhmloc;
var j : integer;
begin
  if not fileexists(tmp_fn[j_qtd]) then Exit;
  assignfile(infile,tmp_fn[j_qtd]); Reset(infile);
  if not eof(infile) then begin
    for j := 1 to 16 do begin
      read(infile,test_Double);
    end;
    if (test_Double = 0) or (test_Double = 1) then nhm_loc := 7 else nhm_loc := 10;
  end;
  closefile(infile);
end;

procedure TMultiple.Load_Data;
var i,j : integer;
begin
//  Check_nhmloc;
  nhm_loc := 10;
  if not fileexists(tmp_fn[j_qtd]) then Exit;
  assignfile(infile,tmp_fn[j_qtd]); Reset(infile);
  try
    i := 1;
    while not eof(infile) do begin
      try
        Read(infile,time_arr[i]);
        for j := 1 to nhm_loc do read(infile,df_arr_raw[j,i]);
        for j := 1 to nhm_loc do read(infile,dG_arr_raw[j,i]);
        for j := 1 to nhm_loc do read(infile,i_hide[i]);
        for j := 1 to nhm_loc do read(infile,df_fit_arr[j,i]);
        for j := 1 to nhm_loc do read(infile,dG_fit_arr[j,i]);
        for j := 1 to n_fit_pars_max do read(infile,par_arr[i,j]);
        readln(infile,chisqr_arr[i]);
      except end;
      inc(i);
    end;
    n_dat := i - 1;
  finally closefile(infile);
  end;
  Smoothen;
end;

procedure TMultiple.Save_Data(Save_fn: string);
var i,j : integer;
begin
  try
    assignfile(outfile,ChangeFileExt(Save_fn,'.qtd'));
    Rewrite(outfile);
    for i := 1 to n_dat do begin
      Write(outfile,time_arr[i],#9);
      for j := 1 to nhm do write(outfile,df_arr_raw[j,i],#9);
      for j := 1 to nhm do write(outfile,dG_arr_raw[j,i],#9);
      for j := 1 to nhm do write(outfile,i_hide[i],#9);
      for j := 1 to nhm do write(outfile,df_fit_arr[j,i],#9);
      for j := 1 to nhm do write(outfile,dG_fit_arr[j,i],#9);
      for j := 1 to n_fit_pars_max do write(outfile,par_arr[i,j],#9);
      write(outfile,chisqr_arr[i],#9);
      writeln(outfile);
    end;
  finally closefile(outfile);
  end;
end;

procedure TMultiple.Determine_B_Import_inc_QTools(line : String);
var ih,j : integer;
begin
  nhloc := 0; for ih := 1 to nhm do B_Import_inc[ih] := False;
  for j := 1 to length(line)-6 do begin
    if (Trim(copy(line,j,6)) = 'F_1:1') or (Trim(copy(line,j,6)) = 'F_2:1') then begin B_Import_inc[1] := True; inc(nhloc); end;
    if (Trim(copy(line,j,6)) = 'F_1:3') or (Trim(copy(line,j,6)) = 'F_2:3') then begin B_Import_inc[2] := True; inc(nhloc); end;
    if (Trim(copy(line,j,6)) = 'F_1:5') or (Trim(copy(line,j,6)) = 'F_2:5') then begin B_Import_inc[3] := True; inc(nhloc); end;
    if (Trim(copy(line,j,6)) = 'F_1:7') or (Trim(copy(line,j,6)) = 'F_2:7') then begin B_Import_inc[4] := True; inc(nhloc); end;
    if (Trim(copy(line,j,6)) = 'F_1:9') or (Trim(copy(line,j,6)) = 'F_2:9') then begin B_Import_inc[5] := True; inc(nhloc); end;
    if (Trim(copy(line,j,7)) = 'F_1:11') or (Trim(copy(line,j,6)) = 'F_2:11') then begin B_Import_inc[6] := True; inc(nhloc); end;
    if (Trim(copy(line,j,7)) = 'F_1:13') or (Trim(copy(line,j,6)) = 'F_2:13') then begin B_Import_inc[7] := True; inc(nhloc); end;
  end;
  Set_j_poi_inp;
end;



procedure TMultiple.Determine_B_Import_inc_QTZ(line : String);
var ih,j : integer;
begin
  nhloc := 0; for ih := 1 to nhm do B_Import_inc[ih] := False;
  for j := 1 to length(line)-6 do begin
    if (Trim(copy(line,j,4)) = 'df_1') and
       (Trim(copy(line,j,5)) <> 'df_11') and
       (Trim(copy(line,j,5)) <> 'df_13') then begin B_Import_inc[1] := True; inc(nhloc);
    end;
    if Trim(copy(line,j,4)) = 'df_3' then begin B_Import_inc[2] := True; inc(nhloc); end;
    if Trim(copy(line,j,4)) = 'df_5' then begin B_Import_inc[3] := True; inc(nhloc); end;
    if Trim(copy(line,j,4)) = 'df_7' then begin B_Import_inc[4] := True; inc(nhloc); end;
    if Trim(copy(line,j,4)) = 'df_9' then begin B_Import_inc[5] := True; inc(nhloc); end;
    if Trim(copy(line,j,5)) = 'df_11' then begin B_Import_inc[6] := True; inc(nhloc); end;
    if Trim(copy(line,j,5)) = 'df_13' then begin B_Import_inc[7] := True; inc(nhloc); end;
  end;
  Set_j_poi_inp;
end;

procedure TMultiple.Determine_B_Import_inc_AWSensors(line : String);
var ih,j : integer;
begin
  nhloc := 0; for ih := 1 to nhm do B_Import_inc[ih] := False;
  for j := 1 to length(line)-6 do begin
    if (Trim(copy(line,j,14)) = 'Delta_F/n_n=1') and
       (Trim(copy(line,j,15)) <> 'Delta_F/n_n=11') and
       (Trim(copy(line,j,15)) <> 'Delta_F/n_n=13') then begin B_Import_inc[1] := True; inc(nhloc);
    end;
    if Trim(copy(line,j,14)) = 'Delta_F/n_n=3'  then begin B_Import_inc[2] := True; inc(nhloc); end;
    if Trim(copy(line,j,14)) = 'Delta_F/n_n=5'  then begin B_Import_inc[3] := True; inc(nhloc); end;
    if Trim(copy(line,j,14)) = 'Delta_F/n_n=7'  then begin B_Import_inc[4] := True; inc(nhloc); end;
    if Trim(copy(line,j,14)) = 'Delta_F/n_n=9'  then begin B_Import_inc[5] := True; inc(nhloc); end;
    if Trim(copy(line,j,15)) = 'Delta_F/n_n=11' then begin B_Import_inc[6] := True; inc(nhloc); end;
    if Trim(copy(line,j,15)) = 'Delta_F/n_n=13' then begin B_Import_inc[7] := True; inc(nhloc); end;
  end;
  Set_j_poi_inp;
end;

procedure TMultiple.B_fit_inc_clBoxClickCheck(Sender: TObject);
var i : integer;
begin
  for i := 1 to nhm do begin
    if B_fit_inc_clBox.Checked[i-1] then B_fit_inc[i] := True else B_fit_inc[i] := False;
    QTMFile.WriteBool('Main','B_fit_inc' + inttostr(i),B_fit_inc[i]);
  end;
  B_Changed := True;
  M.Update_All; Update_Freq_Graphs;
end;

procedure TMultiple.RunFits_BtnClick(Sender: TObject);
var ih : integer;
    i,k  : Integer;
    B_finish : Boolean;
//    i_fit_method_old : integer;
begin
  B_Fit_is_running := True;
  if i_fit_method = 2 then Fit_From_Python
  else begin
    PageControl1.TabIndex := 1;
    PageControl1Change(nil);
    B_Stop := False; B_finish := False; Bu_Pars := Pars;
    B_from_Multiple := True;
    Abort_Btn.Enabled := True;
    MIO.pars_to_a(Multiple.guess_multiple);
    n_pts := 0;
    case i_time_direction of
      1 : i := i_PointStart;
      2 : i := i_PointStop;
    end;
    Update_Freq_Graphs_Settings;
    while (not B_finish) and (not B_Stop) do begin
      if (time_arr[i] <> GapV) and (time_arr[i] >= start_range) and (time_arr[i] <= stop_range) then begin
        for ih := 1 to nhm do begin
          if i_hide[i_PointSelected] = 0 then begin
            df[ih] := df_arr[ih,i];
            dG[ih] := dG_arr[ih,i];
          end else begin
            df[ih] := GapV;
            dG[ih] := GapV;
          end;
        end;
        if i_guess = 2 then MIO.pars_to_a(Multiple.guess_multiple);
        if i mod n_skip[i_skip_dis] = 0
          then B_Update_Main := True
          else B_Update_Main := False;
//        i_fit_method_old := i_fit_method; i_fit_method := 1;
        M.Fit_BtnClick(Self);
//        i_fit_method := i_fit_method_old;
        for ih := 1 to nhm do begin
          df_fit_arr[ih,i] := df_fit[ih];
          dG_fit_arr[ih,i] := dG_fit[ih];
        end;
        for k := 1 to n_fit_pars_max do par_arr[i,k] := a_fit[k];
        chisqr_arr[i] := chisqr;
        n_pts := i;
        if i mod n_skip[i_skip_dis] = 0 then begin
          i_PointSelected := i;
          UpdateGraphs;
        end;
      end;
      if i_time_direction = 1 then begin i := i + 1; B_finish := i > i_PointStop;  end;
      if i_time_direction = 2 then begin i := i - 1; B_finish := i < i_PointStart; end;
    end;  //while
    B_Stop := true;
    i_PointSelected := i;
    Abort_Btn.Enabled := False;
    B_from_Multiple := False;
  end;
  UpdateGraphs;
  Save_Data(tmp_fn[j_qtm]);
  for ih := 1 to nhm do begin
    df[ih] := df_arr[ih,i_PointSelected];
    dG[ih] := dG_arr[ih,i_PointSelected];
  end;
  M.Retr_Bu_BtnClick(Self);
  M.Update_All;
  B_Fit_is_running := False;
end;

procedure TMultiple.ClearReadyState;
begin
  i_ready := j_ready_clear;
  Red_Label.Visible := false;
end;

procedure TMultiple.ShowOverLImitClick(Sender: TObject);
begin
  B_ShowPointsoverLimit := (Sender as TCheckBox).Checked;
  i_skip := QTMFile.ReadInteger('Multiple','i_skip',1);
  QTMFile.WriteBool('Multiple','B_ShowPointsoverLimit',B_ShowPointsoverLimit);
  Update_FitPars_Graph;
end;

procedure TMultiple.GraphZoomIn(Sender: TObject);
var ZMinX, ZMaxX: Double;
    i: byte;
begin
  if not (Sender is PESGraph) then exit;
  if not(i_ready = j_ready_clear) then begin
    (Sender as PESGraph).ZoomMode := false;
    GraphZoomInEvent(Sender);
    exit;
  end;
  ZMinX := (Sender as PESGraph).ZoomMinX;
  ZMaxX := (Sender as PESGraph).ZoomMaxX;
  for i := 1 to 3 do begin
    if not((Sender as PESGraph) = MultipleGraphs[i]) then begin
      MultipleGraphs[i].ZoomMode := true;
      MultipleGraphs[i].ZoomMinX := ZMinX;
      MultipleGraphs[i].ZoomMaxX := ZMaxX;
      MultipleGraphs[i].AllowZooming := sgHorzZooming;
      MultipleGraphs[i].Peactions := sgReinitAndReset;
      MultipleGraphs[i].AllowZooming := sgHorzPlusVertZooming;
      MultipleGraphs[i].Peactions := sgReinitAndReset;
    end;
  end;
end;

procedure TMultiple.GraphZoomOut(Sender: TObject);
var i: byte;
begin
  for i := 1 to 3 do begin
    MultipleGraphs[i].ZoomMode := false;
    MultipleGraphs[i].Peactions := sgReinitAndReset;
  end;
end;

procedure TMultiple.miDFGraph1Click(Sender: TObject);
var i:Byte;
begin
  if not(Sender is TMenuItem) then exit;
  (Sender as TMenuItem).Checked := not((Sender as TMenuItem).Checked);
  For i := 1 to 3 do begin
    if ((Sender as TMenuItem) = MainMenu1.Items[1].Items[i+1])
      then Multiple.B_ShowAnnot[i] := (Sender as TMenuItem).Checked
  end;
  UpdateGraphs;
end;

procedure TMultiple.df_Graph_to_clpbd_BtnClick(Sender: TObject);   begin MIO.GraphToClpbd(Multiple.df_graph); end;
procedure TMultiple.dG_Graph_to_clpbd_BtnClick(Sender: TObject);   begin MIO.GraphToClpbd(Multiple.dg_graph); end;
procedure TMultiple.Pars_Graph_to_clpbd_BtnClick(Sender: TObject); begin MIO.GraphToClpbd(Multiple.FitPars_Graph); end;

Procedure TMultiple.UpdateFitPars;
var i: Byte;
    ModelPar: TEditWithnoUnit;
begin
  For i := 1 to n_fit_pars_max do begin
    FitParPanels[i].Visible := not(fit_pointer[i] = 0);
    if not(fit_pointer[i] = 0) then begin
      ModelPar := M.GetModelEdit(fit_pointer[i]);
      FitParEdits[i].Text := ModelPar.Edit.Text;
      FitParEdits[i].Color := ModelPar.Edit.Color;
      FitParLabels[i].Caption := ModelPar.Describtion_Label.Caption;
    end;
  end;
  if B_Limits_Active
    then Multiple.ActLimits_Btn.Caption := 'Deact. Limits'
    else Multiple.ActLimits_Btn.Caption := 'Activate Limits';

  ConstParLabel.Caption := 'Fundamental : ' + #9 + #9 + FloattoStrF(f_fund/1e6,fffixed,8,3) + ' MHz' + #13#10 +
                           'Center Freq. VE Pars : ' + #9 +  FloattoStrF(f_Jref/1e6,fffixed,8,3) + ' MHz' + #13#10 +
                           'Zq [10^6] : ' + #9 + #9 +  FloattoStrF(Zq/1e6,fffixed,8,3) + ' kg/(m^2 s)' {+ #13#10 +
                           'Ref: t_1 : ' + FloatToStrF(Ref_Pars.t_e,fffixed,8,1) + ' t_2 : ' + FloatToStrF(Ref_Pars.t_f,fffixed,8,3) +
                           ' rho_b : ' + FloatToStrF(Ref_Pars.rho_b,fffixed,8,1)};
end;

procedure TMultiple.Fit_BtnClick(Sender: TObject); begin M.Fit_BtnClick(nil); end;

procedure TMultiple.FitParEditKeyPress(Sender: TObject; var Key: Char);
var i: Byte;
  ModelPar: TEditWithnoUnit;
begin
  if not(Sender is TEdit) then exit;
  For i := 1 to n_fit_pars_max do begin
    If (Sender = FitParEdits[i]) then begin
      ModelPar := M.GetModelEdit(fit_pointer[i]);
      ModelPar.Edit.Text := (Sender as TEdit).Text;
      M.KeyPressResponse(ModelPar.Edit, Key);
    end;
  end;
end;

procedure TMultiple.ActLimits_BtnClick(Sender: TObject);
begin
  Limits.Active1Click(self);
  UpdateFitPars;
end;
      
procedure TMultiple.FitParRadioButtonClick(Sender: TObject);
var i:Byte;
begin
  if not(Sender is TRadioButton) then exit;
  for i := 1 to 6 do begin
    if FitParRBtn[i] = Sender
      then i_FitParRBtn := i
      else FitParRBtn[i].Checked := false;
    i_rbtn := fit_pointer[i_FitParRBtn];
    M.Update_RBtns;
  end;  
end;

procedure TMultiple.t10_BtnClick(Sender: TObject);     begin M.par_shift(10); end;
procedure TMultiple.t5_BtnClick(Sender: TObject);      begin M.par_shift(5); end;
procedure TMultiple.t2_BtnClick(Sender: TObject);      begin M.par_shift(2); end;
procedure TMultiple.t1d5_BtnClick(Sender: TObject);    begin M.par_shift(1.5); end;
procedure TMultiple.t1d1_BtnClick(Sender: TObject);    begin M.par_shift(1.1); end;
procedure TMultiple.t1d01_BtnClick(Sender: TObject);   begin M.par_shift(1.01); end;
procedure TMultiple.t1d001_BtnClick(Sender: TObject);  begin M.par_shift(1.001); end;
procedure TMultiple.b1d001_BtnClick(Sender: TObject);  begin shift_fac := 1/1.001; M.par_shift(shift_fac); end;
procedure TMultiple.b1d01_BtnClick(Sender: TObject);   begin shift_fac := 1/1.01; M.par_shift(shift_fac); end;
procedure TMultiple.b1d1_BtnClick(Sender: TObject);    begin shift_fac := 1/1.1; M.par_shift(shift_fac); end;
procedure TMultiple.b1d5_BtnClick(Sender: TObject);    begin shift_fac := 1/1.5; M.par_shift(shift_fac); end;
procedure TMultiple.b2_BtnClick(Sender: TObject);      begin M.par_shift(0.5); end;
procedure TMultiple.b5_BtnClick(Sender: TObject);      begin M.par_shift(0.2); end;
procedure TMultiple.b10_BtnClick(Sender: TObject);     begin M.par_shift(0.1); end;

procedure TMultiple.PageControl1Change(Sender: TObject);
begin
  Multiple.DF_from_Main.Visible := PageControl1.TabIndex = 1;
  Multiple.DG_From_Main.Visible := PageControl1.TabIndex = 1;
  UpdateFitPars;
  QTMFile.WriteInteger('Multiple', 'PageControlIndex', PageControl1.TabIndex);
end;

procedure TMultiple.Shift_i_PointSelected(i_dir : Integer);
  var ih,k : integer;
begin
  case i_dir of
    1  : if i_PointSelected < n_dat then inc(i_PointSelected);
    -1 : if i_PointSelected > 1 then dec(i_PointSelected);
  end;
  QTMFile.WriteInteger('Multiple','i_PointSelected',i_PointSelected);
  if i_hide[i_PointSelected] = 0 then begin
    Info_String := FloatToStrF(time_arr[i_PointSelected],fffixed,8,3);
    QTMFile.WriteString('Graphs','Info_String',Info_String);
    for ih := 1 to nhm do begin
      df[ih] := df_arr[ih,i_PointSelected];
      dG[ih] := dG_arr[ih,i_PointSelected];
      QTMFile.WriteFloat('Main','Df' + inttostr(ih),df[ih]);
      QTMFile.WriteFloat('Main','DG' + inttostr(ih),dG[ih]);
      for k := 1 to n_fit_pars_max do begin
        if par_arr[i_PointSelected,k] <> GapV then a_fit[k] := par_arr[i_PointSelected,k];
      end;
      SLA.a_to_Pars(a_fit);
      M.Update_All;
    end;
  end else begin
    for ih := 1 to nhm do begin
      df[ih] := GapV;
      dG[ih] := GapV;
    end;
  end;
end;

procedure TMultiple.AcceptFit1Click(Sender: TObject);
var ih,k : integer;
begin
  for ih := 1 to nhm do begin
    df_fit_arr[ih,i_PointSelected] := df_fit[ih];
    dG_fit_arr[ih,i_PointSelected] := dG_fit[ih];
  end;
  for k := 1 to n_fit_pars_max do par_arr[i_PointSelected,k] := a_fit[k];
  chisqr_arr[i_PointSelected] := chisqr;
  Update_FitPars_Graph; Save_Data(tmp_fn[j_qtm]);
end;

procedure TMultiple.Discard_BtnClick(Sender: TObject);
var ih,k : integer;
begin
  for ih := 1 to nhm do begin
    df_fit_arr[ih,i_PointSelected] := GapV;
    dG_fit_arr[ih,i_PointSelected] := GapV;
  end;
  for k := 1 to n_fit_pars_max do par_arr[i_PointSelected,k] := GapV;
  chisqr_arr[i_PointSelected] := GapV;
  Update_FitPars_Graph; Save_Data(tmp_fn[j_qtm]);
end;

procedure TMultiple.i_MLAfr_UDMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Y < 12 then Shift_i_PointSelected(1)
  else           Shift_i_PointSelected(-1);
end;


procedure TMultiple.miExportFitParameter1Click(Sender: TObject);
var
  TextBuf,DateStr : String;
  s,p : integer;
  B_HasData: Boolean;
begin
  Screen.Cursor := crHourglass;
  try
    DateTimeToString(DateStr,'yyyy-mm-dd_hh-nn-ss',Now);
    TextBuf := TextBuf + comment + #9 + io_fn  + #10;
    TextBuf := TextBuf + DateStr + #10;

    TextBuf := TextBuf + df_Graph.XAxisLabel +  #9;

    for s := 1 to n_fit_pars + 1 do begin
      if s <= n_fit_pars then TextBuf := TextBuf + MIO.Graph_Labels(fit_pointer[s]) + #9
      else if s = n_fit_pars + 1 then TextBuf := TextBuf + 'chi^2' + #9;
    end;
    TextBuf := TextBuf + #10;


    for p := 1 to df_Graph.Points do begin
      for s := 1 to n_fit_pars do begin
        if par_arr[p,s] <> GapV
          then B_HasData := true;
      end;

      if B_HasData then begin
        B_HasData := false;
        //write time
        if df_Graph.XData[0,p-1] <> GapV then begin
          TextBuf := TextBuf + FloatToStr(df_Graph.XData[0,p-1]*Power(10,df_Graph.ScaleforXData)) + #9;
          //write Fit pars
          for s := 1 to n_fit_pars do begin
            if par_arr[p,s] <> GapV
              then TextBuf := TextBuf + FloatToStr(par_arr[p,s])+ #9
              else  TextBuf := TextBuf + #9;
          end;
          if chisqr_arr[p] <> GapV
            then TextBuf := TextBuf + FloatToStr(chisqr_arr[p])+ #9
            else  TextBuf := TextBuf + #9;
          TextBuf := TextBuf + #10;
        end;
      end;
    end;
    MIO.ExportStrToClpb(TextBuf);
  finally
    Screen.Cursor := crDefault;
  end;
  Application.ProcessMessages;
end;

procedure TMultiple.Change_VE_Pars;
var i_dat,i_par : integer;
    B_non_GapV : Boolean;
    Pars_new : TPars;
begin
  for i_dat := 1 to n_dat do begin
    B_non_GapV := True;
    for i_par := 1 to n_fit_pars do begin
      if par_arr[i_dat,i_par] = GapV then B_non_GapV := False;
    end;
    if B_non_GapV then begin
      fit_pars_to_Pars(i_dat);
      SLA.Convert_VE_Pars(M.i_layer,M.i_ve_old, M.i_ve_new, Multiple_Pars, Pars_new);
      Multiple_Pars := Pars_new;
      Pars_to_fit_pars(i_dat);
    end;
  end;
  Update_FitPars_Graph; UpdateFitPars;
end;

procedure TMultiple.fit_pars_to_Pars(i : integer);
var i_par : integer;
begin
  for i_par := 1 to n_fit_pars do begin
    case fit_pointer[i_par] of
      t_e_ID                 : Multiple_Pars.t_e  := par_arr[i,i_par];
      t_f_ID                 : Multiple_Pars.t_f  := par_arr[i,i_par];

      rho_e_ID               : Multiple_Pars.rho_e  := par_arr[i,i_par];
      rho_f_ID               : Multiple_Pars.rho_f  := par_arr[i,i_par];
      rho_b_ID               : Multiple_Pars.rho_b  := par_arr[i,i_par];

      Jp_e_ID                : Multiple_Pars.Jp_e  := par_arr[i,i_par];
      Jp_f_ID                : Multiple_Pars.Jp_f  := par_arr[i,i_par];
      Jp_b_ID                : Multiple_Pars.Jp_b  := par_arr[i,i_par];

      Jp_exp_e_ID            : Multiple_Pars.Jp_exp_e  := par_arr[i,i_par];
      Jp_exp_f_ID            : Multiple_Pars.Jp_exp_f  := par_arr[i,i_par];
      Jp_exp_b_ID            : Multiple_Pars.Jp_exp_b  := par_arr[i,i_par];

      Jpp_e_ID               : Multiple_Pars.Jpp_e  := par_arr[i,i_par];
      Jpp_f_ID               : Multiple_Pars.Jpp_f  := par_arr[i,i_par];
      Jpp_b_ID               : Multiple_Pars.Jpp_b  := par_arr[i,i_par];

      Jpp_exp_e_ID           : Multiple_Pars.Jpp_exp_e  := par_arr[i,i_par];
      Jpp_exp_f_ID           : Multiple_Pars.Jpp_exp_f  := par_arr[i,i_par];
      Jpp_exp_b_ID           : Multiple_Pars.Jpp_exp_b := par_arr[i,i_par];

      vers_ID                : Multiple_Pars.vers := par_arr[i,i_par];
      AspRat_ID              : Multiple_Pars.AspRat := par_arr[i,i_par];
    end;
  end;
end;

procedure TMultiple.Pars_to_fit_pars(i : integer);
var i_par : integer;
begin
  for i_par := 1 to n_fit_pars do begin
    case fit_pointer[i_par] of
      t_e_ID                 : par_arr[i,i_par] := Multiple_Pars.t_e;
      t_f_ID                 : par_arr[i,i_par] := Multiple_Pars.t_f;

      rho_e_ID               : par_arr[i,i_par] := Multiple_Pars.rho_e ;
      rho_f_ID               : par_arr[i,i_par] := Multiple_Pars.rho_f ;
      rho_b_ID               : par_arr[i,i_par] := Multiple_Pars.rho_b ;

      Jp_e_ID                : par_arr[i,i_par] := Multiple_Pars.Jp_e ;
      Jp_f_ID                : par_arr[i,i_par] := Multiple_Pars.Jp_f ;
      Jp_b_ID                : par_arr[i,i_par] := Multiple_Pars.Jp_b ;

      Jp_exp_e_ID            : par_arr[i,i_par] := Multiple_Pars.Jp_exp_e ;
      Jp_exp_f_ID            : par_arr[i,i_par] := Multiple_Pars.Jp_exp_f ;
      Jp_exp_b_ID            : par_arr[i,i_par] := Multiple_Pars.Jp_exp_b ;

      Jpp_e_ID               : par_arr[i,i_par] := Multiple_Pars.Jpp_e;
      Jpp_f_ID               : par_arr[i,i_par] := Multiple_Pars.Jpp_f;
      Jpp_b_ID               : par_arr[i,i_par] := Multiple_Pars.Jpp_b;

      Jpp_exp_e_ID           : par_arr[i,i_par] := Multiple_Pars.Jpp_exp_e;
      Jpp_exp_f_ID           : par_arr[i,i_par] := Multiple_Pars.Jpp_exp_f;
      Jpp_exp_b_ID           : par_arr[i,i_par] := Multiple_Pars.Jpp_exp_b;

      vers_ID                : par_arr[i,i_par] := Multiple_Pars.vers;
      AspRat_ID              : par_arr[i,i_par] := Multiple_Pars.AspRat;
    end;
  end;
end;

procedure TMultiple.Fit_From_Python;
var fn : string;
  i,j,i_hide_tot : integer;
  idouble : double;
  StartTick: Cardinal;
begin
  assignfile(outfile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Abort.txt'); Rewrite(outfile); Writeln(outfile,0); closefile(outfile);
  assignfile(outfile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Time_Traces.txt');
  Rewrite(outfile);
  for i := i_PointStart to i_PointStop do begin
    Write(outfile,i,#9,time_arr[i],#9);
    i_hide_tot := 0;
    for j := 1 to nhm do i_hide_tot := i_hide_tot + i_hide[i];
    if i_hide_tot = 0 then begin
      for j := 1 to nhm do write(outfile,df_arr[j,i],#9,dG_arr[j,i],#9);
      Writeln(outfile);
    end;
  end;
  closefile(outfile);
  i_action_PyQTM := j_Python_Time_Traces;
  B_no_Graph_in_Python := True;
  M.Write_to_QPY;
  i_fileage_old := fileage(ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Time_Traces_FitPars.txt');
  i_fileage_finished_old := fileage(ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_finished.txt');
  if M.ExecuteExe(QPY_exe_fn) then begin
    StartTick := GetTickCount;
    repeat
      i_fileage_finished_new := Fileage(ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_finished.txt');
      until (i_fileage_finished_new > i_fileage_finished_old);
      assignfile(infile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Time_Traces_FitPars.txt');
      try
        Reset(infile);
        while not eof(infile) do begin
          Read(infile,idouble); i := round(idouble);
          Read(infile,time_arr[i]);
          for j := 1 to n_fit_pars do read(infile,par_arr[i,j]);
          readln(infile,chisqr_arr[i]);
        end;
        closefile(infile);
      finally
      end;
      assignfile(infile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Time_Traces_fitted_DfDG.txt');
      try
        Reset(infile);
        while not eof(infile) do begin
          Read(infile,idouble); i := round(idouble);
          Read(infile,time_arr[i]);
          for j := 1 to nhm do read(infile,df_fit_arr[j,i],dG_fit_arr[j,i]);
          readln(infile);
        end;
        closefile(infile);
      finally
      end;
      Update_FitPars_Graph; Update_Freq_Graphs;
  end;
  assignfile(outfile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Abort.txt'); Rewrite(outfile); Writeln(outfile,0); closefile(outfile);
end;

procedure TMultiple.GenerateInfoforPython1miClick(Sender: TObject);
var i,j : integer;
begin
  B_no_Graph_in_Python := False;
  assignfile(outfile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Time_Traces.txt');
  Rewrite(outfile);
  for i := i_PointStart to i_PointStop do begin
    Write(outfile,i,#9,time_arr[i],#9);
    if i_hide[i] = 0 then begin
      for j := 1 to nhm do write(outfile,df_arr[j,i],#9,dG_arr[j,i],#9);
      Writeln(outfile);
    end;
  end;
  closefile(outfile);
  i_action_PyQTM := j_Python_Time_Traces;
  M.Write_to_QPY;
end;  

procedure TMultiple.ReadFitParsfromPython1miClick(Sender: TObject);
var idouble : Double;
    i,j : integer;
begin
  assignfile(infile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Time_Traces_FitPars.txt');
  Reset(infile);
  while not eof(infile) do begin
    Read(infile,idouble); i := round(idouble);
    Read(infile,time_arr[i]);
    for j := 1 to n_fit_pars do read(infile,par_arr[i,j]);
    readln(infile,chisqr_arr[i]);
  end;
  closefile(infile);
  assignfile(infile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_Time_Traces_fitted_DfDG.txt');
  try
    Reset(infile);
    while not eof(infile) do begin
      Read(infile,idouble); i := round(idouble);
      Read(infile,time_arr[i]);
      for j := 1 to nhm do read(infile,df_fit_arr[j,i],dG_fit_arr[j,i]);
      readln(infile);
    end;
  closefile(infile);
  finally
  end;
  Update_FitPars_Graph; Update_Freq_Graphs;
end;

procedure TMultiple.nsmoEditKeyPress(Sender: TObject; var Key: Char);
var nsmof : double;
begin
  nsmoEdit.Color := cl3dLight; if key <> #13 then Exit; if key = #27 then begin nsmoEdit.Color := clwindow; Exit; end;
  nsmof := M.FloatFromEdit(nsmoEdit,nsmo);
  nsmo := Round(nsmof);
  QTMFile.WriteFloat('Multiple', 'nsmo', nsmo); B_Changed := True;
  nsmoEdit.Text := IntToStr(nsmo);
  Smoothen; Update_Freq_Graphs;
  (Sender as TEdit).Color := clwindow;;
end;

procedure TMultiple.Smoothen;
var window_half_width,ih,i,j : integer;
    norm,avg,weight : double;
begin
  window_half_width := 2 * nsmo;
  for ih := 1 to nhm do begin
    for i := 1 to n_dat_max do begin
      df_arr[ih,i] := GapV;
      dG_arr[ih,i] := GapV;
    end;
  end;
  for ih := 1 to nhm do begin
    for i := 1 to n_dat_max do begin
      if (df_arr_raw[ih,i] <> GapV) then begin
        norm := 0; avg := 0;
        for j := i - window_half_width to i + window_half_width do begin
          if ((j > 0) and (j <= n_dat_max) and (df_arr_raw[ih,j] <> GapV)) then begin
            if nsmo > 0 then weight := exp(sqr(i-j)/(2.*sqr(nsmo)))
            else weight := 1;
            norm := norm + weight;
            avg := avg + weight * df_arr_raw[ih,j];
          end;
        end;
        if norm > 0 then
          df_arr[ih,i] := avg/norm
        else df_arr[ih,i] := GapV;
      end;
      if dG_arr_raw[ih,i] <> GapV then begin
        norm := 0; avg := 0;
        for j := i - window_half_width to i + window_half_width do begin
          if ((j > 0) and (j <= n_dat_max) and (dG_arr_raw[ih,j] <> GapV)) then begin
            if nsmo > 0 then weight := exp(sqr(i-j)/(2.*sqr(nsmo)))
            else weight := 1;
            norm := norm + weight;
            avg := avg + weight * dG_arr_raw[ih,j];
          end;
        end;
        if norm > 0 then
          dG_arr[ih,i] := avg/norm
        else dG_arr[ih,i] := GapV;
      end;
    end;
  end;
end;


end.
